/**
 * @file clapack.h
 * This file has been generated by executing $ltilib/tools/perl/getclapackh
 * It is based on the original clapack.h from http://www.netlib.org/clapack/
 * As such, this file is not part of the LTI-Lib, but included here for
 * convenience. It is copyrighted by the CLAPACK developers.
 * A documentation of the routines is contained in the book:
 * E. Anderson, Z. Bai, C. Bischof, S. Blackford, J. Demmel, J. Dongarra,
 * J. Du Croz, A. Greenbaum, S. Hammarling, A. McKenney, and D. Sorensen:
 * LAPACK Users' Guide. 3rd edition. Society for Industrial and Applied
 * Mathematics, Philadelphia, 1999. ISBN 0-89871-447-8
 *
 * The getclapackh tool included with the LTI-Lib automatically makes
 * some modifications to the original clapack.h. These are as follows:
 * - this comment is prepended to the file
 * - the file includes f2c.h that comes with the f2clib.
 * - the file includes ltiConfig.h for determining if LAPACK has to be used
 * - instead of the fixed function names, the prototypes are based on
 *   the F77_FUNC macro (which is generated by configure) for determining
 *   the mangled C-name of a FORTRAN function name.
 */

#ifndef __CLAPACK_H
#define __CLAPACK_H

#include "ltiConfig.h"
#ifdef HAVE_LAPACK

#ifdef _LTI_WIN32
/**
 * Undefine min and max macros in Windows environment to prevent
 * muliply defined symbols as Windows itself defines them in its SDK
 * and f2c.h defines them as well.
 */
  #undef min
  #undef max
#endif

#ifdef _LTI_MSC_VER
  #pragma warning(disable:4518)
/**
 * The last statement prevents two warnings in the .NET compiler
 * If somebody knows how to fix them in the code, feel free to do so.
 * clapack.h(1884) : warning C4518: 'char ': storage-class or type specifier(s) unexpected here; ignored
 * clapack.h(3581) : warning C4518: 'char ': storage-class or type specifier(s) unexpected here; ignored
 */
#endif

#include <f2c.h>

extern "C" {

#define LA_CBDSQR F77_FUNC(cbdsqr,CBDSQR)
/* Subroutine */ int LA_CBDSQR(char *uplo, integer *n, integer *ncvt, integer *
  nru, integer *ncc, real *d__, real *e, complex *vt, integer *ldvt,
  complex *u, integer *ldu, complex *c__, integer *ldc, real *rwork,
  integer *info);

#define LA_CGBBRD F77_FUNC(cgbbrd,CGBBRD)
/* Subroutine */ int LA_CGBBRD(char *vect, integer *m, integer *n, integer *ncc,
   integer *kl, integer *ku, complex *ab, integer *ldab, real *d__,
  real *e, complex *q, integer *ldq, complex *pt, integer *ldpt,
  complex *c__, integer *ldc, complex *work, real *rwork, integer *info);

#define LA_CGBCON F77_FUNC(cgbcon,CGBCON)
/* Subroutine */ int LA_CGBCON(char *norm, integer *n, integer *kl, integer *ku,
   complex *ab, integer *ldab, integer *ipiv, real *anorm, real *rcond,
  complex *work, real *rwork, integer *info);

#define LA_CGBEQU F77_FUNC(cgbequ,CGBEQU)
/* Subroutine */ int LA_CGBEQU(integer *m, integer *n, integer *kl, integer *ku,
   complex *ab, integer *ldab, real *r__, real *c__, real *rowcnd, real
  *colcnd, real *amax, integer *info);

#define LA_CGBRFS F77_FUNC(cgbrfs,CGBRFS)
/* Subroutine */ int LA_CGBRFS(char *trans, integer *n, integer *kl, integer *
  ku, integer *nrhs, complex *ab, integer *ldab, complex *afb, integer *
  ldafb, integer *ipiv, complex *b, integer *ldb, complex *x, integer *
  ldx, real *ferr, real *berr, complex *work, real *rwork, integer *
  info);

#define LA_CGBSV F77_FUNC(cgbsv,CGBSV)
/* Subroutine */ int LA_CGBSV(integer *n, integer *kl, integer *ku, integer *
  nrhs, complex *ab, integer *ldab, integer *ipiv, complex *b, integer *
  ldb, integer *info);

#define LA_CGBSVX F77_FUNC(cgbsvx,CGBSVX)
/* Subroutine */ int LA_CGBSVX(char *fact, char *trans, integer *n, integer *kl,
   integer *ku, integer *nrhs, complex *ab, integer *ldab, complex *afb,
   integer *ldafb, integer *ipiv, char *equed, real *r__, real *c__,
  complex *b, integer *ldb, complex *x, integer *ldx, real *rcond, real
  *ferr, real *berr, complex *work, real *rwork, integer *info);

#define LA_CGBTF2 F77_FUNC(cgbtf2,CGBTF2)
/* Subroutine */ int LA_CGBTF2(integer *m, integer *n, integer *kl, integer *ku,
   complex *ab, integer *ldab, integer *ipiv, integer *info);

#define LA_CGBTRF F77_FUNC(cgbtrf,CGBTRF)
/* Subroutine */ int LA_CGBTRF(integer *m, integer *n, integer *kl, integer *ku,
   complex *ab, integer *ldab, integer *ipiv, integer *info);

#define LA_CGBTRS F77_FUNC(cgbtrs,CGBTRS)
/* Subroutine */ int LA_CGBTRS(char *trans, integer *n, integer *kl, integer *
  ku, integer *nrhs, complex *ab, integer *ldab, integer *ipiv, complex
  *b, integer *ldb, integer *info);

#define LA_CGEBAK F77_FUNC(cgebak,CGEBAK)
/* Subroutine */ int LA_CGEBAK(char *job, char *side, integer *n, integer *ilo,
  integer *ihi, real *scale, integer *m, complex *v, integer *ldv,
  integer *info);

#define LA_CGEBAL F77_FUNC(cgebal,CGEBAL)
/* Subroutine */ int LA_CGEBAL(char *job, integer *n, complex *a, integer *lda,
  integer *ilo, integer *ihi, real *scale, integer *info);

#define LA_CGEBD2 F77_FUNC(cgebd2,CGEBD2)
/* Subroutine */ int LA_CGEBD2(integer *m, integer *n, complex *a, integer *lda,
   real *d__, real *e, complex *tauq, complex *taup, complex *work,
  integer *info);

#define LA_CGEBRD F77_FUNC(cgebrd,CGEBRD)
/* Subroutine */ int LA_CGEBRD(integer *m, integer *n, complex *a, integer *lda,
   real *d__, real *e, complex *tauq, complex *taup, complex *work,
  integer *lwork, integer *info);

#define LA_CGECON F77_FUNC(cgecon,CGECON)
/* Subroutine */ int LA_CGECON(char *norm, integer *n, complex *a, integer *lda,
   real *anorm, real *rcond, complex *work, real *rwork, integer *info);

#define LA_CGEEQU F77_FUNC(cgeequ,CGEEQU)
/* Subroutine */ int LA_CGEEQU(integer *m, integer *n, complex *a, integer *lda,
   real *r__, real *c__, real *rowcnd, real *colcnd, real *amax,
  integer *info);

#define LA_CGEES F77_FUNC(cgees,CGEES)
/* Subroutine */ int LA_CGEES(char *jobvs, char *sort, L_fp select, integer *n,
  complex *a, integer *lda, integer *sdim, complex *w, complex *vs,
  integer *ldvs, complex *work, integer *lwork, real *rwork, logical *
  bwork, integer *info);

#define LA_CGEESX F77_FUNC(cgeesx,CGEESX)
/* Subroutine */ int LA_CGEESX(char *jobvs, char *sort, L_fp select, char *
  sense, integer *n, complex *a, integer *lda, integer *sdim, complex *
  w, complex *vs, integer *ldvs, real *rconde, real *rcondv, complex *
  work, integer *lwork, real *rwork, logical *bwork, integer *info);

#define LA_CGEEV F77_FUNC(cgeev,CGEEV)
/* Subroutine */ int LA_CGEEV(char *jobvl, char *jobvr, integer *n, complex *a,
  integer *lda, complex *w, complex *vl, integer *ldvl, complex *vr,
  integer *ldvr, complex *work, integer *lwork, real *rwork, integer *
  info);

#define LA_CGEEVX F77_FUNC(cgeevx,CGEEVX)
/* Subroutine */ int LA_CGEEVX(char *balanc, char *jobvl, char *jobvr, char *
  sense, integer *n, complex *a, integer *lda, complex *w, complex *vl,
  integer *ldvl, complex *vr, integer *ldvr, integer *ilo, integer *ihi,
   real *scale, real *abnrm, real *rconde, real *rcondv, complex *work,
  integer *lwork, real *rwork, integer *info);

#define LA_CGEGS F77_FUNC(cgegs,CGEGS)
/* Subroutine */ int LA_CGEGS(char *jobvsl, char *jobvsr, integer *n, complex *
  a, integer *lda, complex *b, integer *ldb, complex *alpha, complex *
  beta, complex *vsl, integer *ldvsl, complex *vsr, integer *ldvsr,
  complex *work, integer *lwork, real *rwork, integer *info);

#define LA_CGEGV F77_FUNC(cgegv,CGEGV)
/* Subroutine */ int LA_CGEGV(char *jobvl, char *jobvr, integer *n, complex *a,
  integer *lda, complex *b, integer *ldb, complex *alpha, complex *beta,
   complex *vl, integer *ldvl, complex *vr, integer *ldvr, complex *
  work, integer *lwork, real *rwork, integer *info);

#define LA_CGEHD2 F77_FUNC(cgehd2,CGEHD2)
/* Subroutine */ int LA_CGEHD2(integer *n, integer *ilo, integer *ihi, complex *
  a, integer *lda, complex *tau, complex *work, integer *info);

#define LA_CGEHRD F77_FUNC(cgehrd,CGEHRD)
/* Subroutine */ int LA_CGEHRD(integer *n, integer *ilo, integer *ihi, complex *
  a, integer *lda, complex *tau, complex *work, integer *lwork, integer
  *info);

#define LA_CGELQ2 F77_FUNC(cgelq2,CGELQ2)
/* Subroutine */ int LA_CGELQ2(integer *m, integer *n, complex *a, integer *lda,
   complex *tau, complex *work, integer *info);

#define LA_CGELQF F77_FUNC(cgelqf,CGELQF)
/* Subroutine */ int LA_CGELQF(integer *m, integer *n, complex *a, integer *lda,
   complex *tau, complex *work, integer *lwork, integer *info);

#define LA_CGELS F77_FUNC(cgels,CGELS)
/* Subroutine */ int LA_CGELS(char *trans, integer *m, integer *n, integer *
  nrhs, complex *a, integer *lda, complex *b, integer *ldb, complex *
  work, integer *lwork, integer *info);

#define LA_CGELSX F77_FUNC(cgelsx,CGELSX)
/* Subroutine */ int LA_CGELSX(integer *m, integer *n, integer *nrhs, complex *
  a, integer *lda, complex *b, integer *ldb, integer *jpvt, real *rcond,
   integer *rank, complex *work, real *rwork, integer *info);

#define LA_CGELSY F77_FUNC(cgelsy,CGELSY)
/* Subroutine */ int LA_CGELSY(integer *m, integer *n, integer *nrhs, complex *
  a, integer *lda, complex *b, integer *ldb, integer *jpvt, real *rcond,
   integer *rank, complex *work, integer *lwork, real *rwork, integer *
  info);

#define LA_CGEQL2 F77_FUNC(cgeql2,CGEQL2)
/* Subroutine */ int LA_CGEQL2(integer *m, integer *n, complex *a, integer *lda,
   complex *tau, complex *work, integer *info);

#define LA_CGEQLF F77_FUNC(cgeqlf,CGEQLF)
/* Subroutine */ int LA_CGEQLF(integer *m, integer *n, complex *a, integer *lda,
   complex *tau, complex *work, integer *lwork, integer *info);

#define LA_CGEQP3 F77_FUNC(cgeqp3,CGEQP3)
/* Subroutine */ int LA_CGEQP3(integer *m, integer *n, complex *a, integer *lda,
   integer *jpvt, complex *tau, complex *work, integer *lwork, real *
  rwork, integer *info);

#define LA_CGEQPF F77_FUNC(cgeqpf,CGEQPF)
/* Subroutine */ int LA_CGEQPF(integer *m, integer *n, complex *a, integer *lda,
   integer *jpvt, complex *tau, complex *work, real *rwork, integer *
  info);

#define LA_CGEQR2 F77_FUNC(cgeqr2,CGEQR2)
/* Subroutine */ int LA_CGEQR2(integer *m, integer *n, complex *a, integer *lda,
   complex *tau, complex *work, integer *info);

#define LA_CGEQRF F77_FUNC(cgeqrf,CGEQRF)
/* Subroutine */ int LA_CGEQRF(integer *m, integer *n, complex *a, integer *lda,
   complex *tau, complex *work, integer *lwork, integer *info);

#define LA_CGERFS F77_FUNC(cgerfs,CGERFS)
/* Subroutine */ int LA_CGERFS(char *trans, integer *n, integer *nrhs, complex *
  a, integer *lda, complex *af, integer *ldaf, integer *ipiv, complex *
  b, integer *ldb, complex *x, integer *ldx, real *ferr, real *berr,
  complex *work, real *rwork, integer *info);

#define LA_CGERQ2 F77_FUNC(cgerq2,CGERQ2)
/* Subroutine */ int LA_CGERQ2(integer *m, integer *n, complex *a, integer *lda,
   complex *tau, complex *work, integer *info);

#define LA_CGERQF F77_FUNC(cgerqf,CGERQF)
/* Subroutine */ int LA_CGERQF(integer *m, integer *n, complex *a, integer *lda,
   complex *tau, complex *work, integer *lwork, integer *info);

#define LA_CGESC2 F77_FUNC(cgesc2,CGESC2)
/* Subroutine */ int LA_CGESC2(integer *n, complex *a, integer *lda, complex *
  rhs, integer *ipiv, integer *jpiv, real *scale);

#define LA_CGESV F77_FUNC(cgesv,CGESV)
/* Subroutine */ int LA_CGESV(integer *n, integer *nrhs, complex *a, integer *
  lda, integer *ipiv, complex *b, integer *ldb, integer *info);

#define LA_CGESVX F77_FUNC(cgesvx,CGESVX)
/* Subroutine */ int LA_CGESVX(char *fact, char *trans, integer *n, integer *
  nrhs, complex *a, integer *lda, complex *af, integer *ldaf, integer *
  ipiv, char *equed, real *r__, real *c__, complex *b, integer *ldb,
  complex *x, integer *ldx, real *rcond, real *ferr, real *berr,
  complex *work, real *rwork, integer *info);

#define LA_CGETC2 F77_FUNC(cgetc2,CGETC2)
/* Subroutine */ int LA_CGETC2(integer *n, complex *a, integer *lda, integer *
  ipiv, integer *jpiv, integer *info);

#define LA_CGETF2 F77_FUNC(cgetf2,CGETF2)
/* Subroutine */ int LA_CGETF2(integer *m, integer *n, complex *a, integer *lda,
   integer *ipiv, integer *info);

#define LA_CGETRF F77_FUNC(cgetrf,CGETRF)
/* Subroutine */ int LA_CGETRF(integer *m, integer *n, complex *a, integer *lda,
   integer *ipiv, integer *info);

#define LA_CGETRI F77_FUNC(cgetri,CGETRI)
/* Subroutine */ int LA_CGETRI(integer *n, complex *a, integer *lda, integer *
  ipiv, complex *work, integer *lwork, integer *info);

#define LA_CGETRS F77_FUNC(cgetrs,CGETRS)
/* Subroutine */ int LA_CGETRS(char *trans, integer *n, integer *nrhs, complex *
  a, integer *lda, integer *ipiv, complex *b, integer *ldb, integer *
  info);

#define LA_CGGBAK F77_FUNC(cggbak,CGGBAK)
/* Subroutine */ int LA_CGGBAK(char *job, char *side, integer *n, integer *ilo,
  integer *ihi, real *lscale, real *rscale, integer *m, complex *v,
  integer *ldv, integer *info);

#define LA_CGGBAL F77_FUNC(cggbal,CGGBAL)
/* Subroutine */ int LA_CGGBAL(char *job, integer *n, complex *a, integer *lda,
  complex *b, integer *ldb, integer *ilo, integer *ihi, real *lscale,
  real *rscale, real *work, integer *info);

#define LA_CGGES F77_FUNC(cgges,CGGES)
/* Subroutine */ int LA_CGGES(char *jobvsl, char *jobvsr, char *sort, L_fp
  selctg, integer *n, complex *a, integer *lda, complex *b, integer *
  ldb, integer *sdim, complex *alpha, complex *beta, complex *vsl,
  integer *ldvsl, complex *vsr, integer *ldvsr, complex *work, integer *
  lwork, real *rwork, logical *bwork, integer *info);

#define LA_CGGESX F77_FUNC(cggesx,CGGESX)
/* Subroutine */ int LA_CGGESX(char *jobvsl, char *jobvsr, char *sort, L_fp
  selctg, char *sense, integer *n, complex *a, integer *lda, complex *b,
   integer *ldb, integer *sdim, complex *alpha, complex *beta, complex *
  vsl, integer *ldvsl, complex *vsr, integer *ldvsr, real *rconde, real
  *rcondv, complex *work, integer *lwork, real *rwork, integer *iwork,
  integer *liwork, logical *bwork, integer *info);

#define LA_CGGEV F77_FUNC(cggev,CGGEV)
/* Subroutine */ int LA_CGGEV(char *jobvl, char *jobvr, integer *n, complex *a,
  integer *lda, complex *b, integer *ldb, complex *alpha, complex *beta,
   complex *vl, integer *ldvl, complex *vr, integer *ldvr, complex *
  work, integer *lwork, real *rwork, integer *info);

#define LA_CGGEVX F77_FUNC(cggevx,CGGEVX)
/* Subroutine */ int LA_CGGEVX(char *balanc, char *jobvl, char *jobvr, char *
  sense, integer *n, complex *a, integer *lda, complex *b, integer *ldb,
   complex *alpha, complex *beta, complex *vl, integer *ldvl, complex *
  vr, integer *ldvr, integer *ilo, integer *ihi, real *lscale, real *
  rscale, real *abnrm, real *bbnrm, real *rconde, real *rcondv, complex
  *work, integer *lwork, real *rwork, integer *iwork, logical *bwork,
  integer *info);

#define LA_CGGGLM F77_FUNC(cggglm,CGGGLM)
/* Subroutine */ int LA_CGGGLM(integer *n, integer *m, integer *p, complex *a,
  integer *lda, complex *b, integer *ldb, complex *d__, complex *x,
  complex *y, complex *work, integer *lwork, integer *info);

#define LA_CGGHRD F77_FUNC(cgghrd,CGGHRD)
/* Subroutine */ int LA_CGGHRD(char *compq, char *compz, integer *n, integer *
  ilo, integer *ihi, complex *a, integer *lda, complex *b, integer *ldb,
   complex *q, integer *ldq, complex *z__, integer *ldz, integer *info);

#define LA_CGGLSE F77_FUNC(cgglse,CGGLSE)
/* Subroutine */ int LA_CGGLSE(integer *m, integer *n, integer *p, complex *a,
  integer *lda, complex *b, integer *ldb, complex *c__, complex *d__,
  complex *x, complex *work, integer *lwork, integer *info);

#define LA_CGGQRF F77_FUNC(cggqrf,CGGQRF)
/* Subroutine */ int LA_CGGQRF(integer *n, integer *m, integer *p, complex *a,
  integer *lda, complex *taua, complex *b, integer *ldb, complex *taub,
  complex *work, integer *lwork, integer *info);

#define LA_CGGRQF F77_FUNC(cggrqf,CGGRQF)
/* Subroutine */ int LA_CGGRQF(integer *m, integer *p, integer *n, complex *a,
  integer *lda, complex *taua, complex *b, integer *ldb, complex *taub,
  complex *work, integer *lwork, integer *info);

#define LA_CGGSVD F77_FUNC(cggsvd,CGGSVD)
/* Subroutine */ int LA_CGGSVD(char *jobu, char *jobv, char *jobq, integer *m,
  integer *n, integer *p, integer *k, integer *l, complex *a, integer *
  lda, complex *b, integer *ldb, real *alpha, real *beta, complex *u,
  integer *ldu, complex *v, integer *ldv, complex *q, integer *ldq,
  complex *work, real *rwork, integer *iwork, integer *info);

#define LA_CGGSVP F77_FUNC(cggsvp,CGGSVP)
/* Subroutine */ int LA_CGGSVP(char *jobu, char *jobv, char *jobq, integer *m,
  integer *p, integer *n, complex *a, integer *lda, complex *b, integer
  *ldb, real *tola, real *tolb, integer *k, integer *l, complex *u,
  integer *ldu, complex *v, integer *ldv, complex *q, integer *ldq,
  integer *iwork, real *rwork, complex *tau, complex *work, integer *
  info);

#define LA_CGTCON F77_FUNC(cgtcon,CGTCON)
/* Subroutine */ int LA_CGTCON(char *norm, integer *n, complex *dl, complex *
  d__, complex *du, complex *du2, integer *ipiv, real *anorm, real *
  rcond, complex *work, integer *info);

#define LA_CGTRFS F77_FUNC(cgtrfs,CGTRFS)
/* Subroutine */ int LA_CGTRFS(char *trans, integer *n, integer *nrhs, complex *
  dl, complex *d__, complex *du, complex *dlf, complex *df, complex *
  duf, complex *du2, integer *ipiv, complex *b, integer *ldb, complex *
  x, integer *ldx, real *ferr, real *berr, complex *work, real *rwork,
  integer *info);

#define LA_CGTSV F77_FUNC(cgtsv,CGTSV)
/* Subroutine */ int LA_CGTSV(integer *n, integer *nrhs, complex *dl, complex *
  d__, complex *du, complex *b, integer *ldb, integer *info);

#define LA_CGTSVX F77_FUNC(cgtsvx,CGTSVX)
/* Subroutine */ int LA_CGTSVX(char *fact, char *trans, integer *n, integer *
  nrhs, complex *dl, complex *d__, complex *du, complex *dlf, complex *
  df, complex *duf, complex *du2, integer *ipiv, complex *b, integer *
  ldb, complex *x, integer *ldx, real *rcond, real *ferr, real *berr,
  complex *work, real *rwork, integer *info);

#define LA_CGTTRF F77_FUNC(cgttrf,CGTTRF)
/* Subroutine */ int LA_CGTTRF(integer *n, complex *dl, complex *d__, complex *
  du, complex *du2, integer *ipiv, integer *info);

#define LA_CGTTRS F77_FUNC(cgttrs,CGTTRS)
/* Subroutine */ int LA_CGTTRS(char *trans, integer *n, integer *nrhs, complex *
  dl, complex *d__, complex *du, complex *du2, integer *ipiv, complex *
  b, integer *ldb, integer *info);

#define LA_CGTTS2 F77_FUNC(cgtts2,CGTTS2)
/* Subroutine */ int LA_CGTTS2(integer *itrans, integer *n, integer *nrhs,
  complex *dl, complex *d__, complex *du, complex *du2, integer *ipiv,
  complex *b, integer *ldb);

#define LA_CHBEV F77_FUNC(chbev,CHBEV)
/* Subroutine */ int LA_CHBEV(char *jobz, char *uplo, integer *n, integer *kd,
  complex *ab, integer *ldab, real *w, complex *z__, integer *ldz,
  complex *work, real *rwork, integer *info);

#define LA_CHBEVD F77_FUNC(chbevd,CHBEVD)
/* Subroutine */ int LA_CHBEVD(char *jobz, char *uplo, integer *n, integer *kd,
  complex *ab, integer *ldab, real *w, complex *z__, integer *ldz,
  complex *work, integer *lwork, real *rwork, integer *lrwork, integer *
  iwork, integer *liwork, integer *info);

#define LA_CHBEVX F77_FUNC(chbevx,CHBEVX)
/* Subroutine */ int LA_CHBEVX(char *jobz, char *range, char *uplo, integer *n,
  integer *kd, complex *ab, integer *ldab, complex *q, integer *ldq,
  real *vl, real *vu, integer *il, integer *iu, real *abstol, integer *
  m, real *w, complex *z__, integer *ldz, complex *work, real *rwork,
  integer *iwork, integer *ifail, integer *info);

#define LA_CHBGST F77_FUNC(chbgst,CHBGST)
/* Subroutine */ int LA_CHBGST(char *vect, char *uplo, integer *n, integer *ka,
  integer *kb, complex *ab, integer *ldab, complex *bb, integer *ldbb,
  complex *x, integer *ldx, complex *work, real *rwork, integer *info);

#define LA_CHBGV F77_FUNC(chbgv,CHBGV)
/* Subroutine */ int LA_CHBGV(char *jobz, char *uplo, integer *n, integer *ka,
  integer *kb, complex *ab, integer *ldab, complex *bb, integer *ldbb,
  real *w, complex *z__, integer *ldz, complex *work, real *rwork,
  integer *info);

#define LA_CHBGVX F77_FUNC(chbgvx,CHBGVX)
/* Subroutine */ int LA_CHBGVX(char *jobz, char *range, char *uplo, integer *n,
  integer *ka, integer *kb, complex *ab, integer *ldab, complex *bb,
  integer *ldbb, complex *q, integer *ldq, real *vl, real *vu, integer *
  il, integer *iu, real *abstol, integer *m, real *w, complex *z__,
  integer *ldz, complex *work, real *rwork, integer *iwork, integer *
  ifail, integer *info);

#define LA_CHBTRD F77_FUNC(chbtrd,CHBTRD)
/* Subroutine */ int LA_CHBTRD(char *vect, char *uplo, integer *n, integer *kd,
  complex *ab, integer *ldab, real *d__, real *e, complex *q, integer *
  ldq, complex *work, integer *info);

#define LA_CHECON F77_FUNC(checon,CHECON)
/* Subroutine */ int LA_CHECON(char *uplo, integer *n, complex *a, integer *lda,
   integer *ipiv, real *anorm, real *rcond, complex *work, integer *
  info);

#define LA_CHEEV F77_FUNC(cheev,CHEEV)
/* Subroutine */ int LA_CHEEV(char *jobz, char *uplo, integer *n, complex *a,
  integer *lda, real *w, complex *work, integer *lwork, real *rwork,
  integer *info);

#define LA_CHEEVD F77_FUNC(cheevd,CHEEVD)
/* Subroutine */ int LA_CHEEVD(char *jobz, char *uplo, integer *n, complex *a,
  integer *lda, real *w, complex *work, integer *lwork, real *rwork,
  integer *lrwork, integer *iwork, integer *liwork, integer *info);

#define LA_CHEEVR F77_FUNC(cheevr,CHEEVR)
/* Subroutine */ int LA_CHEEVR(char *jobz, char *range, char *uplo, integer *n,
  complex *a, integer *lda, real *vl, real *vu, integer *il, integer *
  iu, real *abstol, integer *m, real *w, complex *z__, integer *ldz,
  integer *isuppz, complex *work, integer *lwork, real *rwork, integer *
  lrwork, integer *iwork, integer *liwork, integer *info);

#define LA_CHEEVX F77_FUNC(cheevx,CHEEVX)
/* Subroutine */ int LA_CHEEVX(char *jobz, char *range, char *uplo, integer *n,
  complex *a, integer *lda, real *vl, real *vu, integer *il, integer *
  iu, real *abstol, integer *m, real *w, complex *z__, integer *ldz,
  complex *work, integer *lwork, real *rwork, integer *iwork, integer *
  ifail, integer *info);

#define LA_CHEGS2 F77_FUNC(chegs2,CHEGS2)
/* Subroutine */ int LA_CHEGS2(integer *itype, char *uplo, integer *n, complex *
  a, integer *lda, complex *b, integer *ldb, integer *info);

#define LA_CHEGST F77_FUNC(chegst,CHEGST)
/* Subroutine */ int LA_CHEGST(integer *itype, char *uplo, integer *n, complex *
  a, integer *lda, complex *b, integer *ldb, integer *info);

#define LA_CHEGV F77_FUNC(chegv,CHEGV)
/* Subroutine */ int LA_CHEGV(integer *itype, char *jobz, char *uplo, integer *
  n, complex *a, integer *lda, complex *b, integer *ldb, real *w,
  complex *work, integer *lwork, real *rwork, integer *info);

#define LA_CHEGVD F77_FUNC(chegvd,CHEGVD)
/* Subroutine */ int LA_CHEGVD(integer *itype, char *jobz, char *uplo, integer *
  n, complex *a, integer *lda, complex *b, integer *ldb, real *w,
  complex *work, integer *lwork, real *rwork, integer *lrwork, integer *
  iwork, integer *liwork, integer *info);

#define LA_CHEGVX F77_FUNC(chegvx,CHEGVX)
/* Subroutine */ int LA_CHEGVX(integer *itype, char *jobz, char *range, char *
  uplo, integer *n, complex *a, integer *lda, complex *b, integer *ldb,
  real *vl, real *vu, integer *il, integer *iu, real *abstol, integer *
  m, real *w, complex *z__, integer *ldz, complex *work, integer *lwork,
   real *rwork, integer *iwork, integer *ifail, integer *info);

#define LA_CHERFS F77_FUNC(cherfs,CHERFS)
/* Subroutine */ int LA_CHERFS(char *uplo, integer *n, integer *nrhs, complex *
  a, integer *lda, complex *af, integer *ldaf, integer *ipiv, complex *
  b, integer *ldb, complex *x, integer *ldx, real *ferr, real *berr,
  complex *work, real *rwork, integer *info);

#define LA_CHESV F77_FUNC(chesv,CHESV)
/* Subroutine */ int LA_CHESV(char *uplo, integer *n, integer *nrhs, complex *a,
   integer *lda, integer *ipiv, complex *b, integer *ldb, complex *work,
   integer *lwork, integer *info);

#define LA_CHESVX F77_FUNC(chesvx,CHESVX)
/* Subroutine */ int LA_CHESVX(char *fact, char *uplo, integer *n, integer *
  nrhs, complex *a, integer *lda, complex *af, integer *ldaf, integer *
  ipiv, complex *b, integer *ldb, complex *x, integer *ldx, real *rcond,
   real *ferr, real *berr, complex *work, integer *lwork, real *rwork,
  integer *info);

#define LA_CHETF2 F77_FUNC(chetf2,CHETF2)
/* Subroutine */ int LA_CHETF2(char *uplo, integer *n, complex *a, integer *lda,
   integer *ipiv, integer *info);

#define LA_CHETRD F77_FUNC(chetrd,CHETRD)
/* Subroutine */ int LA_CHETRD(char *uplo, integer *n, complex *a, integer *lda,
   real *d__, real *e, complex *tau, complex *work, integer *lwork,
  integer *info);

#define LA_CHETRF F77_FUNC(chetrf,CHETRF)
/* Subroutine */ int LA_CHETRF(char *uplo, integer *n, complex *a, integer *lda,
   integer *ipiv, complex *work, integer *lwork, integer *info);

#define LA_CHETRI F77_FUNC(chetri,CHETRI)
/* Subroutine */ int LA_CHETRI(char *uplo, integer *n, complex *a, integer *lda,
   integer *ipiv, complex *work, integer *info);

#define LA_CHETRS F77_FUNC(chetrs,CHETRS)
/* Subroutine */ int LA_CHETRS(char *uplo, integer *n, integer *nrhs, complex *
  a, integer *lda, integer *ipiv, complex *b, integer *ldb, integer *
  info);

#define LA_CHGEQZ F77_FUNC(chgeqz,CHGEQZ)
/* Subroutine */ int LA_CHGEQZ(char *job, char *compq, char *compz, integer *n,
  integer *ilo, integer *ihi, complex *a, integer *lda, complex *b,
  integer *ldb, complex *alpha, complex *beta, complex *q, integer *ldq,
   complex *z__, integer *ldz, complex *work, integer *lwork, real *
  rwork, integer *info);

#define LA_CHPCON F77_FUNC(chpcon,CHPCON)
/* Subroutine */ int LA_CHPCON(char *uplo, integer *n, complex *ap, integer *
  ipiv, real *anorm, real *rcond, complex *work, integer *info);

#define LA_CHPEV F77_FUNC(chpev,CHPEV)
/* Subroutine */ int LA_CHPEV(char *jobz, char *uplo, integer *n, complex *ap,
  real *w, complex *z__, integer *ldz, complex *work, real *rwork,
  integer *info);

#define LA_CHPEVD F77_FUNC(chpevd,CHPEVD)
/* Subroutine */ int LA_CHPEVD(char *jobz, char *uplo, integer *n, complex *ap,
  real *w, complex *z__, integer *ldz, complex *work, integer *lwork,
  real *rwork, integer *lrwork, integer *iwork, integer *liwork,
  integer *info);

#define LA_CHPEVX F77_FUNC(chpevx,CHPEVX)
/* Subroutine */ int LA_CHPEVX(char *jobz, char *range, char *uplo, integer *n,
  complex *ap, real *vl, real *vu, integer *il, integer *iu, real *
  abstol, integer *m, real *w, complex *z__, integer *ldz, complex *
  work, real *rwork, integer *iwork, integer *ifail, integer *info);

#define LA_CHPGST F77_FUNC(chpgst,CHPGST)
/* Subroutine */ int LA_CHPGST(integer *itype, char *uplo, integer *n, complex *
  ap, complex *bp, integer *info);

#define LA_CHPGV F77_FUNC(chpgv,CHPGV)
/* Subroutine */ int LA_CHPGV(integer *itype, char *jobz, char *uplo, integer *
  n, complex *ap, complex *bp, real *w, complex *z__, integer *ldz,
  complex *work, real *rwork, integer *info);

#define LA_CHPGVD F77_FUNC(chpgvd,CHPGVD)
/* Subroutine */ int LA_CHPGVD(integer *itype, char *jobz, char *uplo, integer *
  n, complex *ap, complex *bp, real *w, complex *z__, integer *ldz,
  complex *work, integer *lwork, real *rwork, integer *lrwork, integer *
  iwork, integer *liwork, integer *info);

#define LA_CHPGVX F77_FUNC(chpgvx,CHPGVX)
/* Subroutine */ int LA_CHPGVX(integer *itype, char *jobz, char *range, char *
  uplo, integer *n, complex *ap, complex *bp, real *vl, real *vu,
  integer *il, integer *iu, real *abstol, integer *m, real *w, complex *
  z__, integer *ldz, complex *work, real *rwork, integer *iwork,
  integer *ifail, integer *info);

#define LA_CHPRFS F77_FUNC(chprfs,CHPRFS)
/* Subroutine */ int LA_CHPRFS(char *uplo, integer *n, integer *nrhs, complex *
  ap, complex *afp, integer *ipiv, complex *b, integer *ldb, complex *x,
   integer *ldx, real *ferr, real *berr, complex *work, real *rwork,
  integer *info);

#define LA_CHPSV F77_FUNC(chpsv,CHPSV)
/* Subroutine */ int LA_CHPSV(char *uplo, integer *n, integer *nrhs, complex *
  ap, integer *ipiv, complex *b, integer *ldb, integer *info);

#define LA_CHPSVX F77_FUNC(chpsvx,CHPSVX)
/* Subroutine */ int LA_CHPSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, complex *ap, complex *afp, integer *ipiv, complex *b, integer *
  ldb, complex *x, integer *ldx, real *rcond, real *ferr, real *berr,
  complex *work, real *rwork, integer *info);

#define LA_CHPTRD F77_FUNC(chptrd,CHPTRD)
/* Subroutine */ int LA_CHPTRD(char *uplo, integer *n, complex *ap, real *d__,
  real *e, complex *tau, integer *info);

#define LA_CHPTRF F77_FUNC(chptrf,CHPTRF)
/* Subroutine */ int LA_CHPTRF(char *uplo, integer *n, complex *ap, integer *
  ipiv, integer *info);

#define LA_CHPTRI F77_FUNC(chptri,CHPTRI)
/* Subroutine */ int LA_CHPTRI(char *uplo, integer *n, complex *ap, integer *
  ipiv, complex *work, integer *info);

#define LA_CHPTRS F77_FUNC(chptrs,CHPTRS)
/* Subroutine */ int LA_CHPTRS(char *uplo, integer *n, integer *nrhs, complex *
  ap, integer *ipiv, complex *b, integer *ldb, integer *info);

#define LA_CHSEIN F77_FUNC(chsein,CHSEIN)
/* Subroutine */ int LA_CHSEIN(char *side, char *eigsrc, char *initv, logical *
  select, integer *n, complex *h__, integer *ldh, complex *w, complex *
  vl, integer *ldvl, complex *vr, integer *ldvr, integer *mm, integer *
  m, complex *work, real *rwork, integer *ifaill, integer *ifailr,
  integer *info);

#define LA_CHSEQR F77_FUNC(chseqr,CHSEQR)
/* Subroutine */ int LA_CHSEQR(char *job, char *compz, integer *n, integer *ilo,
   integer *ihi, complex *h__, integer *ldh, complex *w, complex *z__,
  integer *ldz, complex *work, integer *lwork, integer *info);

#define LA_CLABRD F77_FUNC(clabrd,CLABRD)
/* Subroutine */ int LA_CLABRD(integer *m, integer *n, integer *nb, complex *a,
  integer *lda, real *d__, real *e, complex *tauq, complex *taup,
  complex *x, integer *ldx, complex *y, integer *ldy);

#define LA_CLACGV F77_FUNC(clacgv,CLACGV)
/* Subroutine */ int LA_CLACGV(integer *n, complex *x, integer *incx);

#define LA_CLACON F77_FUNC(clacon,CLACON)
/* Subroutine */ int LA_CLACON(integer *n, complex *v, complex *x, real *est,
  integer *kase);

#define LA_CLACP2 F77_FUNC(clacp2,CLACP2)
/* Subroutine */ int LA_CLACP2(char *uplo, integer *m, integer *n, real *a,
  integer *lda, complex *b, integer *ldb);

#define LA_CLACPY F77_FUNC(clacpy,CLACPY)
/* Subroutine */ int LA_CLACPY(char *uplo, integer *m, integer *n, complex *a,
  integer *lda, complex *b, integer *ldb);

#define LA_CLACRM F77_FUNC(clacrm,CLACRM)
/* Subroutine */ int LA_CLACRM(integer *m, integer *n, complex *a, integer *lda,
   real *b, integer *ldb, complex *c__, integer *ldc, real *rwork);

#define LA_CLACRT F77_FUNC(clacrt,CLACRT)
/* Subroutine */ int LA_CLACRT(integer *n, complex *cx, integer *incx, complex *
  cy, integer *incy, complex *c__, complex *s);

#define LA_CLAED0 F77_FUNC(claed0,CLAED0)
/* Subroutine */ int LA_CLAED0(integer *qsiz, integer *n, real *d__, real *e,
  complex *q, integer *ldq, complex *qstore, integer *ldqs, real *rwork,
   integer *iwork, integer *info);

#define LA_CLAED7 F77_FUNC(claed7,CLAED7)
/* Subroutine */ int LA_CLAED7(integer *n, integer *cutpnt, integer *qsiz,
  integer *tlvls, integer *curlvl, integer *curpbm, real *d__, complex *
  q, integer *ldq, real *rho, integer *indxq, real *qstore, integer *
  qptr, integer *prmptr, integer *perm, integer *givptr, integer *
  givcol, real *givnum, complex *work, real *rwork, integer *iwork,
  integer *info);

#define LA_CLAED8 F77_FUNC(claed8,CLAED8)
/* Subroutine */ int LA_CLAED8(integer *k, integer *n, integer *qsiz, complex *
  q, integer *ldq, real *d__, real *rho, integer *cutpnt, real *z__,
  real *dlamda, complex *q2, integer *ldq2, real *w, integer *indxp,
  integer *indx, integer *indxq, integer *perm, integer *givptr,
  integer *givcol, real *givnum, integer *info);

#define LA_CLAEIN F77_FUNC(claein,CLAEIN)
/* Subroutine */ int LA_CLAEIN(logical *rightv, logical *noinit, integer *n,
  complex *h__, integer *ldh, complex *w, complex *v, complex *b,
  integer *ldb, real *rwork, real *eps3, real *smlnum, integer *info);

#define LA_CLAESY F77_FUNC(claesy,CLAESY)
/* Subroutine */ int LA_CLAESY(complex *a, complex *b, complex *c__, complex *
  rt1, complex *rt2, complex *evscal, complex *cs1, complex *sn1);

#define LA_CLAEV2 F77_FUNC(claev2,CLAEV2)
/* Subroutine */ int LA_CLAEV2(complex *a, complex *b, complex *c__, real *rt1,
  real *rt2, real *cs1, complex *sn1);

#define LA_CLAGS2 F77_FUNC(clags2,CLAGS2)
/* Subroutine */ int LA_CLAGS2(logical *upper, real *a1, complex *a2, real *a3,
  real *b1, complex *b2, real *b3, real *csu, complex *snu, real *csv,
  complex *snv, real *csq, complex *snq);

#define LA_CLAGTM F77_FUNC(clagtm,CLAGTM)
/* Subroutine */ int LA_CLAGTM(char *trans, integer *n, integer *nrhs, real *
  alpha, complex *dl, complex *d__, complex *du, complex *x, integer *
  ldx, real *beta, complex *b, integer *ldb);

#define LA_CLAHEF F77_FUNC(clahef,CLAHEF)
/* Subroutine */ int LA_CLAHEF(char *uplo, integer *n, integer *nb, integer *kb,
   complex *a, integer *lda, integer *ipiv, complex *w, integer *ldw,
  integer *info);

#define LA_CLAHQR F77_FUNC(clahqr,CLAHQR)
/* Subroutine */ int LA_CLAHQR(logical *wantt, logical *wantz, integer *n,
  integer *ilo, integer *ihi, complex *h__, integer *ldh, complex *w,
  integer *iloz, integer *ihiz, complex *z__, integer *ldz, integer *
  info);

#define LA_CLAHRD F77_FUNC(clahrd,CLAHRD)
/* Subroutine */ int LA_CLAHRD(integer *n, integer *k, integer *nb, complex *a,
  integer *lda, complex *tau, complex *t, integer *ldt, complex *y,
  integer *ldy);

#define LA_CLAIC1 F77_FUNC(claic1,CLAIC1)
/* Subroutine */ int LA_CLAIC1(integer *job, integer *j, complex *x, real *sest,
   complex *w, complex *gamma, real *sestpr, complex *s, complex *c__);

#define LA_CLALS0 F77_FUNC(clals0,CLALS0)
/* Subroutine */ int LA_CLALS0(integer *icompq, integer *nl, integer *nr,
  integer *sqre, integer *nrhs, complex *b, integer *ldb, complex *bx,
  integer *ldbx, integer *perm, integer *givptr, integer *givcol,
  integer *ldgcol, real *givnum, integer *ldgnum, real *poles, real *
  difl, real *difr, real *z__, integer *k, real *c__, real *s, real *
  rwork, integer *info);

#define LA_CLALSA F77_FUNC(clalsa,CLALSA)
/* Subroutine */ int LA_CLALSA(integer *icompq, integer *smlsiz, integer *n,
  integer *nrhs, complex *b, integer *ldb, complex *bx, integer *ldbx,
  real *u, integer *ldu, real *vt, integer *k, real *difl, real *difr,
  real *z__, real *poles, integer *givptr, integer *givcol, integer *
  ldgcol, integer *perm, real *givnum, real *c__, real *s, real *rwork,
  integer *iwork, integer *info);

#define LA_CLAPLL F77_FUNC(clapll,CLAPLL)
/* Subroutine */ int LA_CLAPLL(integer *n, complex *x, integer *incx, complex *
  y, integer *incy, real *ssmin);

#define LA_CLAPMT F77_FUNC(clapmt,CLAPMT)
/* Subroutine */ int LA_CLAPMT(logical *forwrd, integer *m, integer *n, complex
  *x, integer *ldx, integer *k);

#define LA_CLAQGB F77_FUNC(claqgb,CLAQGB)
/* Subroutine */ int LA_CLAQGB(integer *m, integer *n, integer *kl, integer *ku,
   complex *ab, integer *ldab, real *r__, real *c__, real *rowcnd, real
  *colcnd, real *amax, char *equed);

#define LA_CLAQGE F77_FUNC(claqge,CLAQGE)
/* Subroutine */ int LA_CLAQGE(integer *m, integer *n, complex *a, integer *lda,
   real *r__, real *c__, real *rowcnd, real *colcnd, real *amax, char *
  equed);

#define LA_CLAQHB F77_FUNC(claqhb,CLAQHB)
/* Subroutine */ int LA_CLAQHB(char *uplo, integer *n, integer *kd, complex *ab,
   integer *ldab, real *s, real *scond, real *amax, char *equed);

#define LA_CLAQHE F77_FUNC(claqhe,CLAQHE)
/* Subroutine */ int LA_CLAQHE(char *uplo, integer *n, complex *a, integer *lda,
   real *s, real *scond, real *amax, char *equed);

#define LA_CLAQHP F77_FUNC(claqhp,CLAQHP)
/* Subroutine */ int LA_CLAQHP(char *uplo, integer *n, complex *ap, real *s,
  real *scond, real *amax, char *equed);

#define LA_CLAQP2 F77_FUNC(claqp2,CLAQP2)
/* Subroutine */ int LA_CLAQP2(integer *m, integer *n, integer *offset, complex
  *a, integer *lda, integer *jpvt, complex *tau, real *vn1, real *vn2,
  complex *work);

#define LA_CLAQPS F77_FUNC(claqps,CLAQPS)
/* Subroutine */ int LA_CLAQPS(integer *m, integer *n, integer *offset, integer
  *nb, integer *kb, complex *a, integer *lda, integer *jpvt, complex *
  tau, real *vn1, real *vn2, complex *auxv, complex *f, integer *ldf);

#define LA_CLAQSB F77_FUNC(claqsb,CLAQSB)
/* Subroutine */ int LA_CLAQSB(char *uplo, integer *n, integer *kd, complex *ab,
   integer *ldab, real *s, real *scond, real *amax, char *equed);

#define LA_CLAQSP F77_FUNC(claqsp,CLAQSP)
/* Subroutine */ int LA_CLAQSP(char *uplo, integer *n, complex *ap, real *s,
  real *scond, real *amax, char *equed);

#define LA_CLAQSY F77_FUNC(claqsy,CLAQSY)
/* Subroutine */ int LA_CLAQSY(char *uplo, integer *n, complex *a, integer *lda,
   real *s, real *scond, real *amax, char *equed);

#define LA_CLAR1V F77_FUNC(clar1v,CLAR1V)
/* Subroutine */ int LA_CLAR1V(integer *n, integer *b1, integer *bn, real *
  sigma, real *d__, real *l, real *ld, real *lld, real *gersch, complex
  *z__, real *ztz, real *mingma, integer *r__, integer *isuppz, real *
  work);

#define LA_CLAR2V F77_FUNC(clar2v,CLAR2V)
/* Subroutine */ int LA_CLAR2V(integer *n, complex *x, complex *y, complex *z__,
   integer *incx, real *c__, complex *s, integer *incc);

#define LA_CLARCM F77_FUNC(clarcm,CLARCM)
/* Subroutine */ int LA_CLARCM(integer *m, integer *n, real *a, integer *lda,
  complex *b, integer *ldb, complex *c__, integer *ldc, real *rwork);

#define LA_CLARF F77_FUNC(clarf,CLARF)
/* Subroutine */ int LA_CLARF(char *side, integer *m, integer *n, complex *v,
  integer *incv, complex *tau, complex *c__, integer *ldc, complex *
  work);

#define LA_CLARFB F77_FUNC(clarfb,CLARFB)
/* Subroutine */ int LA_CLARFB(char *side, char *trans, char *direct, char *
  storev, integer *m, integer *n, integer *k, complex *v, integer *ldv,
  complex *t, integer *ldt, complex *c__, integer *ldc, complex *work,
  integer *ldwork);

#define LA_CLARFG F77_FUNC(clarfg,CLARFG)
/* Subroutine */ int LA_CLARFG(integer *n, complex *alpha, complex *x, integer *
  incx, complex *tau);

#define LA_CLARFT F77_FUNC(clarft,CLARFT)
/* Subroutine */ int LA_CLARFT(char *direct, char *storev, integer *n, integer *
  k, complex *v, integer *ldv, complex *tau, complex *t, integer *ldt);

#define LA_CLARFX F77_FUNC(clarfx,CLARFX)
/* Subroutine */ int LA_CLARFX(char *side, integer *m, integer *n, complex *v,
  complex *tau, complex *c__, integer *ldc, complex *work);

#define LA_CLARGV F77_FUNC(clargv,CLARGV)
/* Subroutine */ int LA_CLARGV(integer *n, complex *x, integer *incx, complex *
  y, integer *incy, real *c__, integer *incc);

#define LA_CLARNV F77_FUNC(clarnv,CLARNV)
/* Subroutine */ int LA_CLARNV(integer *idist, integer *iseed, integer *n,
  complex *x);

#define LA_CLARRV F77_FUNC(clarrv,CLARRV)
/* Subroutine */ int LA_CLARRV(integer *n, real *d__, real *l, integer *isplit,
  integer *m, real *w, integer *iblock, real *gersch, real *tol,
  complex *z__, integer *ldz, integer *isuppz, real *work, integer *
  iwork, integer *info);

#define LA_CLARTG F77_FUNC(clartg,CLARTG)
/* Subroutine */ int LA_CLARTG(complex *f, complex *g, real *cs, complex *sn,
  complex *r__);

#define LA_CLARTV F77_FUNC(clartv,CLARTV)
/* Subroutine */ int LA_CLARTV(integer *n, complex *x, integer *incx, complex *
  y, integer *incy, real *c__, complex *s, integer *incc);

#define LA_CLARZ F77_FUNC(clarz,CLARZ)
/* Subroutine */ int LA_CLARZ(char *side, integer *m, integer *n, integer *l,
  complex *v, integer *incv, complex *tau, complex *c__, integer *ldc,
  complex *work);

#define LA_CLARZB F77_FUNC(clarzb,CLARZB)
/* Subroutine */ int LA_CLARZB(char *side, char *trans, char *direct, char *
  storev, integer *m, integer *n, integer *k, integer *l, complex *v,
  integer *ldv, complex *t, integer *ldt, complex *c__, integer *ldc,
  complex *work, integer *ldwork);

#define LA_CLARZT F77_FUNC(clarzt,CLARZT)
/* Subroutine */ int LA_CLARZT(char *direct, char *storev, integer *n, integer *
  k, complex *v, integer *ldv, complex *tau, complex *t, integer *ldt);

#define LA_CLASCL F77_FUNC(clascl,CLASCL)
/* Subroutine */ int LA_CLASCL(char *type__, integer *kl, integer *ku, real *
  cfrom, real *cto, integer *m, integer *n, complex *a, integer *lda,
  integer *info);

#define LA_CLASET F77_FUNC(claset,CLASET)
/* Subroutine */ int LA_CLASET(char *uplo, integer *m, integer *n, complex *
  alpha, complex *beta, complex *a, integer *lda);

#define LA_CLASR F77_FUNC(clasr,CLASR)
/* Subroutine */ int LA_CLASR(char *side, char *pivot, char *direct, integer *m,
   integer *n, real *c__, real *s, complex *a, integer *lda);

#define LA_CLASSQ F77_FUNC(classq,CLASSQ)
/* Subroutine */ int LA_CLASSQ(integer *n, complex *x, integer *incx, real *
  scale, real *sumsq);

#define LA_CLASWP F77_FUNC(claswp,CLASWP)
/* Subroutine */ int LA_CLASWP(integer *n, complex *a, integer *lda, integer *
  k1, integer *k2, integer *ipiv, integer *incx);

#define LA_CLASYF F77_FUNC(clasyf,CLASYF)
/* Subroutine */ int LA_CLASYF(char *uplo, integer *n, integer *nb, integer *kb,
   complex *a, integer *lda, integer *ipiv, complex *w, integer *ldw,
  integer *info);

#define LA_CLATBS F77_FUNC(clatbs,CLATBS)
/* Subroutine */ int LA_CLATBS(char *uplo, char *trans, char *diag, char *
  normin, integer *n, integer *kd, complex *ab, integer *ldab, complex *
  x, real *scale, real *cnorm, integer *info);

#define LA_CLATDF F77_FUNC(clatdf,CLATDF)
/* Subroutine */ int LA_CLATDF(integer *ijob, integer *n, complex *z__, integer
  *ldz, complex *rhs, real *rdsum, real *rdscal, integer *ipiv, integer
  *jpiv);

#define LA_CLATPS F77_FUNC(clatps,CLATPS)
/* Subroutine */ int LA_CLATPS(char *uplo, char *trans, char *diag, char *
  normin, integer *n, complex *ap, complex *x, real *scale, real *cnorm,
   integer *info);

#define LA_CLATRD F77_FUNC(clatrd,CLATRD)
/* Subroutine */ int LA_CLATRD(char *uplo, integer *n, integer *nb, complex *a,
  integer *lda, real *e, complex *tau, complex *w, integer *ldw);

#define LA_CLATRS F77_FUNC(clatrs,CLATRS)
/* Subroutine */ int LA_CLATRS(char *uplo, char *trans, char *diag, char *
  normin, integer *n, complex *a, integer *lda, complex *x, real *scale,
   real *cnorm, integer *info);

#define LA_CLATRZ F77_FUNC(clatrz,CLATRZ)
/* Subroutine */ int LA_CLATRZ(integer *m, integer *n, integer *l, complex *a,
  integer *lda, complex *tau, complex *work);

#define LA_CLATZM F77_FUNC(clatzm,CLATZM)
/* Subroutine */ int LA_CLATZM(char *side, integer *m, integer *n, complex *v,
  integer *incv, complex *tau, complex *c1, complex *c2, integer *ldc,
  complex *work);

#define LA_CLAUU2 F77_FUNC(clauu2,CLAUU2)
/* Subroutine */ int LA_CLAUU2(char *uplo, integer *n, complex *a, integer *lda,
   integer *info);

#define LA_CLAUUM F77_FUNC(clauum,CLAUUM)
/* Subroutine */ int LA_CLAUUM(char *uplo, integer *n, complex *a, integer *lda,
   integer *info);

#define LA_CPBCON F77_FUNC(cpbcon,CPBCON)
/* Subroutine */ int LA_CPBCON(char *uplo, integer *n, integer *kd, complex *ab,
   integer *ldab, real *anorm, real *rcond, complex *work, real *rwork,
  integer *info);

#define LA_CPBEQU F77_FUNC(cpbequ,CPBEQU)
/* Subroutine */ int LA_CPBEQU(char *uplo, integer *n, integer *kd, complex *ab,
   integer *ldab, real *s, real *scond, real *amax, integer *info);

#define LA_CPBRFS F77_FUNC(cpbrfs,CPBRFS)
/* Subroutine */ int LA_CPBRFS(char *uplo, integer *n, integer *kd, integer *
  nrhs, complex *ab, integer *ldab, complex *afb, integer *ldafb,
  complex *b, integer *ldb, complex *x, integer *ldx, real *ferr, real *
  berr, complex *work, real *rwork, integer *info);

#define LA_CPBSTF F77_FUNC(cpbstf,CPBSTF)
/* Subroutine */ int LA_CPBSTF(char *uplo, integer *n, integer *kd, complex *ab,
   integer *ldab, integer *info);

#define LA_CPBSV F77_FUNC(cpbsv,CPBSV)
/* Subroutine */ int LA_CPBSV(char *uplo, integer *n, integer *kd, integer *
  nrhs, complex *ab, integer *ldab, complex *b, integer *ldb, integer *
  info);

#define LA_CPBSVX F77_FUNC(cpbsvx,CPBSVX)
/* Subroutine */ int LA_CPBSVX(char *fact, char *uplo, integer *n, integer *kd,
  integer *nrhs, complex *ab, integer *ldab, complex *afb, integer *
  ldafb, char *equed, real *s, complex *b, integer *ldb, complex *x,
  integer *ldx, real *rcond, real *ferr, real *berr, complex *work,
  real *rwork, integer *info);

#define LA_CPBTF2 F77_FUNC(cpbtf2,CPBTF2)
/* Subroutine */ int LA_CPBTF2(char *uplo, integer *n, integer *kd, complex *ab,
   integer *ldab, integer *info);

#define LA_CPBTRF F77_FUNC(cpbtrf,CPBTRF)
/* Subroutine */ int LA_CPBTRF(char *uplo, integer *n, integer *kd, complex *ab,
   integer *ldab, integer *info);

#define LA_CPBTRS F77_FUNC(cpbtrs,CPBTRS)
/* Subroutine */ int LA_CPBTRS(char *uplo, integer *n, integer *kd, integer *
  nrhs, complex *ab, integer *ldab, complex *b, integer *ldb, integer *
  info);

#define LA_CPOCON F77_FUNC(cpocon,CPOCON)
/* Subroutine */ int LA_CPOCON(char *uplo, integer *n, complex *a, integer *lda,
   real *anorm, real *rcond, complex *work, real *rwork, integer *info);

#define LA_CPOEQU F77_FUNC(cpoequ,CPOEQU)
/* Subroutine */ int LA_CPOEQU(integer *n, complex *a, integer *lda, real *s,
  real *scond, real *amax, integer *info);

#define LA_CPORFS F77_FUNC(cporfs,CPORFS)
/* Subroutine */ int LA_CPORFS(char *uplo, integer *n, integer *nrhs, complex *
  a, integer *lda, complex *af, integer *ldaf, complex *b, integer *ldb,
   complex *x, integer *ldx, real *ferr, real *berr, complex *work,
  real *rwork, integer *info);

#define LA_CPOSV F77_FUNC(cposv,CPOSV)
/* Subroutine */ int LA_CPOSV(char *uplo, integer *n, integer *nrhs, complex *a,
   integer *lda, complex *b, integer *ldb, integer *info);

#define LA_CPOSVX F77_FUNC(cposvx,CPOSVX)
/* Subroutine */ int LA_CPOSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, complex *a, integer *lda, complex *af, integer *ldaf, char *
  equed, real *s, complex *b, integer *ldb, complex *x, integer *ldx,
  real *rcond, real *ferr, real *berr, complex *work, real *rwork,
  integer *info);

#define LA_CPOTF2 F77_FUNC(cpotf2,CPOTF2)
/* Subroutine */ int LA_CPOTF2(char *uplo, integer *n, complex *a, integer *lda,
   integer *info);

#define LA_CPOTRF F77_FUNC(cpotrf,CPOTRF)
/* Subroutine */ int LA_CPOTRF(char *uplo, integer *n, complex *a, integer *lda,
   integer *info);

#define LA_CPOTRI F77_FUNC(cpotri,CPOTRI)
/* Subroutine */ int LA_CPOTRI(char *uplo, integer *n, complex *a, integer *lda,
   integer *info);

#define LA_CPOTRS F77_FUNC(cpotrs,CPOTRS)
/* Subroutine */ int LA_CPOTRS(char *uplo, integer *n, integer *nrhs, complex *
  a, integer *lda, complex *b, integer *ldb, integer *info);

#define LA_CPPCON F77_FUNC(cppcon,CPPCON)
/* Subroutine */ int LA_CPPCON(char *uplo, integer *n, complex *ap, real *anorm,
   real *rcond, complex *work, real *rwork, integer *info);

#define LA_CPPEQU F77_FUNC(cppequ,CPPEQU)
/* Subroutine */ int LA_CPPEQU(char *uplo, integer *n, complex *ap, real *s,
  real *scond, real *amax, integer *info);

#define LA_CPPRFS F77_FUNC(cpprfs,CPPRFS)
/* Subroutine */ int LA_CPPRFS(char *uplo, integer *n, integer *nrhs, complex *
  ap, complex *afp, complex *b, integer *ldb, complex *x, integer *ldx,
  real *ferr, real *berr, complex *work, real *rwork, integer *info);

#define LA_CPPSV F77_FUNC(cppsv,CPPSV)
/* Subroutine */ int LA_CPPSV(char *uplo, integer *n, integer *nrhs, complex *
  ap, complex *b, integer *ldb, integer *info);

#define LA_CPPSVX F77_FUNC(cppsvx,CPPSVX)
/* Subroutine */ int LA_CPPSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, complex *ap, complex *afp, char *equed, real *s, complex *b,
  integer *ldb, complex *x, integer *ldx, real *rcond, real *ferr, real
  *berr, complex *work, real *rwork, integer *info);

#define LA_CPPTRF F77_FUNC(cpptrf,CPPTRF)
/* Subroutine */ int LA_CPPTRF(char *uplo, integer *n, complex *ap, integer *
  info);

#define LA_CPPTRI F77_FUNC(cpptri,CPPTRI)
/* Subroutine */ int LA_CPPTRI(char *uplo, integer *n, complex *ap, integer *
  info);

#define LA_CPPTRS F77_FUNC(cpptrs,CPPTRS)
/* Subroutine */ int LA_CPPTRS(char *uplo, integer *n, integer *nrhs, complex *
  ap, complex *b, integer *ldb, integer *info);

#define LA_CPTCON F77_FUNC(cptcon,CPTCON)
/* Subroutine */ int LA_CPTCON(integer *n, real *d__, complex *e, real *anorm,
  real *rcond, real *rwork, integer *info);

#define LA_CPTRFS F77_FUNC(cptrfs,CPTRFS)
/* Subroutine */ int LA_CPTRFS(char *uplo, integer *n, integer *nrhs, real *d__,
   complex *e, real *df, complex *ef, complex *b, integer *ldb, complex
  *x, integer *ldx, real *ferr, real *berr, complex *work, real *rwork,
  integer *info);

#define LA_CPTSV F77_FUNC(cptsv,CPTSV)
/* Subroutine */ int LA_CPTSV(integer *n, integer *nrhs, real *d__, complex *e,
  complex *b, integer *ldb, integer *info);

#define LA_CPTSVX F77_FUNC(cptsvx,CPTSVX)
/* Subroutine */ int LA_CPTSVX(char *fact, integer *n, integer *nrhs, real *d__,
   complex *e, real *df, complex *ef, complex *b, integer *ldb, complex
  *x, integer *ldx, real *rcond, real *ferr, real *berr, complex *work,
  real *rwork, integer *info);

#define LA_CPTTRF F77_FUNC(cpttrf,CPTTRF)
/* Subroutine */ int LA_CPTTRF(integer *n, real *d__, complex *e, integer *info);

#define LA_CPTTRS F77_FUNC(cpttrs,CPTTRS)
/* Subroutine */ int LA_CPTTRS(char *uplo, integer *n, integer *nrhs, real *d__,
   complex *e, complex *b, integer *ldb, integer *info);

#define LA_CPTTS2 F77_FUNC(cptts2,CPTTS2)
/* Subroutine */ int LA_CPTTS2(integer *iuplo, integer *n, integer *nrhs, real *
  d__, complex *e, complex *b, integer *ldb);

#define LA_CROT F77_FUNC(crot,CROT)
/* Subroutine */ int LA_CROT(integer *n, complex *cx, integer *incx, complex *
  cy, integer *incy, real *c__, complex *s);

#define LA_CSPCON F77_FUNC(cspcon,CSPCON)
/* Subroutine */ int LA_CSPCON(char *uplo, integer *n, complex *ap, integer *
  ipiv, real *anorm, real *rcond, complex *work, integer *info);

#define LA_CSPMV F77_FUNC(cspmv,CSPMV)
/* Subroutine */ int LA_CSPMV(char *uplo, integer *n, complex *alpha, complex *
  ap, complex *x, integer *incx, complex *beta, complex *y, integer *
  incy);

#define LA_CSPR F77_FUNC(cspr,CSPR)
/* Subroutine */ int LA_CSPR(char *uplo, integer *n, complex *alpha, complex *x,
   integer *incx, complex *ap);

#define LA_CSPRFS F77_FUNC(csprfs,CSPRFS)
/* Subroutine */ int LA_CSPRFS(char *uplo, integer *n, integer *nrhs, complex *
  ap, complex *afp, integer *ipiv, complex *b, integer *ldb, complex *x,
   integer *ldx, real *ferr, real *berr, complex *work, real *rwork,
  integer *info);

#define LA_CSPSV F77_FUNC(cspsv,CSPSV)
/* Subroutine */ int LA_CSPSV(char *uplo, integer *n, integer *nrhs, complex *
  ap, integer *ipiv, complex *b, integer *ldb, integer *info);

#define LA_CSPSVX F77_FUNC(cspsvx,CSPSVX)
/* Subroutine */ int LA_CSPSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, complex *ap, complex *afp, integer *ipiv, complex *b, integer *
  ldb, complex *x, integer *ldx, real *rcond, real *ferr, real *berr,
  complex *work, real *rwork, integer *info);

#define LA_CSPTRF F77_FUNC(csptrf,CSPTRF)
/* Subroutine */ int LA_CSPTRF(char *uplo, integer *n, complex *ap, integer *
  ipiv, integer *info);

#define LA_CSPTRI F77_FUNC(csptri,CSPTRI)
/* Subroutine */ int LA_CSPTRI(char *uplo, integer *n, complex *ap, integer *
  ipiv, complex *work, integer *info);

#define LA_CSPTRS F77_FUNC(csptrs,CSPTRS)
/* Subroutine */ int LA_CSPTRS(char *uplo, integer *n, integer *nrhs, complex *
  ap, integer *ipiv, complex *b, integer *ldb, integer *info);

#define LA_CSROT F77_FUNC(csrot,CSROT)
/* Subroutine */ int LA_CSROT(integer *n, complex *cx, integer *incx, complex *
  cy, integer *incy, real *c__, real *s);

#define LA_CSRSCL F77_FUNC(csrscl,CSRSCL)
/* Subroutine */ int LA_CSRSCL(integer *n, real *sa, complex *sx, integer *incx);

#define LA_CSTEDC F77_FUNC(cstedc,CSTEDC)
/* Subroutine */ int LA_CSTEDC(char *compz, integer *n, real *d__, real *e,
  complex *z__, integer *ldz, complex *work, integer *lwork, real *
  rwork, integer *lrwork, integer *iwork, integer *liwork, integer *
  info);

#define LA_CSTEIN F77_FUNC(cstein,CSTEIN)
/* Subroutine */ int LA_CSTEIN(integer *n, real *d__, real *e, integer *m, real
  *w, integer *iblock, integer *isplit, complex *z__, integer *ldz,
  real *work, integer *iwork, integer *ifail, integer *info);

#define LA_CSTEQR F77_FUNC(csteqr,CSTEQR)
/* Subroutine */ int LA_CSTEQR(char *compz, integer *n, real *d__, real *e,
  complex *z__, integer *ldz, real *work, integer *info);

#define LA_CSYCON F77_FUNC(csycon,CSYCON)
/* Subroutine */ int LA_CSYCON(char *uplo, integer *n, complex *a, integer *lda,
   integer *ipiv, real *anorm, real *rcond, complex *work, integer *
  info);

#define LA_CSYMV F77_FUNC(csymv,CSYMV)
/* Subroutine */ int LA_CSYMV(char *uplo, integer *n, complex *alpha, complex *
  a, integer *lda, complex *x, integer *incx, complex *beta, complex *y,
   integer *incy);

#define LA_CSYR F77_FUNC(csyr,CSYR)
/* Subroutine */ int LA_CSYR(char *uplo, integer *n, complex *alpha, complex *x,
   integer *incx, complex *a, integer *lda);

#define LA_CSYRFS F77_FUNC(csyrfs,CSYRFS)
/* Subroutine */ int LA_CSYRFS(char *uplo, integer *n, integer *nrhs, complex *
  a, integer *lda, complex *af, integer *ldaf, integer *ipiv, complex *
  b, integer *ldb, complex *x, integer *ldx, real *ferr, real *berr,
  complex *work, real *rwork, integer *info);

#define LA_CSYSV F77_FUNC(csysv,CSYSV)
/* Subroutine */ int LA_CSYSV(char *uplo, integer *n, integer *nrhs, complex *a,
   integer *lda, integer *ipiv, complex *b, integer *ldb, complex *work,
   integer *lwork, integer *info);

#define LA_CSYSVX F77_FUNC(csysvx,CSYSVX)
/* Subroutine */ int LA_CSYSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, complex *a, integer *lda, complex *af, integer *ldaf, integer *
  ipiv, complex *b, integer *ldb, complex *x, integer *ldx, real *rcond,
   real *ferr, real *berr, complex *work, integer *lwork, real *rwork,
  integer *info);

#define LA_CSYTF2 F77_FUNC(csytf2,CSYTF2)
/* Subroutine */ int LA_CSYTF2(char *uplo, integer *n, complex *a, integer *lda,
   integer *ipiv, integer *info);

#define LA_CSYTRF F77_FUNC(csytrf,CSYTRF)
/* Subroutine */ int LA_CSYTRF(char *uplo, integer *n, complex *a, integer *lda,
   integer *ipiv, complex *work, integer *lwork, integer *info);

#define LA_CSYTRI F77_FUNC(csytri,CSYTRI)
/* Subroutine */ int LA_CSYTRI(char *uplo, integer *n, complex *a, integer *lda,
   integer *ipiv, complex *work, integer *info);

#define LA_CSYTRS F77_FUNC(csytrs,CSYTRS)
/* Subroutine */ int LA_CSYTRS(char *uplo, integer *n, integer *nrhs, complex *
  a, integer *lda, integer *ipiv, complex *b, integer *ldb, integer *
  info);

#define LA_CTBCON F77_FUNC(ctbcon,CTBCON)
/* Subroutine */ int LA_CTBCON(char *norm, char *uplo, char *diag, integer *n,
  integer *kd, complex *ab, integer *ldab, real *rcond, complex *work,
  real *rwork, integer *info);

#define LA_CTBRFS F77_FUNC(ctbrfs,CTBRFS)
/* Subroutine */ int LA_CTBRFS(char *uplo, char *trans, char *diag, integer *n,
  integer *kd, integer *nrhs, complex *ab, integer *ldab, complex *b,
  integer *ldb, complex *x, integer *ldx, real *ferr, real *berr,
  complex *work, real *rwork, integer *info);

#define LA_CTBTRS F77_FUNC(ctbtrs,CTBTRS)
/* Subroutine */ int LA_CTBTRS(char *uplo, char *trans, char *diag, integer *n,
  integer *kd, integer *nrhs, complex *ab, integer *ldab, complex *b,
  integer *ldb, integer *info);

#define LA_CTGEVC F77_FUNC(ctgevc,CTGEVC)
/* Subroutine */ int LA_CTGEVC(char *side, char *howmny, logical *select,
  integer *n, complex *a, integer *lda, complex *b, integer *ldb,
  complex *vl, integer *ldvl, complex *vr, integer *ldvr, integer *mm,
  integer *m, complex *work, real *rwork, integer *info);

#define LA_CTGEX2 F77_FUNC(ctgex2,CTGEX2)
/* Subroutine */ int LA_CTGEX2(logical *wantq, logical *wantz, integer *n,
  complex *a, integer *lda, complex *b, integer *ldb, complex *q,
  integer *ldq, complex *z__, integer *ldz, integer *j1, integer *info);

#define LA_CTGEXC F77_FUNC(ctgexc,CTGEXC)
/* Subroutine */ int LA_CTGEXC(logical *wantq, logical *wantz, integer *n,
  complex *a, integer *lda, complex *b, integer *ldb, complex *q,
  integer *ldq, complex *z__, integer *ldz, integer *ifst, integer *
  ilst, integer *info);

#define LA_CTGSEN F77_FUNC(ctgsen,CTGSEN)
/* Subroutine */ int LA_CTGSEN(integer *ijob, logical *wantq, logical *wantz,
  logical *select, integer *n, complex *a, integer *lda, complex *b,
  integer *ldb, complex *alpha, complex *beta, complex *q, integer *ldq,
   complex *z__, integer *ldz, integer *m, real *pl, real *pr, real *
  dif, complex *work, integer *lwork, integer *iwork, integer *liwork,
  integer *info);

#define LA_CTGSJA F77_FUNC(ctgsja,CTGSJA)
/* Subroutine */ int LA_CTGSJA(char *jobu, char *jobv, char *jobq, integer *m,
  integer *p, integer *n, integer *k, integer *l, complex *a, integer *
  lda, complex *b, integer *ldb, real *tola, real *tolb, real *alpha,
  real *beta, complex *u, integer *ldu, complex *v, integer *ldv,
  complex *q, integer *ldq, complex *work, integer *ncycle, integer *
  info);

#define LA_CTGSNA F77_FUNC(ctgsna,CTGSNA)
/* Subroutine */ int LA_CTGSNA(char *job, char *howmny, logical *select,
  integer *n, complex *a, integer *lda, complex *b, integer *ldb,
  complex *vl, integer *ldvl, complex *vr, integer *ldvr, real *s, real
  *dif, integer *mm, integer *m, complex *work, integer *lwork, integer
  *iwork, integer *info);

#define LA_CTGSY2 F77_FUNC(ctgsy2,CTGSY2)
/* Subroutine */ int LA_CTGSY2(char *trans, integer *ijob, integer *m, integer *
  n, complex *a, integer *lda, complex *b, integer *ldb, complex *c__,
  integer *ldc, complex *d__, integer *ldd, complex *e, integer *lde,
  complex *f, integer *ldf, real *scale, real *rdsum, real *rdscal,
  integer *info);

#define LA_CTGSYL F77_FUNC(ctgsyl,CTGSYL)
/* Subroutine */ int LA_CTGSYL(char *trans, integer *ijob, integer *m, integer *
  n, complex *a, integer *lda, complex *b, integer *ldb, complex *c__,
  integer *ldc, complex *d__, integer *ldd, complex *e, integer *lde,
  complex *f, integer *ldf, real *scale, real *dif, complex *work,
  integer *lwork, integer *iwork, integer *info);

#define LA_CTPCON F77_FUNC(ctpcon,CTPCON)
/* Subroutine */ int LA_CTPCON(char *norm, char *uplo, char *diag, integer *n,
  complex *ap, real *rcond, complex *work, real *rwork, integer *info);

#define LA_CTPRFS F77_FUNC(ctprfs,CTPRFS)
/* Subroutine */ int LA_CTPRFS(char *uplo, char *trans, char *diag, integer *n,
  integer *nrhs, complex *ap, complex *b, integer *ldb, complex *x,
  integer *ldx, real *ferr, real *berr, complex *work, real *rwork,
  integer *info);

#define LA_CTPTRI F77_FUNC(ctptri,CTPTRI)
/* Subroutine */ int LA_CTPTRI(char *uplo, char *diag, integer *n, complex *ap,
  integer *info);

#define LA_CTPTRS F77_FUNC(ctptrs,CTPTRS)
/* Subroutine */ int LA_CTPTRS(char *uplo, char *trans, char *diag, integer *n,
  integer *nrhs, complex *ap, complex *b, integer *ldb, integer *info);

#define LA_CTRCON F77_FUNC(ctrcon,CTRCON)
/* Subroutine */ int LA_CTRCON(char *norm, char *uplo, char *diag, integer *n,
  complex *a, integer *lda, real *rcond, complex *work, real *rwork,
  integer *info);

#define LA_CTREVC F77_FUNC(ctrevc,CTREVC)
/* Subroutine */ int LA_CTREVC(char *side, char *howmny, logical *select,
  integer *n, complex *t, integer *ldt, complex *vl, integer *ldvl,
  complex *vr, integer *ldvr, integer *mm, integer *m, complex *work,
  real *rwork, integer *info);

#define LA_CTREXC F77_FUNC(ctrexc,CTREXC)
/* Subroutine */ int LA_CTREXC(char *compq, integer *n, complex *t, integer *
  ldt, complex *q, integer *ldq, integer *ifst, integer *ilst, integer *
  info);

#define LA_CTRRFS F77_FUNC(ctrrfs,CTRRFS)
/* Subroutine */ int LA_CTRRFS(char *uplo, char *trans, char *diag, integer *n,
  integer *nrhs, complex *a, integer *lda, complex *b, integer *ldb,
  complex *x, integer *ldx, real *ferr, real *berr, complex *work, real
  *rwork, integer *info);

#define LA_CTRSEN F77_FUNC(ctrsen,CTRSEN)
/* Subroutine */ int LA_CTRSEN(char *job, char *compq, logical *select, integer
  *n, complex *t, integer *ldt, complex *q, integer *ldq, complex *w,
  integer *m, real *s, real *sep, complex *work, integer *lwork,
  integer *info);

#define LA_CTRSNA F77_FUNC(ctrsna,CTRSNA)
/* Subroutine */ int LA_CTRSNA(char *job, char *howmny, logical *select,
  integer *n, complex *t, integer *ldt, complex *vl, integer *ldvl,
  complex *vr, integer *ldvr, real *s, real *sep, integer *mm, integer *
  m, complex *work, integer *ldwork, real *rwork, integer *info);

#define LA_CTRSYL F77_FUNC(ctrsyl,CTRSYL)
/* Subroutine */ int LA_CTRSYL(char *trana, char *tranb, integer *isgn, integer
  *m, integer *n, complex *a, integer *lda, complex *b, integer *ldb,
  complex *c__, integer *ldc, real *scale, integer *info);

#define LA_CTRTI2 F77_FUNC(ctrti2,CTRTI2)
/* Subroutine */ int LA_CTRTI2(char *uplo, char *diag, integer *n, complex *a,
  integer *lda, integer *info);

#define LA_CTRTRI F77_FUNC(ctrtri,CTRTRI)
/* Subroutine */ int LA_CTRTRI(char *uplo, char *diag, integer *n, complex *a,
  integer *lda, integer *info);

#define LA_CTRTRS F77_FUNC(ctrtrs,CTRTRS)
/* Subroutine */ int LA_CTRTRS(char *uplo, char *trans, char *diag, integer *n,
  integer *nrhs, complex *a, integer *lda, complex *b, integer *ldb,
  integer *info);

#define LA_CTZRQF F77_FUNC(ctzrqf,CTZRQF)
/* Subroutine */ int LA_CTZRQF(integer *m, integer *n, complex *a, integer *lda,
   complex *tau, integer *info);

#define LA_CTZRZF F77_FUNC(ctzrzf,CTZRZF)
/* Subroutine */ int LA_CTZRZF(integer *m, integer *n, complex *a, integer *lda,
   complex *tau, complex *work, integer *lwork, integer *info);

#define LA_CUNG2L F77_FUNC(cung2l,CUNG2L)
/* Subroutine */ int LA_CUNG2L(integer *m, integer *n, integer *k, complex *a,
  integer *lda, complex *tau, complex *work, integer *info);

#define LA_CUNG2R F77_FUNC(cung2r,CUNG2R)
/* Subroutine */ int LA_CUNG2R(integer *m, integer *n, integer *k, complex *a,
  integer *lda, complex *tau, complex *work, integer *info);

#define LA_CUNGBR F77_FUNC(cungbr,CUNGBR)
/* Subroutine */ int LA_CUNGBR(char *vect, integer *m, integer *n, integer *k,
  complex *a, integer *lda, complex *tau, complex *work, integer *lwork,
   integer *info);

#define LA_CUNGHR F77_FUNC(cunghr,CUNGHR)
/* Subroutine */ int LA_CUNGHR(integer *n, integer *ilo, integer *ihi, complex *
  a, integer *lda, complex *tau, complex *work, integer *lwork, integer
  *info);

#define LA_CUNGL2 F77_FUNC(cungl2,CUNGL2)
/* Subroutine */ int LA_CUNGL2(integer *m, integer *n, integer *k, complex *a,
  integer *lda, complex *tau, complex *work, integer *info);

#define LA_CUNGLQ F77_FUNC(cunglq,CUNGLQ)
/* Subroutine */ int LA_CUNGLQ(integer *m, integer *n, integer *k, complex *a,
  integer *lda, complex *tau, complex *work, integer *lwork, integer *
  info);

#define LA_CUNGQL F77_FUNC(cungql,CUNGQL)
/* Subroutine */ int LA_CUNGQL(integer *m, integer *n, integer *k, complex *a,
  integer *lda, complex *tau, complex *work, integer *lwork, integer *
  info);

#define LA_CUNGQR F77_FUNC(cungqr,CUNGQR)
/* Subroutine */ int LA_CUNGQR(integer *m, integer *n, integer *k, complex *a,
  integer *lda, complex *tau, complex *work, integer *lwork, integer *
  info);

#define LA_CUNGR2 F77_FUNC(cungr2,CUNGR2)
/* Subroutine */ int LA_CUNGR2(integer *m, integer *n, integer *k, complex *a,
  integer *lda, complex *tau, complex *work, integer *info);

#define LA_CUNGRQ F77_FUNC(cungrq,CUNGRQ)
/* Subroutine */ int LA_CUNGRQ(integer *m, integer *n, integer *k, complex *a,
  integer *lda, complex *tau, complex *work, integer *lwork, integer *
  info);

#define LA_CUNGTR F77_FUNC(cungtr,CUNGTR)
/* Subroutine */ int LA_CUNGTR(char *uplo, integer *n, complex *a, integer *lda,
   complex *tau, complex *work, integer *lwork, integer *info);

#define LA_CUNM2L F77_FUNC(cunm2l,CUNM2L)
/* Subroutine */ int LA_CUNM2L(char *side, char *trans, integer *m, integer *n,
  integer *k, complex *a, integer *lda, complex *tau, complex *c__,
  integer *ldc, complex *work, integer *info);

#define LA_CUNM2R F77_FUNC(cunm2r,CUNM2R)
/* Subroutine */ int LA_CUNM2R(char *side, char *trans, integer *m, integer *n,
  integer *k, complex *a, integer *lda, complex *tau, complex *c__,
  integer *ldc, complex *work, integer *info);

#define LA_CUNMBR F77_FUNC(cunmbr,CUNMBR)
/* Subroutine */ int LA_CUNMBR(char *vect, char *side, char *trans, integer *m,
  integer *n, integer *k, complex *a, integer *lda, complex *tau,
  complex *c__, integer *ldc, complex *work, integer *lwork, integer *
  info);

#define LA_CUNMHR F77_FUNC(cunmhr,CUNMHR)
/* Subroutine */ int LA_CUNMHR(char *side, char *trans, integer *m, integer *n,
  integer *ilo, integer *ihi, complex *a, integer *lda, complex *tau,
  complex *c__, integer *ldc, complex *work, integer *lwork, integer *
  info);

#define LA_CUNML2 F77_FUNC(cunml2,CUNML2)
/* Subroutine */ int LA_CUNML2(char *side, char *trans, integer *m, integer *n,
  integer *k, complex *a, integer *lda, complex *tau, complex *c__,
  integer *ldc, complex *work, integer *info);

#define LA_CUNMLQ F77_FUNC(cunmlq,CUNMLQ)
/* Subroutine */ int LA_CUNMLQ(char *side, char *trans, integer *m, integer *n,
  integer *k, complex *a, integer *lda, complex *tau, complex *c__,
  integer *ldc, complex *work, integer *lwork, integer *info);

#define LA_CUNMQL F77_FUNC(cunmql,CUNMQL)
/* Subroutine */ int LA_CUNMQL(char *side, char *trans, integer *m, integer *n,
  integer *k, complex *a, integer *lda, complex *tau, complex *c__,
  integer *ldc, complex *work, integer *lwork, integer *info);

#define LA_CUNMQR F77_FUNC(cunmqr,CUNMQR)
/* Subroutine */ int LA_CUNMQR(char *side, char *trans, integer *m, integer *n,
  integer *k, complex *a, integer *lda, complex *tau, complex *c__,
  integer *ldc, complex *work, integer *lwork, integer *info);

#define LA_CUNMR2 F77_FUNC(cunmr2,CUNMR2)
/* Subroutine */ int LA_CUNMR2(char *side, char *trans, integer *m, integer *n,
  integer *k, complex *a, integer *lda, complex *tau, complex *c__,
  integer *ldc, complex *work, integer *info);

#define LA_CUNMR3 F77_FUNC(cunmr3,CUNMR3)
/* Subroutine */ int LA_CUNMR3(char *side, char *trans, integer *m, integer *n,
  integer *k, integer *l, complex *a, integer *lda, complex *tau,
  complex *c__, integer *ldc, complex *work, integer *info);

#define LA_CUNMRQ F77_FUNC(cunmrq,CUNMRQ)
/* Subroutine */ int LA_CUNMRQ(char *side, char *trans, integer *m, integer *n,
  integer *k, complex *a, integer *lda, complex *tau, complex *c__,
  integer *ldc, complex *work, integer *lwork, integer *info);

#define LA_CUNMRZ F77_FUNC(cunmrz,CUNMRZ)
/* Subroutine */ int LA_CUNMRZ(char *side, char *trans, integer *m, integer *n,
  integer *k, integer *l, complex *a, integer *lda, complex *tau,
  complex *c__, integer *ldc, complex *work, integer *lwork, integer *
  info);

#define LA_CUNMTR F77_FUNC(cunmtr,CUNMTR)
/* Subroutine */ int LA_CUNMTR(char *side, char *uplo, char *trans, integer *m,
  integer *n, complex *a, integer *lda, complex *tau, complex *c__,
  integer *ldc, complex *work, integer *lwork, integer *info);

#define LA_CUPGTR F77_FUNC(cupgtr,CUPGTR)
/* Subroutine */ int LA_CUPGTR(char *uplo, integer *n, complex *ap, complex *
  tau, complex *q, integer *ldq, complex *work, integer *info);

#define LA_CUPMTR F77_FUNC(cupmtr,CUPMTR)
/* Subroutine */ int LA_CUPMTR(char *side, char *uplo, char *trans, integer *m,
  integer *n, complex *ap, complex *tau, complex *c__, integer *ldc,
  complex *work, integer *info);

#define LA_DBDSDC F77_FUNC(dbdsdc,DBDSDC)
/* Subroutine */ int LA_DBDSDC(char *uplo, char *compq, integer *n, doublereal *
  d__, doublereal *e, doublereal *u, integer *ldu, doublereal *vt,
  integer *ldvt, doublereal *q, integer *iq, doublereal *work, integer *
  iwork, integer *info);

#define LA_DBDSQR F77_FUNC(dbdsqr,DBDSQR)
/* Subroutine */ int LA_DBDSQR(char *uplo, integer *n, integer *ncvt, integer *
  nru, integer *ncc, doublereal *d__, doublereal *e, doublereal *vt,
  integer *ldvt, doublereal *u, integer *ldu, doublereal *c__, integer *
  ldc, doublereal *work, integer *info);

#define LA_DDISNA F77_FUNC(ddisna,DDISNA)
/* Subroutine */ int LA_DDISNA(char *job, integer *m, integer *n, doublereal *
  d__, doublereal *sep, integer *info);

#define LA_DGBBRD F77_FUNC(dgbbrd,DGBBRD)
/* Subroutine */ int LA_DGBBRD(char *vect, integer *m, integer *n, integer *ncc,
   integer *kl, integer *ku, doublereal *ab, integer *ldab, doublereal *
  d__, doublereal *e, doublereal *q, integer *ldq, doublereal *pt,
  integer *ldpt, doublereal *c__, integer *ldc, doublereal *work,
  integer *info);

#define LA_DGBCON F77_FUNC(dgbcon,DGBCON)
/* Subroutine */ int LA_DGBCON(char *norm, integer *n, integer *kl, integer *ku,
   doublereal *ab, integer *ldab, integer *ipiv, doublereal *anorm,
  doublereal *rcond, doublereal *work, integer *iwork, integer *info);

#define LA_DGBEQU F77_FUNC(dgbequ,DGBEQU)
/* Subroutine */ int LA_DGBEQU(integer *m, integer *n, integer *kl, integer *ku,
   doublereal *ab, integer *ldab, doublereal *r__, doublereal *c__,
  doublereal *rowcnd, doublereal *colcnd, doublereal *amax, integer *
  info);

#define LA_DGBRFS F77_FUNC(dgbrfs,DGBRFS)
/* Subroutine */ int LA_DGBRFS(char *trans, integer *n, integer *kl, integer *
  ku, integer *nrhs, doublereal *ab, integer *ldab, doublereal *afb,
  integer *ldafb, integer *ipiv, doublereal *b, integer *ldb,
  doublereal *x, integer *ldx, doublereal *ferr, doublereal *berr,
  doublereal *work, integer *iwork, integer *info);

#define LA_DGBSV F77_FUNC(dgbsv,DGBSV)
/* Subroutine */ int LA_DGBSV(integer *n, integer *kl, integer *ku, integer *
  nrhs, doublereal *ab, integer *ldab, integer *ipiv, doublereal *b,
  integer *ldb, integer *info);

#define LA_DGBSVX F77_FUNC(dgbsvx,DGBSVX)
/* Subroutine */ int LA_DGBSVX(char *fact, char *trans, integer *n, integer *kl,
   integer *ku, integer *nrhs, doublereal *ab, integer *ldab,
  doublereal *afb, integer *ldafb, integer *ipiv, char *equed,
  doublereal *r__, doublereal *c__, doublereal *b, integer *ldb,
  doublereal *x, integer *ldx, doublereal *rcond, doublereal *ferr,
  doublereal *berr, doublereal *work, integer *iwork, integer *info);

#define LA_DGBTF2 F77_FUNC(dgbtf2,DGBTF2)
/* Subroutine */ int LA_DGBTF2(integer *m, integer *n, integer *kl, integer *ku,
   doublereal *ab, integer *ldab, integer *ipiv, integer *info);

#define LA_DGBTRF F77_FUNC(dgbtrf,DGBTRF)
/* Subroutine */ int LA_DGBTRF(integer *m, integer *n, integer *kl, integer *ku,
   doublereal *ab, integer *ldab, integer *ipiv, integer *info);

#define LA_DGBTRS F77_FUNC(dgbtrs,DGBTRS)
/* Subroutine */ int LA_DGBTRS(char *trans, integer *n, integer *kl, integer *
  ku, integer *nrhs, doublereal *ab, integer *ldab, integer *ipiv,
  doublereal *b, integer *ldb, integer *info);

#define LA_DGEBAK F77_FUNC(dgebak,DGEBAK)
/* Subroutine */ int LA_DGEBAK(char *job, char *side, integer *n, integer *ilo,
  integer *ihi, doublereal *scale, integer *m, doublereal *v, integer *
  ldv, integer *info);

#define LA_DGEBAL F77_FUNC(dgebal,DGEBAL)
/* Subroutine */ int LA_DGEBAL(char *job, integer *n, doublereal *a, integer *
  lda, integer *ilo, integer *ihi, doublereal *scale, integer *info);

#define LA_DGEBD2 F77_FUNC(dgebd2,DGEBD2)
/* Subroutine */ int LA_DGEBD2(integer *m, integer *n, doublereal *a, integer *
  lda, doublereal *d__, doublereal *e, doublereal *tauq, doublereal *
  taup, doublereal *work, integer *info);

#define LA_DGEBRD F77_FUNC(dgebrd,DGEBRD)
/* Subroutine */ int LA_DGEBRD(integer *m, integer *n, doublereal *a, integer *
  lda, doublereal *d__, doublereal *e, doublereal *tauq, doublereal *
  taup, doublereal *work, integer *lwork, integer *info);

#define LA_DGECON F77_FUNC(dgecon,DGECON)
/* Subroutine */ int LA_DGECON(char *norm, integer *n, doublereal *a, integer *
  lda, doublereal *anorm, doublereal *rcond, doublereal *work, integer *
  iwork, integer *info);

#define LA_DGEEQU F77_FUNC(dgeequ,DGEEQU)
/* Subroutine */ int LA_DGEEQU(integer *m, integer *n, doublereal *a, integer *
  lda, doublereal *r__, doublereal *c__, doublereal *rowcnd, doublereal
  *colcnd, doublereal *amax, integer *info);

#define LA_DGEES F77_FUNC(dgees,DGEES)
/* Subroutine */ int LA_DGEES(char *jobvs, char *sort, L_fp select, integer *n,
  doublereal *a, integer *lda, integer *sdim, doublereal *wr,
  doublereal *wi, doublereal *vs, integer *ldvs, doublereal *work,
  integer *lwork, logical *bwork, integer *info);

#define LA_DGEESX F77_FUNC(dgeesx,DGEESX)
/* Subroutine */ int LA_DGEESX(char *jobvs, char *sort, L_fp select, char *
  sense, integer *n, doublereal *a, integer *lda, integer *sdim,
  doublereal *wr, doublereal *wi, doublereal *vs, integer *ldvs,
  doublereal *rconde, doublereal *rcondv, doublereal *work, integer *
  lwork, integer *iwork, integer *liwork, logical *bwork, integer *info);

#define LA_DGEEV F77_FUNC(dgeev,DGEEV)
/* Subroutine */ int LA_DGEEV(char *jobvl, char *jobvr, integer *n, doublereal *
  a, integer *lda, doublereal *wr, doublereal *wi, doublereal *vl,
  integer *ldvl, doublereal *vr, integer *ldvr, doublereal *work,
  integer *lwork, integer *info);

#define LA_DGEEVX F77_FUNC(dgeevx,DGEEVX)
/* Subroutine */ int LA_DGEEVX(char *balanc, char *jobvl, char *jobvr, char *
  sense, integer *n, doublereal *a, integer *lda, doublereal *wr,
  doublereal *wi, doublereal *vl, integer *ldvl, doublereal *vr,
  integer *ldvr, integer *ilo, integer *ihi, doublereal *scale,
  doublereal *abnrm, doublereal *rconde, doublereal *rcondv, doublereal
  *work, integer *lwork, integer *iwork, integer *info);

#define LA_DGEGS F77_FUNC(dgegs,DGEGS)
/* Subroutine */ int LA_DGEGS(char *jobvsl, char *jobvsr, integer *n,
  doublereal *a, integer *lda, doublereal *b, integer *ldb, doublereal *
  alphar, doublereal *alphai, doublereal *beta, doublereal *vsl,
  integer *ldvsl, doublereal *vsr, integer *ldvsr, doublereal *work,
  integer *lwork, integer *info);

#define LA_DGEGV F77_FUNC(dgegv,DGEGV)
/* Subroutine */ int LA_DGEGV(char *jobvl, char *jobvr, integer *n, doublereal *
  a, integer *lda, doublereal *b, integer *ldb, doublereal *alphar,
  doublereal *alphai, doublereal *beta, doublereal *vl, integer *ldvl,
  doublereal *vr, integer *ldvr, doublereal *work, integer *lwork,
  integer *info);

#define LA_DGEHD2 F77_FUNC(dgehd2,DGEHD2)
/* Subroutine */ int LA_DGEHD2(integer *n, integer *ilo, integer *ihi,
  doublereal *a, integer *lda, doublereal *tau, doublereal *work,
  integer *info);

#define LA_DGEHRD F77_FUNC(dgehrd,DGEHRD)
/* Subroutine */ int LA_DGEHRD(integer *n, integer *ilo, integer *ihi,
  doublereal *a, integer *lda, doublereal *tau, doublereal *work,
  integer *lwork, integer *info);

#define LA_DGELQ2 F77_FUNC(dgelq2,DGELQ2)
/* Subroutine */ int LA_DGELQ2(integer *m, integer *n, doublereal *a, integer *
  lda, doublereal *tau, doublereal *work, integer *info);

#define LA_DGELQF F77_FUNC(dgelqf,DGELQF)
/* Subroutine */ int LA_DGELQF(integer *m, integer *n, doublereal *a, integer *
  lda, doublereal *tau, doublereal *work, integer *lwork, integer *info);

#define LA_DGELS F77_FUNC(dgels,DGELS)
/* Subroutine */ int LA_DGELS(char *trans, integer *m, integer *n, integer *
  nrhs, doublereal *a, integer *lda, doublereal *b, integer *ldb,
  doublereal *work, integer *lwork, integer *info);

#define LA_DGELSD F77_FUNC(dgelsd,DGELSD)
/* Subroutine */ int LA_DGELSD(integer *m, integer *n, integer *nrhs,
  doublereal *a, integer *lda, doublereal *b, integer *ldb, doublereal *
  s, doublereal *rcond, integer *rank, doublereal *work, integer *lwork,
   integer *iwork, integer *info);

#define LA_DGELSS F77_FUNC(dgelss,DGELSS)
/* Subroutine */ int LA_DGELSS(integer *m, integer *n, integer *nrhs,
  doublereal *a, integer *lda, doublereal *b, integer *ldb, doublereal *
  s, doublereal *rcond, integer *rank, doublereal *work, integer *lwork,
   integer *info);

#define LA_DGELSX F77_FUNC(dgelsx,DGELSX)
/* Subroutine */ int LA_DGELSX(integer *m, integer *n, integer *nrhs,
  doublereal *a, integer *lda, doublereal *b, integer *ldb, integer *
  jpvt, doublereal *rcond, integer *rank, doublereal *work, integer *
  info);

#define LA_DGELSY F77_FUNC(dgelsy,DGELSY)
/* Subroutine */ int LA_DGELSY(integer *m, integer *n, integer *nrhs,
  doublereal *a, integer *lda, doublereal *b, integer *ldb, integer *
  jpvt, doublereal *rcond, integer *rank, doublereal *work, integer *
  lwork, integer *info);

#define LA_DGEQL2 F77_FUNC(dgeql2,DGEQL2)
/* Subroutine */ int LA_DGEQL2(integer *m, integer *n, doublereal *a, integer *
  lda, doublereal *tau, doublereal *work, integer *info);

#define LA_DGEQLF F77_FUNC(dgeqlf,DGEQLF)
/* Subroutine */ int LA_DGEQLF(integer *m, integer *n, doublereal *a, integer *
  lda, doublereal *tau, doublereal *work, integer *lwork, integer *info);

#define LA_DGEQP3 F77_FUNC(dgeqp3,DGEQP3)
/* Subroutine */ int LA_DGEQP3(integer *m, integer *n, doublereal *a, integer *
  lda, integer *jpvt, doublereal *tau, doublereal *work, integer *lwork,
   integer *info);

#define LA_DGEQPF F77_FUNC(dgeqpf,DGEQPF)
/* Subroutine */ int LA_DGEQPF(integer *m, integer *n, doublereal *a, integer *
  lda, integer *jpvt, doublereal *tau, doublereal *work, integer *info);

#define LA_DGEQR2 F77_FUNC(dgeqr2,DGEQR2)
/* Subroutine */ int LA_DGEQR2(integer *m, integer *n, doublereal *a, integer *
  lda, doublereal *tau, doublereal *work, integer *info);

#define LA_DGEQRF F77_FUNC(dgeqrf,DGEQRF)
/* Subroutine */ int LA_DGEQRF(integer *m, integer *n, doublereal *a, integer *
  lda, doublereal *tau, doublereal *work, integer *lwork, integer *info);

#define LA_DGERFS F77_FUNC(dgerfs,DGERFS)
/* Subroutine */ int LA_DGERFS(char *trans, integer *n, integer *nrhs,
  doublereal *a, integer *lda, doublereal *af, integer *ldaf, integer *
  ipiv, doublereal *b, integer *ldb, doublereal *x, integer *ldx,
  doublereal *ferr, doublereal *berr, doublereal *work, integer *iwork,
  integer *info);

#define LA_DGERQ2 F77_FUNC(dgerq2,DGERQ2)
/* Subroutine */ int LA_DGERQ2(integer *m, integer *n, doublereal *a, integer *
  lda, doublereal *tau, doublereal *work, integer *info);

#define LA_DGERQF F77_FUNC(dgerqf,DGERQF)
/* Subroutine */ int LA_DGERQF(integer *m, integer *n, doublereal *a, integer *
  lda, doublereal *tau, doublereal *work, integer *lwork, integer *info);

#define LA_DGESC2 F77_FUNC(dgesc2,DGESC2)
/* Subroutine */ int LA_DGESC2(integer *n, doublereal *a, integer *lda,
  doublereal *rhs, integer *ipiv, integer *jpiv, doublereal *scale);

#define LA_DGESDD F77_FUNC(dgesdd,DGESDD)
/* Subroutine */ int LA_DGESDD(char *jobz, integer *m, integer *n, doublereal *
  a, integer *lda, doublereal *s, doublereal *u, integer *ldu,
  doublereal *vt, integer *ldvt, doublereal *work, integer *lwork,
  integer *iwork, integer *info);

#define LA_DGESV F77_FUNC(dgesv,DGESV)
/* Subroutine */ int LA_DGESV(integer *n, integer *nrhs, doublereal *a, integer
  *lda, integer *ipiv, doublereal *b, integer *ldb, integer *info);

#define LA_DGESVD F77_FUNC(dgesvd,DGESVD)
/* Subroutine */ int LA_DGESVD(char *jobu, char *jobvt, integer *m, integer *n,
  doublereal *a, integer *lda, doublereal *s, doublereal *u, integer *
  ldu, doublereal *vt, integer *ldvt, doublereal *work, integer *lwork,
  integer *info);

#define LA_DGESVX F77_FUNC(dgesvx,DGESVX)
/* Subroutine */ int LA_DGESVX(char *fact, char *trans, integer *n, integer *
  nrhs, doublereal *a, integer *lda, doublereal *af, integer *ldaf,
  integer *ipiv, char *equed, doublereal *r__, doublereal *c__,
  doublereal *b, integer *ldb, doublereal *x, integer *ldx, doublereal *
  rcond, doublereal *ferr, doublereal *berr, doublereal *work, integer *
  iwork, integer *info);

#define LA_DGETC2 F77_FUNC(dgetc2,DGETC2)
/* Subroutine */ int LA_DGETC2(integer *n, doublereal *a, integer *lda, integer
  *ipiv, integer *jpiv, integer *info);

#define LA_DGETF2 F77_FUNC(dgetf2,DGETF2)
/* Subroutine */ int LA_DGETF2(integer *m, integer *n, doublereal *a, integer *
  lda, integer *ipiv, integer *info);

#define LA_DGETRF F77_FUNC(dgetrf,DGETRF)
/* Subroutine */ int LA_DGETRF(integer *m, integer *n, doublereal *a, integer *
  lda, integer *ipiv, integer *info);

#define LA_DGETRI F77_FUNC(dgetri,DGETRI)
/* Subroutine */ int LA_DGETRI(integer *n, doublereal *a, integer *lda, integer
  *ipiv, doublereal *work, integer *lwork, integer *info);

#define LA_DGETRS F77_FUNC(dgetrs,DGETRS)
/* Subroutine */ int LA_DGETRS(char *trans, integer *n, integer *nrhs,
  doublereal *a, integer *lda, integer *ipiv, doublereal *b, integer *
  ldb, integer *info);

#define LA_DGGBAK F77_FUNC(dggbak,DGGBAK)
/* Subroutine */ int LA_DGGBAK(char *job, char *side, integer *n, integer *ilo,
  integer *ihi, doublereal *lscale, doublereal *rscale, integer *m,
  doublereal *v, integer *ldv, integer *info);

#define LA_DGGBAL F77_FUNC(dggbal,DGGBAL)
/* Subroutine */ int LA_DGGBAL(char *job, integer *n, doublereal *a, integer *
  lda, doublereal *b, integer *ldb, integer *ilo, integer *ihi,
  doublereal *lscale, doublereal *rscale, doublereal *work, integer *
  info);

#define LA_DGGES F77_FUNC(dgges,DGGES)
/* Subroutine */ int LA_DGGES(char *jobvsl, char *jobvsr, char *sort, L_fp
  delctg, integer *n, doublereal *a, integer *lda, doublereal *b,
  integer *ldb, integer *sdim, doublereal *alphar, doublereal *alphai,
  doublereal *beta, doublereal *vsl, integer *ldvsl, doublereal *vsr,
  integer *ldvsr, doublereal *work, integer *lwork, logical *bwork,
  integer *info);

#define LA_DGGESX F77_FUNC(dggesx,DGGESX)
/* Subroutine */ int LA_DGGESX(char *jobvsl, char *jobvsr, char *sort, L_fp
  delctg, char *sense, integer *n, doublereal *a, integer *lda,
  doublereal *b, integer *ldb, integer *sdim, doublereal *alphar,
  doublereal *alphai, doublereal *beta, doublereal *vsl, integer *ldvsl,
   doublereal *vsr, integer *ldvsr, doublereal *rconde, doublereal *
  rcondv, doublereal *work, integer *lwork, integer *iwork, integer *
  liwork, logical *bwork, integer *info);

#define LA_DGGEV F77_FUNC(dggev,DGGEV)
/* Subroutine */ int LA_DGGEV(char *jobvl, char *jobvr, integer *n, doublereal *
  a, integer *lda, doublereal *b, integer *ldb, doublereal *alphar,
  doublereal *alphai, doublereal *beta, doublereal *vl, integer *ldvl,
  doublereal *vr, integer *ldvr, doublereal *work, integer *lwork,
  integer *info);

#define LA_DGGEVX F77_FUNC(dggevx,DGGEVX)
/* Subroutine */ int LA_DGGEVX(char *balanc, char *jobvl, char *jobvr, char *
  sense, integer *n, doublereal *a, integer *lda, doublereal *b,
  integer *ldb, doublereal *alphar, doublereal *alphai, doublereal *
  beta, doublereal *vl, integer *ldvl, doublereal *vr, integer *ldvr,
  integer *ilo, integer *ihi, doublereal *lscale, doublereal *rscale,
  doublereal *abnrm, doublereal *bbnrm, doublereal *rconde, doublereal *
  rcondv, doublereal *work, integer *lwork, integer *iwork, logical *
  bwork, integer *info);

#define LA_DGGGLM F77_FUNC(dggglm,DGGGLM)
/* Subroutine */ int LA_DGGGLM(integer *n, integer *m, integer *p, doublereal *
  a, integer *lda, doublereal *b, integer *ldb, doublereal *d__,
  doublereal *x, doublereal *y, doublereal *work, integer *lwork,
  integer *info);

#define LA_DGGHRD F77_FUNC(dgghrd,DGGHRD)
/* Subroutine */ int LA_DGGHRD(char *compq, char *compz, integer *n, integer *
  ilo, integer *ihi, doublereal *a, integer *lda, doublereal *b,
  integer *ldb, doublereal *q, integer *ldq, doublereal *z__, integer *
  ldz, integer *info);

#define LA_DGGLSE F77_FUNC(dgglse,DGGLSE)
/* Subroutine */ int LA_DGGLSE(integer *m, integer *n, integer *p, doublereal *
  a, integer *lda, doublereal *b, integer *ldb, doublereal *c__,
  doublereal *d__, doublereal *x, doublereal *work, integer *lwork,
  integer *info);

#define LA_DGGQRF F77_FUNC(dggqrf,DGGQRF)
/* Subroutine */ int LA_DGGQRF(integer *n, integer *m, integer *p, doublereal *
  a, integer *lda, doublereal *taua, doublereal *b, integer *ldb,
  doublereal *taub, doublereal *work, integer *lwork, integer *info);

#define LA_DGGRQF F77_FUNC(dggrqf,DGGRQF)
/* Subroutine */ int LA_DGGRQF(integer *m, integer *p, integer *n, doublereal *
  a, integer *lda, doublereal *taua, doublereal *b, integer *ldb,
  doublereal *taub, doublereal *work, integer *lwork, integer *info);

#define LA_DGGSVD F77_FUNC(dggsvd,DGGSVD)
/* Subroutine */ int LA_DGGSVD(char *jobu, char *jobv, char *jobq, integer *m,
  integer *n, integer *p, integer *k, integer *l, doublereal *a,
  integer *lda, doublereal *b, integer *ldb, doublereal *alpha,
  doublereal *beta, doublereal *u, integer *ldu, doublereal *v, integer
  *ldv, doublereal *q, integer *ldq, doublereal *work, integer *iwork,
  integer *info);

#define LA_DGGSVP F77_FUNC(dggsvp,DGGSVP)
/* Subroutine */ int LA_DGGSVP(char *jobu, char *jobv, char *jobq, integer *m,
  integer *p, integer *n, doublereal *a, integer *lda, doublereal *b,
  integer *ldb, doublereal *tola, doublereal *tolb, integer *k, integer
  *l, doublereal *u, integer *ldu, doublereal *v, integer *ldv,
  doublereal *q, integer *ldq, integer *iwork, doublereal *tau,
  doublereal *work, integer *info);

#define LA_DGTCON F77_FUNC(dgtcon,DGTCON)
/* Subroutine */ int LA_DGTCON(char *norm, integer *n, doublereal *dl,
  doublereal *d__, doublereal *du, doublereal *du2, integer *ipiv,
  doublereal *anorm, doublereal *rcond, doublereal *work, integer *
  iwork, integer *info);

#define LA_DGTRFS F77_FUNC(dgtrfs,DGTRFS)
/* Subroutine */ int LA_DGTRFS(char *trans, integer *n, integer *nrhs,
  doublereal *dl, doublereal *d__, doublereal *du, doublereal *dlf,
  doublereal *df, doublereal *duf, doublereal *du2, integer *ipiv,
  doublereal *b, integer *ldb, doublereal *x, integer *ldx, doublereal *
  ferr, doublereal *berr, doublereal *work, integer *iwork, integer *
  info);

#define LA_DGTSV F77_FUNC(dgtsv,DGTSV)
/* Subroutine */ int LA_DGTSV(integer *n, integer *nrhs, doublereal *dl,
  doublereal *d__, doublereal *du, doublereal *b, integer *ldb, integer
  *info);

#define LA_DGTSVX F77_FUNC(dgtsvx,DGTSVX)
/* Subroutine */ int LA_DGTSVX(char *fact, char *trans, integer *n, integer *
  nrhs, doublereal *dl, doublereal *d__, doublereal *du, doublereal *
  dlf, doublereal *df, doublereal *duf, doublereal *du2, integer *ipiv,
  doublereal *b, integer *ldb, doublereal *x, integer *ldx, doublereal *
  rcond, doublereal *ferr, doublereal *berr, doublereal *work, integer *
  iwork, integer *info);

#define LA_DGTTRF F77_FUNC(dgttrf,DGTTRF)
/* Subroutine */ int LA_DGTTRF(integer *n, doublereal *dl, doublereal *d__,
  doublereal *du, doublereal *du2, integer *ipiv, integer *info);

#define LA_DGTTRS F77_FUNC(dgttrs,DGTTRS)
/* Subroutine */ int LA_DGTTRS(char *trans, integer *n, integer *nrhs,
  doublereal *dl, doublereal *d__, doublereal *du, doublereal *du2,
  integer *ipiv, doublereal *b, integer *ldb, integer *info);

#define LA_DGTTS2 F77_FUNC(dgtts2,DGTTS2)
/* Subroutine */ int LA_DGTTS2(integer *itrans, integer *n, integer *nrhs,
  doublereal *dl, doublereal *d__, doublereal *du, doublereal *du2,
  integer *ipiv, doublereal *b, integer *ldb);

#define LA_DHGEQZ F77_FUNC(dhgeqz,DHGEQZ)
/* Subroutine */ int LA_DHGEQZ(char *job, char *compq, char *compz, integer *n,
  integer *ilo, integer *ihi, doublereal *a, integer *lda, doublereal *
  b, integer *ldb, doublereal *alphar, doublereal *alphai, doublereal *
  beta, doublereal *q, integer *ldq, doublereal *z__, integer *ldz,
  doublereal *work, integer *lwork, integer *info);

#define LA_DHSEIN F77_FUNC(dhsein,DHSEIN)
/* Subroutine */ int LA_DHSEIN(char *side, char *eigsrc, char *initv, logical *
  select, integer *n, doublereal *h__, integer *ldh, doublereal *wr,
  doublereal *wi, doublereal *vl, integer *ldvl, doublereal *vr,
  integer *ldvr, integer *mm, integer *m, doublereal *work, integer *
  ifaill, integer *ifailr, integer *info);

#define LA_DHSEQR F77_FUNC(dhseqr,DHSEQR)
/* Subroutine */ int LA_DHSEQR(char *job, char *compz, integer *n, integer *ilo,
   integer *ihi, doublereal *h__, integer *ldh, doublereal *wr,
  doublereal *wi, doublereal *z__, integer *ldz, doublereal *work,
  integer *lwork, integer *info);

#define LA_DLABAD F77_FUNC(dlabad,DLABAD)
/* Subroutine */ int LA_DLABAD(doublereal *small, doublereal *large);

#define LA_DLABRD F77_FUNC(dlabrd,DLABRD)
/* Subroutine */ int LA_DLABRD(integer *m, integer *n, integer *nb, doublereal *
  a, integer *lda, doublereal *d__, doublereal *e, doublereal *tauq,
  doublereal *taup, doublereal *x, integer *ldx, doublereal *y, integer
  *ldy);

#define LA_DLACON F77_FUNC(dlacon,DLACON)
/* Subroutine */ int LA_DLACON(integer *n, doublereal *v, doublereal *x,
  integer *isgn, doublereal *est, integer *kase);

#define LA_DLACPY F77_FUNC(dlacpy,DLACPY)
/* Subroutine */ int LA_DLACPY(char *uplo, integer *m, integer *n, doublereal *
  a, integer *lda, doublereal *b, integer *ldb);

#define LA_DLADIV F77_FUNC(dladiv,DLADIV)
/* Subroutine */ int LA_DLADIV(doublereal *a, doublereal *b, doublereal *c__,
  doublereal *d__, doublereal *p, doublereal *q);

#define LA_DLAE2 F77_FUNC(dlae2,DLAE2)
/* Subroutine */ int LA_DLAE2(doublereal *a, doublereal *b, doublereal *c__,
  doublereal *rt1, doublereal *rt2);

#define LA_DLAEBZ F77_FUNC(dlaebz,DLAEBZ)
/* Subroutine */ int LA_DLAEBZ(integer *ijob, integer *nitmax, integer *n,
  integer *mmax, integer *minp, integer *nbmin, doublereal *abstol,
  doublereal *reltol, doublereal *pivmin, doublereal *d__, doublereal *
  e, doublereal *e2, integer *nval, doublereal *ab, doublereal *c__,
  integer *mout, integer *nab, doublereal *work, integer *iwork,
  integer *info);

#define LA_DLAED0 F77_FUNC(dlaed0,DLAED0)
/* Subroutine */ int LA_DLAED0(integer *icompq, integer *qsiz, integer *n,
  doublereal *d__, doublereal *e, doublereal *q, integer *ldq,
  doublereal *qstore, integer *ldqs, doublereal *work, integer *iwork,
  integer *info);

#define LA_DLAED1 F77_FUNC(dlaed1,DLAED1)
/* Subroutine */ int LA_DLAED1(integer *n, doublereal *d__, doublereal *q,
  integer *ldq, integer *indxq, doublereal *rho, integer *cutpnt,
  doublereal *work, integer *iwork, integer *info);

#define LA_DLAED2 F77_FUNC(dlaed2,DLAED2)
/* Subroutine */ int LA_DLAED2(integer *k, integer *n, integer *n1, doublereal *
  d__, doublereal *q, integer *ldq, integer *indxq, doublereal *rho,
  doublereal *z__, doublereal *dlamda, doublereal *w, doublereal *q2,
  integer *indx, integer *indxc, integer *indxp, integer *coltyp,
  integer *info);

#define LA_DLAED3 F77_FUNC(dlaed3,DLAED3)
/* Subroutine */ int LA_DLAED3(integer *k, integer *n, integer *n1, doublereal *
  d__, doublereal *q, integer *ldq, doublereal *rho, doublereal *dlamda,
   doublereal *q2, integer *indx, integer *ctot, doublereal *w,
  doublereal *s, integer *info);

#define LA_DLAED4 F77_FUNC(dlaed4,DLAED4)
/* Subroutine */ int LA_DLAED4(integer *n, integer *i__, doublereal *d__,
  doublereal *z__, doublereal *delta, doublereal *rho, doublereal *dlam,
   integer *info);

#define LA_DLAED5 F77_FUNC(dlaed5,DLAED5)
/* Subroutine */ int LA_DLAED5(integer *i__, doublereal *d__, doublereal *z__,
  doublereal *delta, doublereal *rho, doublereal *dlam);

#define LA_DLAED6 F77_FUNC(dlaed6,DLAED6)
/* Subroutine */ int LA_DLAED6(integer *kniter, logical *orgati, doublereal *
  rho, doublereal *d__, doublereal *z__, doublereal *finit, doublereal *
  tau, integer *info);

#define LA_DLAED7 F77_FUNC(dlaed7,DLAED7)
/* Subroutine */ int LA_DLAED7(integer *icompq, integer *n, integer *qsiz,
  integer *tlvls, integer *curlvl, integer *curpbm, doublereal *d__,
  doublereal *q, integer *ldq, integer *indxq, doublereal *rho, integer
  *cutpnt, doublereal *qstore, integer *qptr, integer *prmptr, integer *
  perm, integer *givptr, integer *givcol, doublereal *givnum,
  doublereal *work, integer *iwork, integer *info);

#define LA_DLAED8 F77_FUNC(dlaed8,DLAED8)
/* Subroutine */ int LA_DLAED8(integer *icompq, integer *k, integer *n, integer
  *qsiz, doublereal *d__, doublereal *q, integer *ldq, integer *indxq,
  doublereal *rho, integer *cutpnt, doublereal *z__, doublereal *dlamda,
   doublereal *q2, integer *ldq2, doublereal *w, integer *perm, integer
  *givptr, integer *givcol, doublereal *givnum, integer *indxp, integer
  *indx, integer *info);

#define LA_DLAED9 F77_FUNC(dlaed9,DLAED9)
/* Subroutine */ int LA_DLAED9(integer *k, integer *kstart, integer *kstop,
  integer *n, doublereal *d__, doublereal *q, integer *ldq, doublereal *
  rho, doublereal *dlamda, doublereal *w, doublereal *s, integer *lds,
  integer *info);

#define LA_DLAEDA F77_FUNC(dlaeda,DLAEDA)
/* Subroutine */ int LA_DLAEDA(integer *n, integer *tlvls, integer *curlvl,
  integer *curpbm, integer *prmptr, integer *perm, integer *givptr,
  integer *givcol, doublereal *givnum, doublereal *q, integer *qptr,
  doublereal *z__, doublereal *ztemp, integer *info);

#define LA_DLAEIN F77_FUNC(dlaein,DLAEIN)
/* Subroutine */ int LA_DLAEIN(logical *rightv, logical *noinit, integer *n,
  doublereal *h__, integer *ldh, doublereal *wr, doublereal *wi,
  doublereal *vr, doublereal *vi, doublereal *b, integer *ldb,
  doublereal *work, doublereal *eps3, doublereal *smlnum, doublereal *
  bignum, integer *info);

#define LA_DLAEV2 F77_FUNC(dlaev2,DLAEV2)
/* Subroutine */ int LA_DLAEV2(doublereal *a, doublereal *b, doublereal *c__,
  doublereal *rt1, doublereal *rt2, doublereal *cs1, doublereal *sn1);

#define LA_DLAEXC F77_FUNC(dlaexc,DLAEXC)
/* Subroutine */ int LA_DLAEXC(logical *wantq, integer *n, doublereal *t,
  integer *ldt, doublereal *q, integer *ldq, integer *j1, integer *n1,
  integer *n2, doublereal *work, integer *info);

#define LA_DLAG2 F77_FUNC(dlag2,DLAG2)
/* Subroutine */ int LA_DLAG2(doublereal *a, integer *lda, doublereal *b,
  integer *ldb, doublereal *safmin, doublereal *scale1, doublereal *
  scale2, doublereal *wr1, doublereal *wr2, doublereal *wi);

#define LA_DLAGS2 F77_FUNC(dlags2,DLAGS2)
/* Subroutine */ int LA_DLAGS2(logical *upper, doublereal *a1, doublereal *a2,
  doublereal *a3, doublereal *b1, doublereal *b2, doublereal *b3,
  doublereal *csu, doublereal *snu, doublereal *csv, doublereal *snv,
  doublereal *csq, doublereal *snq);

#define LA_DLAGTF F77_FUNC(dlagtf,DLAGTF)
/* Subroutine */ int LA_DLAGTF(integer *n, doublereal *a, doublereal *lambda,
  doublereal *b, doublereal *c__, doublereal *tol, doublereal *d__,
  integer *in, integer *info);

#define LA_DLAGTM F77_FUNC(dlagtm,DLAGTM)
/* Subroutine */ int LA_DLAGTM(char *trans, integer *n, integer *nrhs,
  doublereal *alpha, doublereal *dl, doublereal *d__, doublereal *du,
  doublereal *x, integer *ldx, doublereal *beta, doublereal *b, integer
  *ldb);

#define LA_DLAGTS F77_FUNC(dlagts,DLAGTS)
/* Subroutine */ int LA_DLAGTS(integer *job, integer *n, doublereal *a,
  doublereal *b, doublereal *c__, doublereal *d__, integer *in,
  doublereal *y, doublereal *tol, integer *info);

#define LA_DLAGV2 F77_FUNC(dlagv2,DLAGV2)
/* Subroutine */ int LA_DLAGV2(doublereal *a, integer *lda, doublereal *b,
  integer *ldb, doublereal *alphar, doublereal *alphai, doublereal *
  beta, doublereal *csl, doublereal *snl, doublereal *csr, doublereal *
  snr);

#define LA_DLAHQR F77_FUNC(dlahqr,DLAHQR)
/* Subroutine */ int LA_DLAHQR(logical *wantt, logical *wantz, integer *n,
  integer *ilo, integer *ihi, doublereal *h__, integer *ldh, doublereal
  *wr, doublereal *wi, integer *iloz, integer *ihiz, doublereal *z__,
  integer *ldz, integer *info);

#define LA_DLAHRD F77_FUNC(dlahrd,DLAHRD)
/* Subroutine */ int LA_DLAHRD(integer *n, integer *k, integer *nb, doublereal *
  a, integer *lda, doublereal *tau, doublereal *t, integer *ldt,
  doublereal *y, integer *ldy);

#define LA_DLAIC1 F77_FUNC(dlaic1,DLAIC1)
/* Subroutine */ int LA_DLAIC1(integer *job, integer *j, doublereal *x,
  doublereal *sest, doublereal *w, doublereal *gamma, doublereal *
  sestpr, doublereal *s, doublereal *c__);

#define LA_DLALN2 F77_FUNC(dlaln2,DLALN2)
/* Subroutine */ int LA_DLALN2(logical *ltrans, integer *na, integer *nw,
  doublereal *smin, doublereal *ca, doublereal *a, integer *lda,
  doublereal *d1, doublereal *d2, doublereal *b, integer *ldb,
  doublereal *wr, doublereal *wi, doublereal *x, integer *ldx,
  doublereal *scale, doublereal *xnorm, integer *info);

#define LA_DLALS0 F77_FUNC(dlals0,DLALS0)
/* Subroutine */ int LA_DLALS0(integer *icompq, integer *nl, integer *nr,
  integer *sqre, integer *nrhs, doublereal *b, integer *ldb, doublereal
  *bx, integer *ldbx, integer *perm, integer *givptr, integer *givcol,
  integer *ldgcol, doublereal *givnum, integer *ldgnum, doublereal *
  poles, doublereal *difl, doublereal *difr, doublereal *z__, integer *
  k, doublereal *c__, doublereal *s, doublereal *work, integer *info);

#define LA_DLALSA F77_FUNC(dlalsa,DLALSA)
/* Subroutine */ int LA_DLALSA(integer *icompq, integer *smlsiz, integer *n,
  integer *nrhs, doublereal *b, integer *ldb, doublereal *bx, integer *
  ldbx, doublereal *u, integer *ldu, doublereal *vt, integer *k,
  doublereal *difl, doublereal *difr, doublereal *z__, doublereal *
  poles, integer *givptr, integer *givcol, integer *ldgcol, integer *
  perm, doublereal *givnum, doublereal *c__, doublereal *s, doublereal *
  work, integer *iwork, integer *info);

#define LA_DLALSD F77_FUNC(dlalsd,DLALSD)
/* Subroutine */ int LA_DLALSD(char *uplo, integer *smlsiz, integer *n, integer
  *nrhs, doublereal *d__, doublereal *e, doublereal *b, integer *ldb,
  doublereal *rcond, integer *rank, doublereal *work, integer *iwork,
  integer *info);

#define LA_DLAMC1 F77_FUNC(dlamc1,DLAMC1)
/* Subroutine */ int LA_DLAMC1(integer *beta, integer *t, logical *rnd, logical
  *ieee1);

#define LA_DLAMC2 F77_FUNC(dlamc2,DLAMC2)
/* Subroutine */ int LA_DLAMC2(integer *beta, integer *t, logical *rnd,
  doublereal *eps, integer *emin, doublereal *rmin, integer *emax,
  doublereal *rmax);

#define LA_DLAMC4 F77_FUNC(dlamc4,DLAMC4)
/* Subroutine */ int LA_DLAMC4(integer *emin, doublereal *start, integer *base);

#define LA_DLAMC5 F77_FUNC(dlamc5,DLAMC5)
/* Subroutine */ int LA_DLAMC5(integer *beta, integer *p, integer *emin,
  logical *ieee, integer *emax, doublereal *rmax);

#define LA_DLAMRG F77_FUNC(dlamrg,DLAMRG)
/* Subroutine */ int LA_DLAMRG(integer *n1, integer *n2, doublereal *a, integer
  *dtrd1, integer *dtrd2, integer *index);

#define LA_DLANV2 F77_FUNC(dlanv2,DLANV2)
/* Subroutine */ int LA_DLANV2(doublereal *a, doublereal *b, doublereal *c__,
  doublereal *d__, doublereal *rt1r, doublereal *rt1i, doublereal *rt2r,
   doublereal *rt2i, doublereal *cs, doublereal *sn);

#define LA_DLAPLL F77_FUNC(dlapll,DLAPLL)
/* Subroutine */ int LA_DLAPLL(integer *n, doublereal *x, integer *incx,
  doublereal *y, integer *incy, doublereal *ssmin);

#define LA_DLAPMT F77_FUNC(dlapmt,DLAPMT)
/* Subroutine */ int LA_DLAPMT(logical *forwrd, integer *m, integer *n,
  doublereal *x, integer *ldx, integer *k);

#define LA_DLAQGB F77_FUNC(dlaqgb,DLAQGB)
/* Subroutine */ int LA_DLAQGB(integer *m, integer *n, integer *kl, integer *ku,
   doublereal *ab, integer *ldab, doublereal *r__, doublereal *c__,
  doublereal *rowcnd, doublereal *colcnd, doublereal *amax, char *equed);

#define LA_DLAQGE F77_FUNC(dlaqge,DLAQGE)
/* Subroutine */ int LA_DLAQGE(integer *m, integer *n, doublereal *a, integer *
  lda, doublereal *r__, doublereal *c__, doublereal *rowcnd, doublereal
  *colcnd, doublereal *amax, char *equed);

#define LA_DLAQP2 F77_FUNC(dlaqp2,DLAQP2)
/* Subroutine */ int LA_DLAQP2(integer *m, integer *n, integer *offset,
  doublereal *a, integer *lda, integer *jpvt, doublereal *tau,
  doublereal *vn1, doublereal *vn2, doublereal *work);

#define LA_DLAQPS F77_FUNC(dlaqps,DLAQPS)
/* Subroutine */ int LA_DLAQPS(integer *m, integer *n, integer *offset, integer
  *nb, integer *kb, doublereal *a, integer *lda, integer *jpvt,
  doublereal *tau, doublereal *vn1, doublereal *vn2, doublereal *auxv,
  doublereal *f, integer *ldf);

#define LA_DLAQSB F77_FUNC(dlaqsb,DLAQSB)
/* Subroutine */ int LA_DLAQSB(char *uplo, integer *n, integer *kd, doublereal *
  ab, integer *ldab, doublereal *s, doublereal *scond, doublereal *amax,
   char *equed);

#define LA_DLAQSP F77_FUNC(dlaqsp,DLAQSP)
/* Subroutine */ int LA_DLAQSP(char *uplo, integer *n, doublereal *ap,
  doublereal *s, doublereal *scond, doublereal *amax, char *equed);

#define LA_DLAQSY F77_FUNC(dlaqsy,DLAQSY)
/* Subroutine */ int LA_DLAQSY(char *uplo, integer *n, doublereal *a, integer *
  lda, doublereal *s, doublereal *scond, doublereal *amax, char *equed);

#define LA_DLAQTR F77_FUNC(dlaqtr,DLAQTR)
/* Subroutine */ int LA_DLAQTR(logical *ltran, logical *lreal, integer *n,
  doublereal *t, integer *ldt, doublereal *b, doublereal *w, doublereal
  *scale, doublereal *x, doublereal *work, integer *info);

#define LA_DLAR1V F77_FUNC(dlar1v,DLAR1V)
/* Subroutine */ int LA_DLAR1V(integer *n, integer *b1, integer *bn, doublereal
  *sigma, doublereal *d__, doublereal *l, doublereal *ld, doublereal *
  lld, doublereal *gersch, doublereal *z__, doublereal *ztz, doublereal
  *mingma, integer *r__, integer *isuppz, doublereal *work);

#define LA_DLAR2V F77_FUNC(dlar2v,DLAR2V)
/* Subroutine */ int LA_DLAR2V(integer *n, doublereal *x, doublereal *y,
  doublereal *z__, integer *incx, doublereal *c__, doublereal *s,
  integer *incc);

#define LA_DLARF F77_FUNC(dlarf,DLARF)
/* Subroutine */ int LA_DLARF(char *side, integer *m, integer *n, doublereal *v,
   integer *incv, doublereal *tau, doublereal *c__, integer *ldc,
  doublereal *work);

#define LA_DLARFB F77_FUNC(dlarfb,DLARFB)
/* Subroutine */ int LA_DLARFB(char *side, char *trans, char *direct, char *
  storev, integer *m, integer *n, integer *k, doublereal *v, integer *
  ldv, doublereal *t, integer *ldt, doublereal *c__, integer *ldc,
  doublereal *work, integer *ldwork);

#define LA_DLARFG F77_FUNC(dlarfg,DLARFG)
/* Subroutine */ int LA_DLARFG(integer *n, doublereal *alpha, doublereal *x,
  integer *incx, doublereal *tau);

#define LA_DLARFT F77_FUNC(dlarft,DLARFT)
/* Subroutine */ int LA_DLARFT(char *direct, char *storev, integer *n, integer *
  k, doublereal *v, integer *ldv, doublereal *tau, doublereal *t,
  integer *ldt);

#define LA_DLARFX F77_FUNC(dlarfx,DLARFX)
/* Subroutine */ int LA_DLARFX(char *side, integer *m, integer *n, doublereal *
  v, doublereal *tau, doublereal *c__, integer *ldc, doublereal *work);

#define LA_DLARGV F77_FUNC(dlargv,DLARGV)
/* Subroutine */ int LA_DLARGV(integer *n, doublereal *x, integer *incx,
  doublereal *y, integer *incy, doublereal *c__, integer *incc);

#define LA_DLARNV F77_FUNC(dlarnv,DLARNV)
/* Subroutine */ int LA_DLARNV(integer *idist, integer *iseed, integer *n,
  doublereal *x);

#define LA_DLARRB F77_FUNC(dlarrb,DLARRB)
/* Subroutine */ int LA_DLARRB(integer *n, doublereal *d__, doublereal *l,
  doublereal *ld, doublereal *lld, integer *ifirst, integer *ilast,
  doublereal *sigma, doublereal *reltol, doublereal *w, doublereal *
  wgap, doublereal *werr, doublereal *work, integer *iwork, integer *
  info);

#define LA_DLARRE F77_FUNC(dlarre,DLARRE)
/* Subroutine */ int LA_DLARRE(integer *n, doublereal *d__, doublereal *e,
  doublereal *tol, integer *nsplit, integer *isplit, integer *m,
  doublereal *w, doublereal *woff, doublereal *gersch, doublereal *work,
   integer *info);

#define LA_DLARRF F77_FUNC(dlarrf,DLARRF)
/* Subroutine */ int LA_DLARRF(integer *n, doublereal *d__, doublereal *l,
  doublereal *ld, doublereal *lld, integer *ifirst, integer *ilast,
  doublereal *w, doublereal *dplus, doublereal *lplus, doublereal *work,
   integer *iwork, integer *info);

#define LA_DLARRV F77_FUNC(dlarrv,DLARRV)
/* Subroutine */ int LA_DLARRV(integer *n, doublereal *d__, doublereal *l,
  integer *isplit, integer *m, doublereal *w, integer *iblock,
  doublereal *gersch, doublereal *tol, doublereal *z__, integer *ldz,
  integer *isuppz, doublereal *work, integer *iwork, integer *info);

#define LA_DLARTG F77_FUNC(dlartg,DLARTG)
/* Subroutine */ int LA_DLARTG(doublereal *f, doublereal *g, doublereal *cs,
  doublereal *sn, doublereal *r__);

#define LA_DLARTV F77_FUNC(dlartv,DLARTV)
/* Subroutine */ int LA_DLARTV(integer *n, doublereal *x, integer *incx,
  doublereal *y, integer *incy, doublereal *c__, doublereal *s, integer
  *incc);

#define LA_DLARUV F77_FUNC(dlaruv,DLARUV)
/* Subroutine */ int LA_DLARUV(integer *iseed, integer *n, doublereal *x);

#define LA_DLARZ F77_FUNC(dlarz,DLARZ)
/* Subroutine */ int LA_DLARZ(char *side, integer *m, integer *n, integer *l,
  doublereal *v, integer *incv, doublereal *tau, doublereal *c__,
  integer *ldc, doublereal *work);

#define LA_DLARZB F77_FUNC(dlarzb,DLARZB)
/* Subroutine */ int LA_DLARZB(char *side, char *trans, char *direct, char *
  storev, integer *m, integer *n, integer *k, integer *l, doublereal *v,
   integer *ldv, doublereal *t, integer *ldt, doublereal *c__, integer *
  ldc, doublereal *work, integer *ldwork);

#define LA_DLARZT F77_FUNC(dlarzt,DLARZT)
/* Subroutine */ int LA_DLARZT(char *direct, char *storev, integer *n, integer *
  k, doublereal *v, integer *ldv, doublereal *tau, doublereal *t,
  integer *ldt);

#define LA_DLAS2 F77_FUNC(dlas2,DLAS2)
/* Subroutine */ int LA_DLAS2(doublereal *f, doublereal *g, doublereal *h__,
  doublereal *ssmin, doublereal *ssmax);

#define LA_DLASCL F77_FUNC(dlascl,DLASCL)
/* Subroutine */ int LA_DLASCL(char *type__, integer *kl, integer *ku,
  doublereal *cfrom, doublereal *cto, integer *m, integer *n,
  doublereal *a, integer *lda, integer *info);

#define LA_DLASD0 F77_FUNC(dlasd0,DLASD0)
/* Subroutine */ int LA_DLASD0(integer *n, integer *sqre, doublereal *d__,
  doublereal *e, doublereal *u, integer *ldu, doublereal *vt, integer *
  ldvt, integer *smlsiz, integer *iwork, doublereal *work, integer *
  info);

#define LA_DLASD1 F77_FUNC(dlasd1,DLASD1)
/* Subroutine */ int LA_DLASD1(integer *nl, integer *nr, integer *sqre,
  doublereal *d__, doublereal *alpha, doublereal *beta, doublereal *u,
  integer *ldu, doublereal *vt, integer *ldvt, integer *idxq, integer *
  iwork, doublereal *work, integer *info);

#define LA_DLASD2 F77_FUNC(dlasd2,DLASD2)
/* Subroutine */ int LA_DLASD2(integer *nl, integer *nr, integer *sqre, integer
  *k, doublereal *d__, doublereal *z__, doublereal *alpha, doublereal *
  beta, doublereal *u, integer *ldu, doublereal *vt, integer *ldvt,
  doublereal *dsigma, doublereal *u2, integer *ldu2, doublereal *vt2,
  integer *ldvt2, integer *idxp, integer *idx, integer *idxc, integer *
  idxq, integer *coltyp, integer *info);

#define LA_DLASD3 F77_FUNC(dlasd3,DLASD3)
/* Subroutine */ int LA_DLASD3(integer *nl, integer *nr, integer *sqre, integer
  *k, doublereal *d__, doublereal *q, integer *ldq, doublereal *dsigma,
  doublereal *u, integer *ldu, doublereal *u2, integer *ldu2,
  doublereal *vt, integer *ldvt, doublereal *vt2, integer *ldvt2,
  integer *idxc, integer *ctot, doublereal *z__, integer *info);

#define LA_DLASD4 F77_FUNC(dlasd4,DLASD4)
/* Subroutine */ int LA_DLASD4(integer *n, integer *i__, doublereal *d__,
  doublereal *z__, doublereal *delta, doublereal *rho, doublereal *
  sigma, doublereal *work, integer *info);

#define LA_DLASD5 F77_FUNC(dlasd5,DLASD5)
/* Subroutine */ int LA_DLASD5(integer *i__, doublereal *d__, doublereal *z__,
  doublereal *delta, doublereal *rho, doublereal *dsigma, doublereal *
  work);

#define LA_DLASD6 F77_FUNC(dlasd6,DLASD6)
/* Subroutine */ int LA_DLASD6(integer *icompq, integer *nl, integer *nr,
  integer *sqre, doublereal *d__, doublereal *vf, doublereal *vl,
  doublereal *alpha, doublereal *beta, integer *idxq, integer *perm,
  integer *givptr, integer *givcol, integer *ldgcol, doublereal *givnum,
   integer *ldgnum, doublereal *poles, doublereal *difl, doublereal *
  difr, doublereal *z__, integer *k, doublereal *c__, doublereal *s,
  doublereal *work, integer *iwork, integer *info);

#define LA_DLASD7 F77_FUNC(dlasd7,DLASD7)
/* Subroutine */ int LA_DLASD7(integer *icompq, integer *nl, integer *nr,
  integer *sqre, integer *k, doublereal *d__, doublereal *z__,
  doublereal *zw, doublereal *vf, doublereal *vfw, doublereal *vl,
  doublereal *vlw, doublereal *alpha, doublereal *beta, doublereal *
  dsigma, integer *idx, integer *idxp, integer *idxq, integer *perm,
  integer *givptr, integer *givcol, integer *ldgcol, doublereal *givnum,
   integer *ldgnum, doublereal *c__, doublereal *s, integer *info);

#define LA_DLASD8 F77_FUNC(dlasd8,DLASD8)
/* Subroutine */ int LA_DLASD8(integer *icompq, integer *k, doublereal *d__,
  doublereal *z__, doublereal *vf, doublereal *vl, doublereal *difl,
  doublereal *difr, integer *lddifr, doublereal *dsigma, doublereal *
  work, integer *info);

#define LA_DLASD9 F77_FUNC(dlasd9,DLASD9)
/* Subroutine */ int LA_DLASD9(integer *icompq, integer *ldu, integer *k,
  doublereal *d__, doublereal *z__, doublereal *vf, doublereal *vl,
  doublereal *difl, doublereal *difr, doublereal *dsigma, doublereal *
  work, integer *info);

#define LA_DLASDA F77_FUNC(dlasda,DLASDA)
/* Subroutine */ int LA_DLASDA(integer *icompq, integer *smlsiz, integer *n,
  integer *sqre, doublereal *d__, doublereal *e, doublereal *u, integer
  *ldu, doublereal *vt, integer *k, doublereal *difl, doublereal *difr,
  doublereal *z__, doublereal *poles, integer *givptr, integer *givcol,
  integer *ldgcol, integer *perm, doublereal *givnum, doublereal *c__,
  doublereal *s, doublereal *work, integer *iwork, integer *info);

#define LA_DLASDQ F77_FUNC(dlasdq,DLASDQ)
/* Subroutine */ int LA_DLASDQ(char *uplo, integer *sqre, integer *n, integer *
  ncvt, integer *nru, integer *ncc, doublereal *d__, doublereal *e,
  doublereal *vt, integer *ldvt, doublereal *u, integer *ldu,
  doublereal *c__, integer *ldc, doublereal *work, integer *info);

#define LA_DLASDT F77_FUNC(dlasdt,DLASDT)
/* Subroutine */ int LA_DLASDT(integer *n, integer *lvl, integer *nd, integer *
  inode, integer *ndiml, integer *ndimr, integer *msub);

#define LA_DLASET F77_FUNC(dlaset,DLASET)
/* Subroutine */ int LA_DLASET(char *uplo, integer *m, integer *n, doublereal *
  alpha, doublereal *beta, doublereal *a, integer *lda);

#define LA_DLASQ1 F77_FUNC(dlasq1,DLASQ1)
/* Subroutine */ int LA_DLASQ1(integer *n, doublereal *d__, doublereal *e,
  doublereal *work, integer *info);

#define LA_DLASQ2 F77_FUNC(dlasq2,DLASQ2)
/* Subroutine */ int LA_DLASQ2(integer *n, doublereal *z__, integer *info);

#define LA_DLASQ3 F77_FUNC(dlasq3,DLASQ3)
/* Subroutine */ int LA_DLASQ3(integer *i0, integer *n0, doublereal *z__,
  integer *pp, doublereal *dmin__, doublereal *sigma, doublereal *desig,
   doublereal *qmax, integer *nfail, integer *iter, integer *ndiv,
  logical *ieee);

#define LA_DLASQ4 F77_FUNC(dlasq4,DLASQ4)
/* Subroutine */ int LA_DLASQ4(integer *i0, integer *n0, doublereal *z__,
  integer *pp, integer *n0in, doublereal *dmin__, doublereal *dmin1,
  doublereal *dmin2, doublereal *dn, doublereal *dn1, doublereal *dn2,
  doublereal *tau, integer *ttype);

#define LA_DLASQ5 F77_FUNC(dlasq5,DLASQ5)
/* Subroutine */ int LA_DLASQ5(integer *i0, integer *n0, doublereal *z__,
  integer *pp, doublereal *tau, doublereal *dmin__, doublereal *dmin1,
  doublereal *dmin2, doublereal *dn, doublereal *dnm1, doublereal *dnm2,
   logical *ieee);

#define LA_DLASQ6 F77_FUNC(dlasq6,DLASQ6)
/* Subroutine */ int LA_DLASQ6(integer *i0, integer *n0, doublereal *z__,
  integer *pp, doublereal *dmin__, doublereal *dmin1, doublereal *dmin2,
   doublereal *dn, doublereal *dnm1, doublereal *dnm2);

#define LA_DLASR F77_FUNC(dlasr,DLASR)
/* Subroutine */ int LA_DLASR(char *side, char *pivot, char *direct, integer *m,
   integer *n, doublereal *c__, doublereal *s, doublereal *a, integer *
  lda);

#define LA_DLASRT F77_FUNC(dlasrt,DLASRT)
/* Subroutine */ int LA_DLASRT(char *id, integer *n, doublereal *d__, integer *
  info);

#define LA_DLASSQ F77_FUNC(dlassq,DLASSQ)
/* Subroutine */ int LA_DLASSQ(integer *n, doublereal *x, integer *incx,
  doublereal *scale, doublereal *sumsq);

#define LA_DLASV2 F77_FUNC(dlasv2,DLASV2)
/* Subroutine */ int LA_DLASV2(doublereal *f, doublereal *g, doublereal *h__,
  doublereal *ssmin, doublereal *ssmax, doublereal *snr, doublereal *
  csr, doublereal *snl, doublereal *csl);

#define LA_DLASWP F77_FUNC(dlaswp,DLASWP)
/* Subroutine */ int LA_DLASWP(integer *n, doublereal *a, integer *lda, integer
  *k1, integer *k2, integer *ipiv, integer *incx);

#define LA_DLASY2 F77_FUNC(dlasy2,DLASY2)
/* Subroutine */ int LA_DLASY2(logical *ltranl, logical *ltranr, integer *isgn,
  integer *n1, integer *n2, doublereal *tl, integer *ldtl, doublereal *
  tr, integer *ldtr, doublereal *b, integer *ldb, doublereal *scale,
  doublereal *x, integer *ldx, doublereal *xnorm, integer *info);

#define LA_DLASYF F77_FUNC(dlasyf,DLASYF)
/* Subroutine */ int LA_DLASYF(char *uplo, integer *n, integer *nb, integer *kb,
   doublereal *a, integer *lda, integer *ipiv, doublereal *w, integer *
  ldw, integer *info);

#define LA_DLATBS F77_FUNC(dlatbs,DLATBS)
/* Subroutine */ int LA_DLATBS(char *uplo, char *trans, char *diag, char *
  normin, integer *n, integer *kd, doublereal *ab, integer *ldab,
  doublereal *x, doublereal *scale, doublereal *cnorm, integer *info);

#define LA_DLATDF F77_FUNC(dlatdf,DLATDF)
/* Subroutine */ int LA_DLATDF(integer *ijob, integer *n, doublereal *z__,
  integer *ldz, doublereal *rhs, doublereal *rdsum, doublereal *rdscal,
  integer *ipiv, integer *jpiv);

#define LA_DLATPS F77_FUNC(dlatps,DLATPS)
/* Subroutine */ int LA_DLATPS(char *uplo, char *trans, char *diag, char *
  normin, integer *n, doublereal *ap, doublereal *x, doublereal *scale,
  doublereal *cnorm, integer *info);

#define LA_DLATRD F77_FUNC(dlatrd,DLATRD)
/* Subroutine */ int LA_DLATRD(char *uplo, integer *n, integer *nb, doublereal *
  a, integer *lda, doublereal *e, doublereal *tau, doublereal *w,
  integer *ldw);

#define LA_DLATRS F77_FUNC(dlatrs,DLATRS)
/* Subroutine */ int LA_DLATRS(char *uplo, char *trans, char *diag, char *
  normin, integer *n, doublereal *a, integer *lda, doublereal *x,
  doublereal *scale, doublereal *cnorm, integer *info);

#define LA_DLATRZ F77_FUNC(dlatrz,DLATRZ)
/* Subroutine */ int LA_DLATRZ(integer *m, integer *n, integer *l, doublereal *
  a, integer *lda, doublereal *tau, doublereal *work);

#define LA_DLATZM F77_FUNC(dlatzm,DLATZM)
/* Subroutine */ int LA_DLATZM(char *side, integer *m, integer *n, doublereal *
  v, integer *incv, doublereal *tau, doublereal *c1, doublereal *c2,
  integer *ldc, doublereal *work);

#define LA_DLAUU2 F77_FUNC(dlauu2,DLAUU2)
/* Subroutine */ int LA_DLAUU2(char *uplo, integer *n, doublereal *a, integer *
  lda, integer *info);

#define LA_DLAUUM F77_FUNC(dlauum,DLAUUM)
/* Subroutine */ int LA_DLAUUM(char *uplo, integer *n, doublereal *a, integer *
  lda, integer *info);

#define LA_DOPGTR F77_FUNC(dopgtr,DOPGTR)
/* Subroutine */ int LA_DOPGTR(char *uplo, integer *n, doublereal *ap,
  doublereal *tau, doublereal *q, integer *ldq, doublereal *work,
  integer *info);

#define LA_DOPMTR F77_FUNC(dopmtr,DOPMTR)
/* Subroutine */ int LA_DOPMTR(char *side, char *uplo, char *trans, integer *m,
  integer *n, doublereal *ap, doublereal *tau, doublereal *c__, integer
  *ldc, doublereal *work, integer *info);

#define LA_DORG2L F77_FUNC(dorg2l,DORG2L)
/* Subroutine */ int LA_DORG2L(integer *m, integer *n, integer *k, doublereal *
  a, integer *lda, doublereal *tau, doublereal *work, integer *info);

#define LA_DORG2R F77_FUNC(dorg2r,DORG2R)
/* Subroutine */ int LA_DORG2R(integer *m, integer *n, integer *k, doublereal *
  a, integer *lda, doublereal *tau, doublereal *work, integer *info);

#define LA_DORGBR F77_FUNC(dorgbr,DORGBR)
/* Subroutine */ int LA_DORGBR(char *vect, integer *m, integer *n, integer *k,
  doublereal *a, integer *lda, doublereal *tau, doublereal *work,
  integer *lwork, integer *info);

#define LA_DORGHR F77_FUNC(dorghr,DORGHR)
/* Subroutine */ int LA_DORGHR(integer *n, integer *ilo, integer *ihi,
  doublereal *a, integer *lda, doublereal *tau, doublereal *work,
  integer *lwork, integer *info);

#define LA_DORGL2 F77_FUNC(dorgl2,DORGL2)
/* Subroutine */ int LA_DORGL2(integer *m, integer *n, integer *k, doublereal *
  a, integer *lda, doublereal *tau, doublereal *work, integer *info);

#define LA_DORGLQ F77_FUNC(dorglq,DORGLQ)
/* Subroutine */ int LA_DORGLQ(integer *m, integer *n, integer *k, doublereal *
  a, integer *lda, doublereal *tau, doublereal *work, integer *lwork,
  integer *info);

#define LA_DORGQL F77_FUNC(dorgql,DORGQL)
/* Subroutine */ int LA_DORGQL(integer *m, integer *n, integer *k, doublereal *
  a, integer *lda, doublereal *tau, doublereal *work, integer *lwork,
  integer *info);

#define LA_DORGQR F77_FUNC(dorgqr,DORGQR)
/* Subroutine */ int LA_DORGQR(integer *m, integer *n, integer *k, doublereal *
  a, integer *lda, doublereal *tau, doublereal *work, integer *lwork,
  integer *info);

#define LA_DORGR2 F77_FUNC(dorgr2,DORGR2)
/* Subroutine */ int LA_DORGR2(integer *m, integer *n, integer *k, doublereal *
  a, integer *lda, doublereal *tau, doublereal *work, integer *info);

#define LA_DORGRQ F77_FUNC(dorgrq,DORGRQ)
/* Subroutine */ int LA_DORGRQ(integer *m, integer *n, integer *k, doublereal *
  a, integer *lda, doublereal *tau, doublereal *work, integer *lwork,
  integer *info);

#define LA_DORGTR F77_FUNC(dorgtr,DORGTR)
/* Subroutine */ int LA_DORGTR(char *uplo, integer *n, doublereal *a, integer *
  lda, doublereal *tau, doublereal *work, integer *lwork, integer *info);

#define LA_DORM2L F77_FUNC(dorm2l,DORM2L)
/* Subroutine */ int LA_DORM2L(char *side, char *trans, integer *m, integer *n,
  integer *k, doublereal *a, integer *lda, doublereal *tau, doublereal *
  c__, integer *ldc, doublereal *work, integer *info);

#define LA_DORM2R F77_FUNC(dorm2r,DORM2R)
/* Subroutine */ int LA_DORM2R(char *side, char *trans, integer *m, integer *n,
  integer *k, doublereal *a, integer *lda, doublereal *tau, doublereal *
  c__, integer *ldc, doublereal *work, integer *info);

#define LA_DORMBR F77_FUNC(dormbr,DORMBR)
/* Subroutine */ int LA_DORMBR(char *vect, char *side, char *trans, integer *m,
  integer *n, integer *k, doublereal *a, integer *lda, doublereal *tau,
  doublereal *c__, integer *ldc, doublereal *work, integer *lwork,
  integer *info);

#define LA_DORMHR F77_FUNC(dormhr,DORMHR)
/* Subroutine */ int LA_DORMHR(char *side, char *trans, integer *m, integer *n,
  integer *ilo, integer *ihi, doublereal *a, integer *lda, doublereal *
  tau, doublereal *c__, integer *ldc, doublereal *work, integer *lwork,
  integer *info);

#define LA_DORML2 F77_FUNC(dorml2,DORML2)
/* Subroutine */ int LA_DORML2(char *side, char *trans, integer *m, integer *n,
  integer *k, doublereal *a, integer *lda, doublereal *tau, doublereal *
  c__, integer *ldc, doublereal *work, integer *info);

#define LA_DORMLQ F77_FUNC(dormlq,DORMLQ)
/* Subroutine */ int LA_DORMLQ(char *side, char *trans, integer *m, integer *n,
  integer *k, doublereal *a, integer *lda, doublereal *tau, doublereal *
  c__, integer *ldc, doublereal *work, integer *lwork, integer *info);

#define LA_DORMQL F77_FUNC(dormql,DORMQL)
/* Subroutine */ int LA_DORMQL(char *side, char *trans, integer *m, integer *n,
  integer *k, doublereal *a, integer *lda, doublereal *tau, doublereal *
  c__, integer *ldc, doublereal *work, integer *lwork, integer *info);

#define LA_DORMQR F77_FUNC(dormqr,DORMQR)
/* Subroutine */ int LA_DORMQR(char *side, char *trans, integer *m, integer *n,
  integer *k, doublereal *a, integer *lda, doublereal *tau, doublereal *
  c__, integer *ldc, doublereal *work, integer *lwork, integer *info);

#define LA_DORMR2 F77_FUNC(dormr2,DORMR2)
/* Subroutine */ int LA_DORMR2(char *side, char *trans, integer *m, integer *n,
  integer *k, doublereal *a, integer *lda, doublereal *tau, doublereal *
  c__, integer *ldc, doublereal *work, integer *info);

#define LA_DORMR3 F77_FUNC(dormr3,DORMR3)
/* Subroutine */ int LA_DORMR3(char *side, char *trans, integer *m, integer *n,
  integer *k, integer *l, doublereal *a, integer *lda, doublereal *tau,
  doublereal *c__, integer *ldc, doublereal *work, integer *info);

#define LA_DORMRQ F77_FUNC(dormrq,DORMRQ)
/* Subroutine */ int LA_DORMRQ(char *side, char *trans, integer *m, integer *n,
  integer *k, doublereal *a, integer *lda, doublereal *tau, doublereal *
  c__, integer *ldc, doublereal *work, integer *lwork, integer *info);

#define LA_DORMRZ F77_FUNC(dormrz,DORMRZ)
/* Subroutine */ int LA_DORMRZ(char *side, char *trans, integer *m, integer *n,
  integer *k, integer *l, doublereal *a, integer *lda, doublereal *tau,
  doublereal *c__, integer *ldc, doublereal *work, integer *lwork,
  integer *info);

#define LA_DORMTR F77_FUNC(dormtr,DORMTR)
/* Subroutine */ int LA_DORMTR(char *side, char *uplo, char *trans, integer *m,
  integer *n, doublereal *a, integer *lda, doublereal *tau, doublereal *
  c__, integer *ldc, doublereal *work, integer *lwork, integer *info);

#define LA_DPBCON F77_FUNC(dpbcon,DPBCON)
/* Subroutine */ int LA_DPBCON(char *uplo, integer *n, integer *kd, doublereal *
  ab, integer *ldab, doublereal *anorm, doublereal *rcond, doublereal *
  work, integer *iwork, integer *info);

#define LA_DPBEQU F77_FUNC(dpbequ,DPBEQU)
/* Subroutine */ int LA_DPBEQU(char *uplo, integer *n, integer *kd, doublereal *
  ab, integer *ldab, doublereal *s, doublereal *scond, doublereal *amax,
   integer *info);

#define LA_DPBRFS F77_FUNC(dpbrfs,DPBRFS)
/* Subroutine */ int LA_DPBRFS(char *uplo, integer *n, integer *kd, integer *
  nrhs, doublereal *ab, integer *ldab, doublereal *afb, integer *ldafb,
  doublereal *b, integer *ldb, doublereal *x, integer *ldx, doublereal *
  ferr, doublereal *berr, doublereal *work, integer *iwork, integer *
  info);

#define LA_DPBSTF F77_FUNC(dpbstf,DPBSTF)
/* Subroutine */ int LA_DPBSTF(char *uplo, integer *n, integer *kd, doublereal *
  ab, integer *ldab, integer *info);

#define LA_DPBSV F77_FUNC(dpbsv,DPBSV)
/* Subroutine */ int LA_DPBSV(char *uplo, integer *n, integer *kd, integer *
  nrhs, doublereal *ab, integer *ldab, doublereal *b, integer *ldb,
  integer *info);

#define LA_DPBSVX F77_FUNC(dpbsvx,DPBSVX)
/* Subroutine */ int LA_DPBSVX(char *fact, char *uplo, integer *n, integer *kd,
  integer *nrhs, doublereal *ab, integer *ldab, doublereal *afb,
  integer *ldafb, char *equed, doublereal *s, doublereal *b, integer *
  ldb, doublereal *x, integer *ldx, doublereal *rcond, doublereal *ferr,
   doublereal *berr, doublereal *work, integer *iwork, integer *info);

#define LA_DPBTF2 F77_FUNC(dpbtf2,DPBTF2)
/* Subroutine */ int LA_DPBTF2(char *uplo, integer *n, integer *kd, doublereal *
  ab, integer *ldab, integer *info);

#define LA_DPBTRF F77_FUNC(dpbtrf,DPBTRF)
/* Subroutine */ int LA_DPBTRF(char *uplo, integer *n, integer *kd, doublereal *
  ab, integer *ldab, integer *info);

#define LA_DPBTRS F77_FUNC(dpbtrs,DPBTRS)
/* Subroutine */ int LA_DPBTRS(char *uplo, integer *n, integer *kd, integer *
  nrhs, doublereal *ab, integer *ldab, doublereal *b, integer *ldb,
  integer *info);

#define LA_DPOCON F77_FUNC(dpocon,DPOCON)
/* Subroutine */ int LA_DPOCON(char *uplo, integer *n, doublereal *a, integer *
  lda, doublereal *anorm, doublereal *rcond, doublereal *work, integer *
  iwork, integer *info);

#define LA_DPOEQU F77_FUNC(dpoequ,DPOEQU)
/* Subroutine */ int LA_DPOEQU(integer *n, doublereal *a, integer *lda,
  doublereal *s, doublereal *scond, doublereal *amax, integer *info);

#define LA_DPORFS F77_FUNC(dporfs,DPORFS)
/* Subroutine */ int LA_DPORFS(char *uplo, integer *n, integer *nrhs,
  doublereal *a, integer *lda, doublereal *af, integer *ldaf,
  doublereal *b, integer *ldb, doublereal *x, integer *ldx, doublereal *
  ferr, doublereal *berr, doublereal *work, integer *iwork, integer *
  info);

#define LA_DPOSV F77_FUNC(dposv,DPOSV)
/* Subroutine */ int LA_DPOSV(char *uplo, integer *n, integer *nrhs, doublereal
  *a, integer *lda, doublereal *b, integer *ldb, integer *info);

#define LA_DPOSVX F77_FUNC(dposvx,DPOSVX)
/* Subroutine */ int LA_DPOSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, doublereal *a, integer *lda, doublereal *af, integer *ldaf,
  char *equed, doublereal *s, doublereal *b, integer *ldb, doublereal *
  x, integer *ldx, doublereal *rcond, doublereal *ferr, doublereal *
  berr, doublereal *work, integer *iwork, integer *info);

#define LA_DPOTF2 F77_FUNC(dpotf2,DPOTF2)
/* Subroutine */ int LA_DPOTF2(char *uplo, integer *n, doublereal *a, integer *
  lda, integer *info);

#define LA_DPOTRF F77_FUNC(dpotrf,DPOTRF)
/* Subroutine */ int LA_DPOTRF(char *uplo, integer *n, doublereal *a, integer *
  lda, integer *info);

#define LA_DPOTRI F77_FUNC(dpotri,DPOTRI)
/* Subroutine */ int LA_DPOTRI(char *uplo, integer *n, doublereal *a, integer *
  lda, integer *info);

#define LA_DPOTRS F77_FUNC(dpotrs,DPOTRS)
/* Subroutine */ int LA_DPOTRS(char *uplo, integer *n, integer *nrhs,
  doublereal *a, integer *lda, doublereal *b, integer *ldb, integer *
  info);

#define LA_DPPCON F77_FUNC(dppcon,DPPCON)
/* Subroutine */ int LA_DPPCON(char *uplo, integer *n, doublereal *ap,
  doublereal *anorm, doublereal *rcond, doublereal *work, integer *
  iwork, integer *info);

#define LA_DPPEQU F77_FUNC(dppequ,DPPEQU)
/* Subroutine */ int LA_DPPEQU(char *uplo, integer *n, doublereal *ap,
  doublereal *s, doublereal *scond, doublereal *amax, integer *info);

#define LA_DPPRFS F77_FUNC(dpprfs,DPPRFS)
/* Subroutine */ int LA_DPPRFS(char *uplo, integer *n, integer *nrhs,
  doublereal *ap, doublereal *afp, doublereal *b, integer *ldb,
  doublereal *x, integer *ldx, doublereal *ferr, doublereal *berr,
  doublereal *work, integer *iwork, integer *info);

#define LA_DPPSV F77_FUNC(dppsv,DPPSV)
/* Subroutine */ int LA_DPPSV(char *uplo, integer *n, integer *nrhs, doublereal
  *ap, doublereal *b, integer *ldb, integer *info);

#define LA_DPPSVX F77_FUNC(dppsvx,DPPSVX)
/* Subroutine */ int LA_DPPSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, doublereal *ap, doublereal *afp, char *equed, doublereal *s,
  doublereal *b, integer *ldb, doublereal *x, integer *ldx, doublereal *
  rcond, doublereal *ferr, doublereal *berr, doublereal *work, integer *
  iwork, integer *info);

#define LA_DPPTRF F77_FUNC(dpptrf,DPPTRF)
/* Subroutine */ int LA_DPPTRF(char *uplo, integer *n, doublereal *ap, integer *
  info);

#define LA_DPPTRI F77_FUNC(dpptri,DPPTRI)
/* Subroutine */ int LA_DPPTRI(char *uplo, integer *n, doublereal *ap, integer *
  info);

#define LA_DPPTRS F77_FUNC(dpptrs,DPPTRS)
/* Subroutine */ int LA_DPPTRS(char *uplo, integer *n, integer *nrhs,
  doublereal *ap, doublereal *b, integer *ldb, integer *info);

#define LA_DPTCON F77_FUNC(dptcon,DPTCON)
/* Subroutine */ int LA_DPTCON(integer *n, doublereal *d__, doublereal *e,
  doublereal *anorm, doublereal *rcond, doublereal *work, integer *info);

#define LA_DPTEQR F77_FUNC(dpteqr,DPTEQR)
/* Subroutine */ int LA_DPTEQR(char *compz, integer *n, doublereal *d__,
  doublereal *e, doublereal *z__, integer *ldz, doublereal *work,
  integer *info);

#define LA_DPTRFS F77_FUNC(dptrfs,DPTRFS)
/* Subroutine */ int LA_DPTRFS(integer *n, integer *nrhs, doublereal *d__,
  doublereal *e, doublereal *df, doublereal *ef, doublereal *b, integer
  *ldb, doublereal *x, integer *ldx, doublereal *ferr, doublereal *berr,
   doublereal *work, integer *info);

#define LA_DPTSV F77_FUNC(dptsv,DPTSV)
/* Subroutine */ int LA_DPTSV(integer *n, integer *nrhs, doublereal *d__,
  doublereal *e, doublereal *b, integer *ldb, integer *info);

#define LA_DPTSVX F77_FUNC(dptsvx,DPTSVX)
/* Subroutine */ int LA_DPTSVX(char *fact, integer *n, integer *nrhs,
  doublereal *d__, doublereal *e, doublereal *df, doublereal *ef,
  doublereal *b, integer *ldb, doublereal *x, integer *ldx, doublereal *
  rcond, doublereal *ferr, doublereal *berr, doublereal *work, integer *
  info);

#define LA_DPTTRF F77_FUNC(dpttrf,DPTTRF)
/* Subroutine */ int LA_DPTTRF(integer *n, doublereal *d__, doublereal *e,
  integer *info);

#define LA_DPTTRS F77_FUNC(dpttrs,DPTTRS)
/* Subroutine */ int LA_DPTTRS(integer *n, integer *nrhs, doublereal *d__,
  doublereal *e, doublereal *b, integer *ldb, integer *info);

#define LA_DPTTS2 F77_FUNC(dptts2,DPTTS2)
/* Subroutine */ int LA_DPTTS2(integer *n, integer *nrhs, doublereal *d__,
  doublereal *e, doublereal *b, integer *ldb);

#define LA_DRSCL F77_FUNC(drscl,DRSCL)
/* Subroutine */ int LA_DRSCL(integer *n, doublereal *sa, doublereal *sx,
  integer *incx);

#define LA_DSBEV F77_FUNC(dsbev,DSBEV)
/* Subroutine */ int LA_DSBEV(char *jobz, char *uplo, integer *n, integer *kd,
  doublereal *ab, integer *ldab, doublereal *w, doublereal *z__,
  integer *ldz, doublereal *work, integer *info);

#define LA_DSBEVD F77_FUNC(dsbevd,DSBEVD)
/* Subroutine */ int LA_DSBEVD(char *jobz, char *uplo, integer *n, integer *kd,
  doublereal *ab, integer *ldab, doublereal *w, doublereal *z__,
  integer *ldz, doublereal *work, integer *lwork, integer *iwork,
  integer *liwork, integer *info);

#define LA_DSBEVX F77_FUNC(dsbevx,DSBEVX)
/* Subroutine */ int LA_DSBEVX(char *jobz, char *range, char *uplo, integer *n,
  integer *kd, doublereal *ab, integer *ldab, doublereal *q, integer *
  ldq, doublereal *vl, doublereal *vu, integer *il, integer *iu,
  doublereal *abstol, integer *m, doublereal *w, doublereal *z__,
  integer *ldz, doublereal *work, integer *iwork, integer *ifail,
  integer *info);

#define LA_DSBGST F77_FUNC(dsbgst,DSBGST)
/* Subroutine */ int LA_DSBGST(char *vect, char *uplo, integer *n, integer *ka,
  integer *kb, doublereal *ab, integer *ldab, doublereal *bb, integer *
  ldbb, doublereal *x, integer *ldx, doublereal *work, integer *info);

#define LA_DSBGV F77_FUNC(dsbgv,DSBGV)
/* Subroutine */ int LA_DSBGV(char *jobz, char *uplo, integer *n, integer *ka,
  integer *kb, doublereal *ab, integer *ldab, doublereal *bb, integer *
  ldbb, doublereal *w, doublereal *z__, integer *ldz, doublereal *work,
  integer *info);

#define LA_DSBGVD F77_FUNC(dsbgvd,DSBGVD)
/* Subroutine */ int LA_DSBGVD(char *jobz, char *uplo, integer *n, integer *ka,
  integer *kb, doublereal *ab, integer *ldab, doublereal *bb, integer *
  ldbb, doublereal *w, doublereal *z__, integer *ldz, doublereal *work,
  integer *lwork, integer *iwork, integer *liwork, integer *info);

#define LA_DSBGVX F77_FUNC(dsbgvx,DSBGVX)
/* Subroutine */ int LA_DSBGVX(char *jobz, char *range, char *uplo, integer *n,
  integer *ka, integer *kb, doublereal *ab, integer *ldab, doublereal *
  bb, integer *ldbb, doublereal *q, integer *ldq, doublereal *vl,
  doublereal *vu, integer *il, integer *iu, doublereal *abstol, integer
  *m, doublereal *w, doublereal *z__, integer *ldz, doublereal *work,
  integer *iwork, integer *ifail, integer *info);

#define LA_DSBTRD F77_FUNC(dsbtrd,DSBTRD)
/* Subroutine */ int LA_DSBTRD(char *vect, char *uplo, integer *n, integer *kd,
  doublereal *ab, integer *ldab, doublereal *d__, doublereal *e,
  doublereal *q, integer *ldq, doublereal *work, integer *info);

#define LA_DSPCON F77_FUNC(dspcon,DSPCON)
/* Subroutine */ int LA_DSPCON(char *uplo, integer *n, doublereal *ap, integer *
  ipiv, doublereal *anorm, doublereal *rcond, doublereal *work, integer
  *iwork, integer *info);

#define LA_DSPEV F77_FUNC(dspev,DSPEV)
/* Subroutine */ int LA_DSPEV(char *jobz, char *uplo, integer *n, doublereal *
  ap, doublereal *w, doublereal *z__, integer *ldz, doublereal *work,
  integer *info);

#define LA_DSPEVD F77_FUNC(dspevd,DSPEVD)
/* Subroutine */ int LA_DSPEVD(char *jobz, char *uplo, integer *n, doublereal *
  ap, doublereal *w, doublereal *z__, integer *ldz, doublereal *work,
  integer *lwork, integer *iwork, integer *liwork, integer *info);

#define LA_DSPEVX F77_FUNC(dspevx,DSPEVX)
/* Subroutine */ int LA_DSPEVX(char *jobz, char *range, char *uplo, integer *n,
  doublereal *ap, doublereal *vl, doublereal *vu, integer *il, integer *
  iu, doublereal *abstol, integer *m, doublereal *w, doublereal *z__,
  integer *ldz, doublereal *work, integer *iwork, integer *ifail,
  integer *info);

#define LA_DSPGST F77_FUNC(dspgst,DSPGST)
/* Subroutine */ int LA_DSPGST(integer *itype, char *uplo, integer *n,
  doublereal *ap, doublereal *bp, integer *info);

#define LA_DSPGV F77_FUNC(dspgv,DSPGV)
/* Subroutine */ int LA_DSPGV(integer *itype, char *jobz, char *uplo, integer *
  n, doublereal *ap, doublereal *bp, doublereal *w, doublereal *z__,
  integer *ldz, doublereal *work, integer *info);

#define LA_DSPGVD F77_FUNC(dspgvd,DSPGVD)
/* Subroutine */ int LA_DSPGVD(integer *itype, char *jobz, char *uplo, integer *
  n, doublereal *ap, doublereal *bp, doublereal *w, doublereal *z__,
  integer *ldz, doublereal *work, integer *lwork, integer *iwork,
  integer *liwork, integer *info);

#define LA_DSPGVX F77_FUNC(dspgvx,DSPGVX)
/* Subroutine */ int LA_DSPGVX(integer *itype, char *jobz, char *range, char *
  uplo, integer *n, doublereal *ap, doublereal *bp, doublereal *vl,
  doublereal *vu, integer *il, integer *iu, doublereal *abstol, integer
  *m, doublereal *w, doublereal *z__, integer *ldz, doublereal *work,
  integer *iwork, integer *ifail, integer *info);

#define LA_DSPRFS F77_FUNC(dsprfs,DSPRFS)
/* Subroutine */ int LA_DSPRFS(char *uplo, integer *n, integer *nrhs,
  doublereal *ap, doublereal *afp, integer *ipiv, doublereal *b,
  integer *ldb, doublereal *x, integer *ldx, doublereal *ferr,
  doublereal *berr, doublereal *work, integer *iwork, integer *info);

#define LA_DSPSV F77_FUNC(dspsv,DSPSV)
/* Subroutine */ int LA_DSPSV(char *uplo, integer *n, integer *nrhs, doublereal
  *ap, integer *ipiv, doublereal *b, integer *ldb, integer *info);

#define LA_DSPSVX F77_FUNC(dspsvx,DSPSVX)
/* Subroutine */ int LA_DSPSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, doublereal *ap, doublereal *afp, integer *ipiv, doublereal *b,
  integer *ldb, doublereal *x, integer *ldx, doublereal *rcond,
  doublereal *ferr, doublereal *berr, doublereal *work, integer *iwork,
  integer *info);

#define LA_DSPTRD F77_FUNC(dsptrd,DSPTRD)
/* Subroutine */ int LA_DSPTRD(char *uplo, integer *n, doublereal *ap,
  doublereal *d__, doublereal *e, doublereal *tau, integer *info);

#define LA_DSPTRF F77_FUNC(dsptrf,DSPTRF)
/* Subroutine */ int LA_DSPTRF(char *uplo, integer *n, doublereal *ap, integer *
  ipiv, integer *info);

#define LA_DSPTRI F77_FUNC(dsptri,DSPTRI)
/* Subroutine */ int LA_DSPTRI(char *uplo, integer *n, doublereal *ap, integer *
  ipiv, doublereal *work, integer *info);

#define LA_DSPTRS F77_FUNC(dsptrs,DSPTRS)
/* Subroutine */ int LA_DSPTRS(char *uplo, integer *n, integer *nrhs,
  doublereal *ap, integer *ipiv, doublereal *b, integer *ldb, integer *
  info);

#define LA_DSTEBZ F77_FUNC(dstebz,DSTEBZ)
/* Subroutine */ int LA_DSTEBZ(char *range, char *order, integer *n, doublereal
  *vl, doublereal *vu, integer *il, integer *iu, doublereal *abstol,
  doublereal *d__, doublereal *e, integer *m, integer *nsplit,
  doublereal *w, integer *iblock, integer *isplit, doublereal *work,
  integer *iwork, integer *info);

#define LA_DSTEDC F77_FUNC(dstedc,DSTEDC)
/* Subroutine */ int LA_DSTEDC(char *compz, integer *n, doublereal *d__,
  doublereal *e, doublereal *z__, integer *ldz, doublereal *work,
  integer *lwork, integer *iwork, integer *liwork, integer *info);

#define LA_DSTEGR F77_FUNC(dstegr,DSTEGR)
/* Subroutine */ int LA_DSTEGR(char *jobz, char *range, integer *n, doublereal *
  d__, doublereal *e, doublereal *vl, doublereal *vu, integer *il,
  integer *iu, doublereal *abstol, integer *m, doublereal *w,
  doublereal *z__, integer *ldz, integer *isuppz, doublereal *work,
  integer *lwork, integer *iwork, integer *liwork, integer *info);

#define LA_DSTEIN F77_FUNC(dstein,DSTEIN)
/* Subroutine */ int LA_DSTEIN(integer *n, doublereal *d__, doublereal *e,
  integer *m, doublereal *w, integer *iblock, integer *isplit,
  doublereal *z__, integer *ldz, doublereal *work, integer *iwork,
  integer *ifail, integer *info);

#define LA_DSTEQR F77_FUNC(dsteqr,DSTEQR)
/* Subroutine */ int LA_DSTEQR(char *compz, integer *n, doublereal *d__,
  doublereal *e, doublereal *z__, integer *ldz, doublereal *work,
  integer *info);

#define LA_DSTERF F77_FUNC(dsterf,DSTERF)
/* Subroutine */ int LA_DSTERF(integer *n, doublereal *d__, doublereal *e,
  integer *info);

#define LA_DSTEV F77_FUNC(dstev,DSTEV)
/* Subroutine */ int LA_DSTEV(char *jobz, integer *n, doublereal *d__,
  doublereal *e, doublereal *z__, integer *ldz, doublereal *work,
  integer *info);

#define LA_DSTEVD F77_FUNC(dstevd,DSTEVD)
/* Subroutine */ int LA_DSTEVD(char *jobz, integer *n, doublereal *d__,
  doublereal *e, doublereal *z__, integer *ldz, doublereal *work,
  integer *lwork, integer *iwork, integer *liwork, integer *info);

#define LA_DSTEVR F77_FUNC(dstevr,DSTEVR)
/* Subroutine */ int LA_DSTEVR(char *jobz, char *range, integer *n, doublereal *
  d__, doublereal *e, doublereal *vl, doublereal *vu, integer *il,
  integer *iu, doublereal *abstol, integer *m, doublereal *w,
  doublereal *z__, integer *ldz, integer *isuppz, doublereal *work,
  integer *lwork, integer *iwork, integer *liwork, integer *info);

#define LA_DSTEVX F77_FUNC(dstevx,DSTEVX)
/* Subroutine */ int LA_DSTEVX(char *jobz, char *range, integer *n, doublereal *
  d__, doublereal *e, doublereal *vl, doublereal *vu, integer *il,
  integer *iu, doublereal *abstol, integer *m, doublereal *w,
  doublereal *z__, integer *ldz, doublereal *work, integer *iwork,
  integer *ifail, integer *info);

#define LA_DSYCON F77_FUNC(dsycon,DSYCON)
/* Subroutine */ int LA_DSYCON(char *uplo, integer *n, doublereal *a, integer *
  lda, integer *ipiv, doublereal *anorm, doublereal *rcond, doublereal *
  work, integer *iwork, integer *info);

#define LA_DSYEV F77_FUNC(dsyev,DSYEV)
/* Subroutine */ int LA_DSYEV(char *jobz, char *uplo, integer *n, doublereal *a,
   integer *lda, doublereal *w, doublereal *work, integer *lwork,
  integer *info);

#define LA_DSYEVD F77_FUNC(dsyevd,DSYEVD)
/* Subroutine */ int LA_DSYEVD(char *jobz, char *uplo, integer *n, doublereal *
  a, integer *lda, doublereal *w, doublereal *work, integer *lwork,
  integer *iwork, integer *liwork, integer *info);

#define LA_DSYEVR F77_FUNC(dsyevr,DSYEVR)
/* Subroutine */ int LA_DSYEVR(char *jobz, char *range, char *uplo, integer *n,
  doublereal *a, integer *lda, doublereal *vl, doublereal *vu, integer *
  il, integer *iu, doublereal *abstol, integer *m, doublereal *w,
  doublereal *z__, integer *ldz, integer *isuppz, doublereal *work,
  integer *lwork, integer *iwork, integer *liwork, integer *info);

#define LA_DSYEVX F77_FUNC(dsyevx,DSYEVX)
/* Subroutine */ int LA_DSYEVX(char *jobz, char *range, char *uplo, integer *n,
  doublereal *a, integer *lda, doublereal *vl, doublereal *vu, integer *
  il, integer *iu, doublereal *abstol, integer *m, doublereal *w,
  doublereal *z__, integer *ldz, doublereal *work, integer *lwork,
  integer *iwork, integer *ifail, integer *info);

#define LA_DSYGS2 F77_FUNC(dsygs2,DSYGS2)
/* Subroutine */ int LA_DSYGS2(integer *itype, char *uplo, integer *n,
  doublereal *a, integer *lda, doublereal *b, integer *ldb, integer *
  info);

#define LA_DSYGST F77_FUNC(dsygst,DSYGST)
/* Subroutine */ int LA_DSYGST(integer *itype, char *uplo, integer *n,
  doublereal *a, integer *lda, doublereal *b, integer *ldb, integer *
  info);

#define LA_DSYGV F77_FUNC(dsygv,DSYGV)
/* Subroutine */ int LA_DSYGV(integer *itype, char *jobz, char *uplo, integer *
  n, doublereal *a, integer *lda, doublereal *b, integer *ldb,
  doublereal *w, doublereal *work, integer *lwork, integer *info);

#define LA_DSYGVD F77_FUNC(dsygvd,DSYGVD)
/* Subroutine */ int LA_DSYGVD(integer *itype, char *jobz, char *uplo, integer *
  n, doublereal *a, integer *lda, doublereal *b, integer *ldb,
  doublereal *w, doublereal *work, integer *lwork, integer *iwork,
  integer *liwork, integer *info);

#define LA_DSYGVX F77_FUNC(dsygvx,DSYGVX)
/* Subroutine */ int LA_DSYGVX(integer *itype, char *jobz, char *range, char *
  uplo, integer *n, doublereal *a, integer *lda, doublereal *b, integer
  *ldb, doublereal *vl, doublereal *vu, integer *il, integer *iu,
  doublereal *abstol, integer *m, doublereal *w, doublereal *z__,
  integer *ldz, doublereal *work, integer *lwork, integer *iwork,
  integer *ifail, integer *info);

#define LA_DSYRFS F77_FUNC(dsyrfs,DSYRFS)
/* Subroutine */ int LA_DSYRFS(char *uplo, integer *n, integer *nrhs,
  doublereal *a, integer *lda, doublereal *af, integer *ldaf, integer *
  ipiv, doublereal *b, integer *ldb, doublereal *x, integer *ldx,
  doublereal *ferr, doublereal *berr, doublereal *work, integer *iwork,
  integer *info);

#define LA_DSYSV F77_FUNC(dsysv,DSYSV)
/* Subroutine */ int LA_DSYSV(char *uplo, integer *n, integer *nrhs, doublereal
  *a, integer *lda, integer *ipiv, doublereal *b, integer *ldb,
  doublereal *work, integer *lwork, integer *info);

#define LA_DSYSVX F77_FUNC(dsysvx,DSYSVX)
/* Subroutine */ int LA_DSYSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, doublereal *a, integer *lda, doublereal *af, integer *ldaf,
  integer *ipiv, doublereal *b, integer *ldb, doublereal *x, integer *
  ldx, doublereal *rcond, doublereal *ferr, doublereal *berr,
  doublereal *work, integer *lwork, integer *iwork, integer *info);

#define LA_DSYTD2 F77_FUNC(dsytd2,DSYTD2)
/* Subroutine */ int LA_DSYTD2(char *uplo, integer *n, doublereal *a, integer *
  lda, doublereal *d__, doublereal *e, doublereal *tau, integer *info);

#define LA_DSYTF2 F77_FUNC(dsytf2,DSYTF2)
/* Subroutine */ int LA_DSYTF2(char *uplo, integer *n, doublereal *a, integer *
  lda, integer *ipiv, integer *info);

#define LA_DSYTRD F77_FUNC(dsytrd,DSYTRD)
/* Subroutine */ int LA_DSYTRD(char *uplo, integer *n, doublereal *a, integer *
  lda, doublereal *d__, doublereal *e, doublereal *tau, doublereal *
  work, integer *lwork, integer *info);

#define LA_DSYTRF F77_FUNC(dsytrf,DSYTRF)
/* Subroutine */ int LA_DSYTRF(char *uplo, integer *n, doublereal *a, integer *
  lda, integer *ipiv, doublereal *work, integer *lwork, integer *info);

#define LA_DSYTRI F77_FUNC(dsytri,DSYTRI)
/* Subroutine */ int LA_DSYTRI(char *uplo, integer *n, doublereal *a, integer *
  lda, integer *ipiv, doublereal *work, integer *info);

#define LA_DSYTRS F77_FUNC(dsytrs,DSYTRS)
/* Subroutine */ int LA_DSYTRS(char *uplo, integer *n, integer *nrhs,
  doublereal *a, integer *lda, integer *ipiv, doublereal *b, integer *
  ldb, integer *info);

#define LA_DTBCON F77_FUNC(dtbcon,DTBCON)
/* Subroutine */ int LA_DTBCON(char *norm, char *uplo, char *diag, integer *n,
  integer *kd, doublereal *ab, integer *ldab, doublereal *rcond,
  doublereal *work, integer *iwork, integer *info);

#define LA_DTBRFS F77_FUNC(dtbrfs,DTBRFS)
/* Subroutine */ int LA_DTBRFS(char *uplo, char *trans, char *diag, integer *n,
  integer *kd, integer *nrhs, doublereal *ab, integer *ldab, doublereal
  *b, integer *ldb, doublereal *x, integer *ldx, doublereal *ferr,
  doublereal *berr, doublereal *work, integer *iwork, integer *info);

#define LA_DTBTRS F77_FUNC(dtbtrs,DTBTRS)
/* Subroutine */ int LA_DTBTRS(char *uplo, char *trans, char *diag, integer *n,
  integer *kd, integer *nrhs, doublereal *ab, integer *ldab, doublereal
  *b, integer *ldb, integer *info);

#define LA_DTGEVC F77_FUNC(dtgevc,DTGEVC)
/* Subroutine */ int LA_DTGEVC(char *side, char *howmny, logical *select,
  integer *n, doublereal *a, integer *lda, doublereal *b, integer *ldb,
  doublereal *vl, integer *ldvl, doublereal *vr, integer *ldvr, integer
  *mm, integer *m, doublereal *work, integer *info);

#define LA_DTGEX2 F77_FUNC(dtgex2,DTGEX2)
/* Subroutine */ int LA_DTGEX2(logical *wantq, logical *wantz, integer *n,
  doublereal *a, integer *lda, doublereal *b, integer *ldb, doublereal *
  q, integer *ldq, doublereal *z__, integer *ldz, integer *j1, integer *
  n1, integer *n2, doublereal *work, integer *lwork, integer *info);

#define LA_DTGEXC F77_FUNC(dtgexc,DTGEXC)
/* Subroutine */ int LA_DTGEXC(logical *wantq, logical *wantz, integer *n,
  doublereal *a, integer *lda, doublereal *b, integer *ldb, doublereal *
  q, integer *ldq, doublereal *z__, integer *ldz, integer *ifst,
  integer *ilst, doublereal *work, integer *lwork, integer *info);

#define LA_DTGSEN F77_FUNC(dtgsen,DTGSEN)
/* Subroutine */ int LA_DTGSEN(integer *ijob, logical *wantq, logical *wantz,
  logical *select, integer *n, doublereal *a, integer *lda, doublereal *
  b, integer *ldb, doublereal *alphar, doublereal *alphai, doublereal *
  beta, doublereal *q, integer *ldq, doublereal *z__, integer *ldz,
  integer *m, doublereal *pl, doublereal *pr, doublereal *dif,
  doublereal *work, integer *lwork, integer *iwork, integer *liwork,
  integer *info);

#define LA_DTGSJA F77_FUNC(dtgsja,DTGSJA)
/* Subroutine */ int LA_DTGSJA(char *jobu, char *jobv, char *jobq, integer *m,
  integer *p, integer *n, integer *k, integer *l, doublereal *a,
  integer *lda, doublereal *b, integer *ldb, doublereal *tola,
  doublereal *tolb, doublereal *alpha, doublereal *beta, doublereal *u,
  integer *ldu, doublereal *v, integer *ldv, doublereal *q, integer *
  ldq, doublereal *work, integer *ncycle, integer *info);

#define LA_DTGSNA F77_FUNC(dtgsna,DTGSNA)
/* Subroutine */ int LA_DTGSNA(char *job, char *howmny, logical *select,
  integer *n, doublereal *a, integer *lda, doublereal *b, integer *ldb,
  doublereal *vl, integer *ldvl, doublereal *vr, integer *ldvr,
  doublereal *s, doublereal *dif, integer *mm, integer *m, doublereal *
  work, integer *lwork, integer *iwork, integer *info);

#define LA_DTGSY2 F77_FUNC(dtgsy2,DTGSY2)
/* Subroutine */ int LA_DTGSY2(char *trans, integer *ijob, integer *m, integer *
  n, doublereal *a, integer *lda, doublereal *b, integer *ldb,
  doublereal *c__, integer *ldc, doublereal *d__, integer *ldd,
  doublereal *e, integer *lde, doublereal *f, integer *ldf, doublereal *
  scale, doublereal *rdsum, doublereal *rdscal, integer *iwork, integer
  *pq, integer *info);

#define LA_DTGSYL F77_FUNC(dtgsyl,DTGSYL)
/* Subroutine */ int LA_DTGSYL(char *trans, integer *ijob, integer *m, integer *
  n, doublereal *a, integer *lda, doublereal *b, integer *ldb,
  doublereal *c__, integer *ldc, doublereal *d__, integer *ldd,
  doublereal *e, integer *lde, doublereal *f, integer *ldf, doublereal *
  scale, doublereal *dif, doublereal *work, integer *lwork, integer *
  iwork, integer *info);

#define LA_DTPCON F77_FUNC(dtpcon,DTPCON)
/* Subroutine */ int LA_DTPCON(char *norm, char *uplo, char *diag, integer *n,
  doublereal *ap, doublereal *rcond, doublereal *work, integer *iwork,
  integer *info);

#define LA_DTPRFS F77_FUNC(dtprfs,DTPRFS)
/* Subroutine */ int LA_DTPRFS(char *uplo, char *trans, char *diag, integer *n,
  integer *nrhs, doublereal *ap, doublereal *b, integer *ldb,
  doublereal *x, integer *ldx, doublereal *ferr, doublereal *berr,
  doublereal *work, integer *iwork, integer *info);

#define LA_DTPTRI F77_FUNC(dtptri,DTPTRI)
/* Subroutine */ int LA_DTPTRI(char *uplo, char *diag, integer *n, doublereal *
  ap, integer *info);

#define LA_DTPTRS F77_FUNC(dtptrs,DTPTRS)
/* Subroutine */ int LA_DTPTRS(char *uplo, char *trans, char *diag, integer *n,
  integer *nrhs, doublereal *ap, doublereal *b, integer *ldb, integer *
  info);

#define LA_DTRCON F77_FUNC(dtrcon,DTRCON)
/* Subroutine */ int LA_DTRCON(char *norm, char *uplo, char *diag, integer *n,
  doublereal *a, integer *lda, doublereal *rcond, doublereal *work,
  integer *iwork, integer *info);

#define LA_DTREVC F77_FUNC(dtrevc,DTREVC)
/* Subroutine */ int LA_DTREVC(char *side, char *howmny, logical *select,
  integer *n, doublereal *t, integer *ldt, doublereal *vl, integer *
  ldvl, doublereal *vr, integer *ldvr, integer *mm, integer *m,
  doublereal *work, integer *info);

#define LA_DTREXC F77_FUNC(dtrexc,DTREXC)
/* Subroutine */ int LA_DTREXC(char *compq, integer *n, doublereal *t, integer *
  ldt, doublereal *q, integer *ldq, integer *ifst, integer *ilst,
  doublereal *work, integer *info);

#define LA_DTRRFS F77_FUNC(dtrrfs,DTRRFS)
/* Subroutine */ int LA_DTRRFS(char *uplo, char *trans, char *diag, integer *n,
  integer *nrhs, doublereal *a, integer *lda, doublereal *b, integer *
  ldb, doublereal *x, integer *ldx, doublereal *ferr, doublereal *berr,
  doublereal *work, integer *iwork, integer *info);

#define LA_DTRSEN F77_FUNC(dtrsen,DTRSEN)
/* Subroutine */ int LA_DTRSEN(char *job, char *compq, logical *select, integer
  *n, doublereal *t, integer *ldt, doublereal *q, integer *ldq,
  doublereal *wr, doublereal *wi, integer *m, doublereal *s, doublereal
  *sep, doublereal *work, integer *lwork, integer *iwork, integer *
  liwork, integer *info);

#define LA_DTRSNA F77_FUNC(dtrsna,DTRSNA)
/* Subroutine */ int LA_DTRSNA(char *job, char *howmny, logical *select,
  integer *n, doublereal *t, integer *ldt, doublereal *vl, integer *
  ldvl, doublereal *vr, integer *ldvr, doublereal *s, doublereal *sep,
  integer *mm, integer *m, doublereal *work, integer *ldwork, integer *
  iwork, integer *info);

#define LA_DTRSYL F77_FUNC(dtrsyl,DTRSYL)
/* Subroutine */ int LA_DTRSYL(char *trana, char *tranb, integer *isgn, integer
  *m, integer *n, doublereal *a, integer *lda, doublereal *b, integer *
  ldb, doublereal *c__, integer *ldc, doublereal *scale, integer *info);

#define LA_DTRTI2 F77_FUNC(dtrti2,DTRTI2)
/* Subroutine */ int LA_DTRTI2(char *uplo, char *diag, integer *n, doublereal *
  a, integer *lda, integer *info);

#define LA_DTRTRI F77_FUNC(dtrtri,DTRTRI)
/* Subroutine */ int LA_DTRTRI(char *uplo, char *diag, integer *n, doublereal *
  a, integer *lda, integer *info);

#define LA_DTRTRS F77_FUNC(dtrtrs,DTRTRS)
/* Subroutine */ int LA_DTRTRS(char *uplo, char *trans, char *diag, integer *n,
  integer *nrhs, doublereal *a, integer *lda, doublereal *b, integer *
  ldb, integer *info);

#define LA_DTZRQF F77_FUNC(dtzrqf,DTZRQF)
/* Subroutine */ int LA_DTZRQF(integer *m, integer *n, doublereal *a, integer *
  lda, doublereal *tau, integer *info);

#define LA_DTZRZF F77_FUNC(dtzrzf,DTZRZF)
/* Subroutine */ int LA_DTZRZF(integer *m, integer *n, doublereal *a, integer *
  lda, doublereal *tau, doublereal *work, integer *lwork, integer *info);

integer icmax1_(integer *n, complex *cx, integer *incx);

integer ieeeck_(integer *ispec, real *zero, real *one);

integer ilaenv_(integer *ispec, char *name__, char *opts, integer *n1,
  integer *n2, integer *n3, integer *n4, ftnlen name_len, ftnlen
  opts_len);

integer izmax1_(integer *n, doublecomplex *cx, integer *incx);

#define LA_SBDSDC F77_FUNC(sbdsdc,SBDSDC)
/* Subroutine */ int LA_SBDSDC(char *uplo, char *compq, integer *n, real *d__,
  real *e, real *u, integer *ldu, real *vt, integer *ldvt, real *q,
  integer *iq, real *work, integer *iwork, integer *info);

#define LA_SBDSQR F77_FUNC(sbdsqr,SBDSQR)
/* Subroutine */ int LA_SBDSQR(char *uplo, integer *n, integer *ncvt, integer *
  nru, integer *ncc, real *d__, real *e, real *vt, integer *ldvt, real *
  u, integer *ldu, real *c__, integer *ldc, real *work, integer *info);

#define LA_SDISNA F77_FUNC(sdisna,SDISNA)
/* Subroutine */ int LA_SDISNA(char *job, integer *m, integer *n, real *d__,
  real *sep, integer *info);

#define LA_SGBBRD F77_FUNC(sgbbrd,SGBBRD)
/* Subroutine */ int LA_SGBBRD(char *vect, integer *m, integer *n, integer *ncc,
   integer *kl, integer *ku, real *ab, integer *ldab, real *d__, real *
  e, real *q, integer *ldq, real *pt, integer *ldpt, real *c__, integer
  *ldc, real *work, integer *info);

#define LA_SGBCON F77_FUNC(sgbcon,SGBCON)
/* Subroutine */ int LA_SGBCON(char *norm, integer *n, integer *kl, integer *ku,
   real *ab, integer *ldab, integer *ipiv, real *anorm, real *rcond,
  real *work, integer *iwork, integer *info);

#define LA_SGBEQU F77_FUNC(sgbequ,SGBEQU)
/* Subroutine */ int LA_SGBEQU(integer *m, integer *n, integer *kl, integer *ku,
   real *ab, integer *ldab, real *r__, real *c__, real *rowcnd, real *
  colcnd, real *amax, integer *info);

#define LA_SGBRFS F77_FUNC(sgbrfs,SGBRFS)
/* Subroutine */ int LA_SGBRFS(char *trans, integer *n, integer *kl, integer *
  ku, integer *nrhs, real *ab, integer *ldab, real *afb, integer *ldafb,
   integer *ipiv, real *b, integer *ldb, real *x, integer *ldx, real *
  ferr, real *berr, real *work, integer *iwork, integer *info);

#define LA_SGBSV F77_FUNC(sgbsv,SGBSV)
/* Subroutine */ int LA_SGBSV(integer *n, integer *kl, integer *ku, integer *
  nrhs, real *ab, integer *ldab, integer *ipiv, real *b, integer *ldb,
  integer *info);

#define LA_SGBSVX F77_FUNC(sgbsvx,SGBSVX)
/* Subroutine */ int LA_SGBSVX(char *fact, char *trans, integer *n, integer *kl,
   integer *ku, integer *nrhs, real *ab, integer *ldab, real *afb,
  integer *ldafb, integer *ipiv, char *equed, real *r__, real *c__,
  real *b, integer *ldb, real *x, integer *ldx, real *rcond, real *ferr,
   real *berr, real *work, integer *iwork, integer *info);

#define LA_SGBTF2 F77_FUNC(sgbtf2,SGBTF2)
/* Subroutine */ int LA_SGBTF2(integer *m, integer *n, integer *kl, integer *ku,
   real *ab, integer *ldab, integer *ipiv, integer *info);

#define LA_SGBTRF F77_FUNC(sgbtrf,SGBTRF)
/* Subroutine */ int LA_SGBTRF(integer *m, integer *n, integer *kl, integer *ku,
   real *ab, integer *ldab, integer *ipiv, integer *info);

#define LA_SGBTRS F77_FUNC(sgbtrs,SGBTRS)
/* Subroutine */ int LA_SGBTRS(char *trans, integer *n, integer *kl, integer *
  ku, integer *nrhs, real *ab, integer *ldab, integer *ipiv, real *b,
  integer *ldb, integer *info);

#define LA_SGEBAK F77_FUNC(sgebak,SGEBAK)
/* Subroutine */ int LA_SGEBAK(char *job, char *side, integer *n, integer *ilo,
  integer *ihi, real *scale, integer *m, real *v, integer *ldv, integer
  *info);

#define LA_SGEBAL F77_FUNC(sgebal,SGEBAL)
/* Subroutine */ int LA_SGEBAL(char *job, integer *n, real *a, integer *lda,
  integer *ilo, integer *ihi, real *scale, integer *info);

#define LA_SGEBD2 F77_FUNC(sgebd2,SGEBD2)
/* Subroutine */ int LA_SGEBD2(integer *m, integer *n, real *a, integer *lda,
  real *d__, real *e, real *tauq, real *taup, real *work, integer *info);

#define LA_SGEBRD F77_FUNC(sgebrd,SGEBRD)
/* Subroutine */ int LA_SGEBRD(integer *m, integer *n, real *a, integer *lda,
  real *d__, real *e, real *tauq, real *taup, real *work, integer *
  lwork, integer *info);

#define LA_SGECON F77_FUNC(sgecon,SGECON)
/* Subroutine */ int LA_SGECON(char *norm, integer *n, real *a, integer *lda,
  real *anorm, real *rcond, real *work, integer *iwork, integer *info);

#define LA_SGEEQU F77_FUNC(sgeequ,SGEEQU)
/* Subroutine */ int LA_SGEEQU(integer *m, integer *n, real *a, integer *lda,
  real *r__, real *c__, real *rowcnd, real *colcnd, real *amax, integer
  *info);

#define LA_SGEES F77_FUNC(sgees,SGEES)
/* Subroutine */ int LA_SGEES(char *jobvs, char *sort, L_fp select, integer *n,
  real *a, integer *lda, integer *sdim, real *wr, real *wi, real *vs,
  integer *ldvs, real *work, integer *lwork, logical *bwork, integer *
  info);

#define LA_SGEESX F77_FUNC(sgeesx,SGEESX)
/* Subroutine */ int LA_SGEESX(char *jobvs, char *sort, L_fp select, char *
  sense, integer *n, real *a, integer *lda, integer *sdim, real *wr,
  real *wi, real *vs, integer *ldvs, real *rconde, real *rcondv, real *
  work, integer *lwork, integer *iwork, integer *liwork, logical *bwork,
   integer *info);

#define LA_SGEEV F77_FUNC(sgeev,SGEEV)
/* Subroutine */ int LA_SGEEV(char *jobvl, char *jobvr, integer *n, real *a,
  integer *lda, real *wr, real *wi, real *vl, integer *ldvl, real *vr,
  integer *ldvr, real *work, integer *lwork, integer *info);

#define LA_SGEEVX F77_FUNC(sgeevx,SGEEVX)
/* Subroutine */ int LA_SGEEVX(char *balanc, char *jobvl, char *jobvr, char *
  sense, integer *n, real *a, integer *lda, real *wr, real *wi, real *
  vl, integer *ldvl, real *vr, integer *ldvr, integer *ilo, integer *
  ihi, real *scale, real *abnrm, real *rconde, real *rcondv, real *work,
   integer *lwork, integer *iwork, integer *info);

#define LA_SGEGS F77_FUNC(sgegs,SGEGS)
/* Subroutine */ int LA_SGEGS(char *jobvsl, char *jobvsr, integer *n, real *a,
  integer *lda, real *b, integer *ldb, real *alphar, real *alphai, real
  *beta, real *vsl, integer *ldvsl, real *vsr, integer *ldvsr, real *
  work, integer *lwork, integer *info);

#define LA_SGEGV F77_FUNC(sgegv,SGEGV)
/* Subroutine */ int LA_SGEGV(char *jobvl, char *jobvr, integer *n, real *a,
  integer *lda, real *b, integer *ldb, real *alphar, real *alphai, real
  *beta, real *vl, integer *ldvl, real *vr, integer *ldvr, real *work,
  integer *lwork, integer *info);

#define LA_SGEHD2 F77_FUNC(sgehd2,SGEHD2)
/* Subroutine */ int LA_SGEHD2(integer *n, integer *ilo, integer *ihi, real *a,
  integer *lda, real *tau, real *work, integer *info);

#define LA_SGEHRD F77_FUNC(sgehrd,SGEHRD)
/* Subroutine */ int LA_SGEHRD(integer *n, integer *ilo, integer *ihi, real *a,
  integer *lda, real *tau, real *work, integer *lwork, integer *info);

#define LA_SGELQ2 F77_FUNC(sgelq2,SGELQ2)
/* Subroutine */ int LA_SGELQ2(integer *m, integer *n, real *a, integer *lda,
  real *tau, real *work, integer *info);

#define LA_SGELQF F77_FUNC(sgelqf,SGELQF)
/* Subroutine */ int LA_SGELQF(integer *m, integer *n, real *a, integer *lda,
  real *tau, real *work, integer *lwork, integer *info);

#define LA_SGELS F77_FUNC(sgels,SGELS)
/* Subroutine */ int LA_SGELS(char *trans, integer *m, integer *n, integer *
  nrhs, real *a, integer *lda, real *b, integer *ldb, real *work,
  integer *lwork, integer *info);

#define LA_SGELSD F77_FUNC(sgelsd,SGELSD)
/* Subroutine */ int LA_SGELSD(integer *m, integer *n, integer *nrhs, real *a,
  integer *lda, real *b, integer *ldb, real *s, real *rcond, integer *
  rank, real *work, integer *lwork, integer *iwork, integer *info);

#define LA_SGELSS F77_FUNC(sgelss,SGELSS)
/* Subroutine */ int LA_SGELSS(integer *m, integer *n, integer *nrhs, real *a,
  integer *lda, real *b, integer *ldb, real *s, real *rcond, integer *
  rank, real *work, integer *lwork, integer *info);

#define LA_SGELSX F77_FUNC(sgelsx,SGELSX)
/* Subroutine */ int LA_SGELSX(integer *m, integer *n, integer *nrhs, real *a,
  integer *lda, real *b, integer *ldb, integer *jpvt, real *rcond,
  integer *rank, real *work, integer *info);

#define LA_SGELSY F77_FUNC(sgelsy,SGELSY)
/* Subroutine */ int LA_SGELSY(integer *m, integer *n, integer *nrhs, real *a,
  integer *lda, real *b, integer *ldb, integer *jpvt, real *rcond,
  integer *rank, real *work, integer *lwork, integer *info);

#define LA_SGEQL2 F77_FUNC(sgeql2,SGEQL2)
/* Subroutine */ int LA_SGEQL2(integer *m, integer *n, real *a, integer *lda,
  real *tau, real *work, integer *info);

#define LA_SGEQLF F77_FUNC(sgeqlf,SGEQLF)
/* Subroutine */ int LA_SGEQLF(integer *m, integer *n, real *a, integer *lda,
  real *tau, real *work, integer *lwork, integer *info);

#define LA_SGEQP3 F77_FUNC(sgeqp3,SGEQP3)
/* Subroutine */ int LA_SGEQP3(integer *m, integer *n, real *a, integer *lda,
  integer *jpvt, real *tau, real *work, integer *lwork, integer *info);

#define LA_SGEQPF F77_FUNC(sgeqpf,SGEQPF)
/* Subroutine */ int LA_SGEQPF(integer *m, integer *n, real *a, integer *lda,
  integer *jpvt, real *tau, real *work, integer *info);

#define LA_SGEQR2 F77_FUNC(sgeqr2,SGEQR2)
/* Subroutine */ int LA_SGEQR2(integer *m, integer *n, real *a, integer *lda,
  real *tau, real *work, integer *info);

#define LA_SGEQRF F77_FUNC(sgeqrf,SGEQRF)
/* Subroutine */ int LA_SGEQRF(integer *m, integer *n, real *a, integer *lda,
  real *tau, real *work, integer *lwork, integer *info);

#define LA_SGERFS F77_FUNC(sgerfs,SGERFS)
/* Subroutine */ int LA_SGERFS(char *trans, integer *n, integer *nrhs, real *a,
  integer *lda, real *af, integer *ldaf, integer *ipiv, real *b,
  integer *ldb, real *x, integer *ldx, real *ferr, real *berr, real *
  work, integer *iwork, integer *info);

#define LA_SGERQ2 F77_FUNC(sgerq2,SGERQ2)
/* Subroutine */ int LA_SGERQ2(integer *m, integer *n, real *a, integer *lda,
  real *tau, real *work, integer *info);

#define LA_SGERQF F77_FUNC(sgerqf,SGERQF)
/* Subroutine */ int LA_SGERQF(integer *m, integer *n, real *a, integer *lda,
  real *tau, real *work, integer *lwork, integer *info);

#define LA_SGESC2 F77_FUNC(sgesc2,SGESC2)
/* Subroutine */ int LA_SGESC2(integer *n, real *a, integer *lda, real *rhs,
  integer *ipiv, integer *jpiv, real *scale);

#define LA_SGESDD F77_FUNC(sgesdd,SGESDD)
/* Subroutine */ int LA_SGESDD(char *jobz, integer *m, integer *n, real *a,
  integer *lda, real *s, real *u, integer *ldu, real *vt, integer *ldvt,
   real *work, integer *lwork, integer *iwork, integer *info);

#define LA_SGESV F77_FUNC(sgesv,SGESV)
/* Subroutine */ int LA_SGESV(integer *n, integer *nrhs, real *a, integer *lda,
  integer *ipiv, real *b, integer *ldb, integer *info);

#define LA_SGESVD F77_FUNC(sgesvd,SGESVD)
/* Subroutine */ int LA_SGESVD(char *jobu, char *jobvt, integer *m, integer *n,
  real *a, integer *lda, real *s, real *u, integer *ldu, real *vt,
  integer *ldvt, real *work, integer *lwork, integer *info);

#define LA_SGESVX F77_FUNC(sgesvx,SGESVX)
/* Subroutine */ int LA_SGESVX(char *fact, char *trans, integer *n, integer *
  nrhs, real *a, integer *lda, real *af, integer *ldaf, integer *ipiv,
  char *equed, real *r__, real *c__, real *b, integer *ldb, real *x,
  integer *ldx, real *rcond, real *ferr, real *berr, real *work,
  integer *iwork, integer *info);

#define LA_SGETC2 F77_FUNC(sgetc2,SGETC2)
/* Subroutine */ int LA_SGETC2(integer *n, real *a, integer *lda, integer *ipiv,
   integer *jpiv, integer *info);

#define LA_SGETF2 F77_FUNC(sgetf2,SGETF2)
/* Subroutine */ int LA_SGETF2(integer *m, integer *n, real *a, integer *lda,
  integer *ipiv, integer *info);

#define LA_SGETRF F77_FUNC(sgetrf,SGETRF)
/* Subroutine */ int LA_SGETRF(integer *m, integer *n, real *a, integer *lda,
  integer *ipiv, integer *info);

#define LA_SGETRI F77_FUNC(sgetri,SGETRI)
/* Subroutine */ int LA_SGETRI(integer *n, real *a, integer *lda, integer *ipiv,
   real *work, integer *lwork, integer *info);

#define LA_SGETRS F77_FUNC(sgetrs,SGETRS)
/* Subroutine */ int LA_SGETRS(char *trans, integer *n, integer *nrhs, real *a,
  integer *lda, integer *ipiv, real *b, integer *ldb, integer *info);

#define LA_SGGBAK F77_FUNC(sggbak,SGGBAK)
/* Subroutine */ int LA_SGGBAK(char *job, char *side, integer *n, integer *ilo,
  integer *ihi, real *lscale, real *rscale, integer *m, real *v,
  integer *ldv, integer *info);

#define LA_SGGBAL F77_FUNC(sggbal,SGGBAL)
/* Subroutine */ int LA_SGGBAL(char *job, integer *n, real *a, integer *lda,
  real *b, integer *ldb, integer *ilo, integer *ihi, real *lscale, real
  *rscale, real *work, integer *info);

#define LA_SGGES F77_FUNC(sgges,SGGES)
/* Subroutine */ int LA_SGGES(char *jobvsl, char *jobvsr, char *sort, L_fp
  selctg, integer *n, real *a, integer *lda, real *b, integer *ldb,
  integer *sdim, real *alphar, real *alphai, real *beta, real *vsl,
  integer *ldvsl, real *vsr, integer *ldvsr, real *work, integer *lwork,
   logical *bwork, integer *info);

#define LA_SGGESX F77_FUNC(sggesx,SGGESX)
/* Subroutine */ int LA_SGGESX(char *jobvsl, char *jobvsr, char *sort, L_fp
  selctg, char *sense, integer *n, real *a, integer *lda, real *b,
  integer *ldb, integer *sdim, real *alphar, real *alphai, real *beta,
  real *vsl, integer *ldvsl, real *vsr, integer *ldvsr, real *rconde,
  real *rcondv, real *work, integer *lwork, integer *iwork, integer *
  liwork, logical *bwork, integer *info);

#define LA_SGGEV F77_FUNC(sggev,SGGEV)
/* Subroutine */ int LA_SGGEV(char *jobvl, char *jobvr, integer *n, real *a,
  integer *lda, real *b, integer *ldb, real *alphar, real *alphai, real
  *beta, real *vl, integer *ldvl, real *vr, integer *ldvr, real *work,
  integer *lwork, integer *info);

#define LA_SGGEVX F77_FUNC(sggevx,SGGEVX)
/* Subroutine */ int LA_SGGEVX(char *balanc, char *jobvl, char *jobvr, char *
  sense, integer *n, real *a, integer *lda, real *b, integer *ldb, real
  *alphar, real *alphai, real *beta, real *vl, integer *ldvl, real *vr,
  integer *ldvr, integer *ilo, integer *ihi, real *lscale, real *rscale,
   real *abnrm, real *bbnrm, real *rconde, real *rcondv, real *work,
  integer *lwork, integer *iwork, logical *bwork, integer *info);

#define LA_SGGGLM F77_FUNC(sggglm,SGGGLM)
/* Subroutine */ int LA_SGGGLM(integer *n, integer *m, integer *p, real *a,
  integer *lda, real *b, integer *ldb, real *d__, real *x, real *y,
  real *work, integer *lwork, integer *info);

#define LA_SGGHRD F77_FUNC(sgghrd,SGGHRD)
/* Subroutine */ int LA_SGGHRD(char *compq, char *compz, integer *n, integer *
  ilo, integer *ihi, real *a, integer *lda, real *b, integer *ldb, real
  *q, integer *ldq, real *z__, integer *ldz, integer *info);

#define LA_SGGLSE F77_FUNC(sgglse,SGGLSE)
/* Subroutine */ int LA_SGGLSE(integer *m, integer *n, integer *p, real *a,
  integer *lda, real *b, integer *ldb, real *c__, real *d__, real *x,
  real *work, integer *lwork, integer *info);

#define LA_SGGQRF F77_FUNC(sggqrf,SGGQRF)
/* Subroutine */ int LA_SGGQRF(integer *n, integer *m, integer *p, real *a,
  integer *lda, real *taua, real *b, integer *ldb, real *taub, real *
  work, integer *lwork, integer *info);

#define LA_SGGRQF F77_FUNC(sggrqf,SGGRQF)
/* Subroutine */ int LA_SGGRQF(integer *m, integer *p, integer *n, real *a,
  integer *lda, real *taua, real *b, integer *ldb, real *taub, real *
  work, integer *lwork, integer *info);

#define LA_SGGSVD F77_FUNC(sggsvd,SGGSVD)
/* Subroutine */ int LA_SGGSVD(char *jobu, char *jobv, char *jobq, integer *m,
  integer *n, integer *p, integer *k, integer *l, real *a, integer *lda,
   real *b, integer *ldb, real *alpha, real *beta, real *u, integer *
  ldu, real *v, integer *ldv, real *q, integer *ldq, real *work,
  integer *iwork, integer *info);

#define LA_SGGSVP F77_FUNC(sggsvp,SGGSVP)
/* Subroutine */ int LA_SGGSVP(char *jobu, char *jobv, char *jobq, integer *m,
  integer *p, integer *n, real *a, integer *lda, real *b, integer *ldb,
  real *tola, real *tolb, integer *k, integer *l, real *u, integer *ldu,
   real *v, integer *ldv, real *q, integer *ldq, integer *iwork, real *
  tau, real *work, integer *info);

#define LA_SGTCON F77_FUNC(sgtcon,SGTCON)
/* Subroutine */ int LA_SGTCON(char *norm, integer *n, real *dl, real *d__,
  real *du, real *du2, integer *ipiv, real *anorm, real *rcond, real *
  work, integer *iwork, integer *info);

#define LA_SGTRFS F77_FUNC(sgtrfs,SGTRFS)
/* Subroutine */ int LA_SGTRFS(char *trans, integer *n, integer *nrhs, real *dl,
   real *d__, real *du, real *dlf, real *df, real *duf, real *du2,
  integer *ipiv, real *b, integer *ldb, real *x, integer *ldx, real *
  ferr, real *berr, real *work, integer *iwork, integer *info);

#define LA_SGTSV F77_FUNC(sgtsv,SGTSV)
/* Subroutine */ int LA_SGTSV(integer *n, integer *nrhs, real *dl, real *d__,
  real *du, real *b, integer *ldb, integer *info);

#define LA_SGTSVX F77_FUNC(sgtsvx,SGTSVX)
/* Subroutine */ int LA_SGTSVX(char *fact, char *trans, integer *n, integer *
  nrhs, real *dl, real *d__, real *du, real *dlf, real *df, real *duf,
  real *du2, integer *ipiv, real *b, integer *ldb, real *x, integer *
  ldx, real *rcond, real *ferr, real *berr, real *work, integer *iwork,
  integer *info);

#define LA_SGTTRF F77_FUNC(sgttrf,SGTTRF)
/* Subroutine */ int LA_SGTTRF(integer *n, real *dl, real *d__, real *du, real *
  du2, integer *ipiv, integer *info);

#define LA_SGTTRS F77_FUNC(sgttrs,SGTTRS)
/* Subroutine */ int LA_SGTTRS(char *trans, integer *n, integer *nrhs, real *dl,
   real *d__, real *du, real *du2, integer *ipiv, real *b, integer *ldb,
   integer *info);

#define LA_SGTTS2 F77_FUNC(sgtts2,SGTTS2)
/* Subroutine */ int LA_SGTTS2(integer *itrans, integer *n, integer *nrhs, real
  *dl, real *d__, real *du, real *du2, integer *ipiv, real *b, integer *
  ldb);

#define LA_SHGEQZ F77_FUNC(shgeqz,SHGEQZ)
/* Subroutine */ int LA_SHGEQZ(char *job, char *compq, char *compz, integer *n,
  integer *ilo, integer *ihi, real *a, integer *lda, real *b, integer *
  ldb, real *alphar, real *alphai, real *beta, real *q, integer *ldq,
  real *z__, integer *ldz, real *work, integer *lwork, integer *info);

#define LA_SHSEIN F77_FUNC(shsein,SHSEIN)
/* Subroutine */ int LA_SHSEIN(char *side, char *eigsrc, char *initv, logical *
  select, integer *n, real *h__, integer *ldh, real *wr, real *wi, real
  *vl, integer *ldvl, real *vr, integer *ldvr, integer *mm, integer *m,
  real *work, integer *ifaill, integer *ifailr, integer *info);

#define LA_SHSEQR F77_FUNC(shseqr,SHSEQR)
/* Subroutine */ int LA_SHSEQR(char *job, char *compz, integer *n, integer *ilo,
   integer *ihi, real *h__, integer *ldh, real *wr, real *wi, real *z__,
   integer *ldz, real *work, integer *lwork, integer *info);

#define LA_SLABAD F77_FUNC(slabad,SLABAD)
/* Subroutine */ int LA_SLABAD(real *small, real *large);

#define LA_SLABRD F77_FUNC(slabrd,SLABRD)
/* Subroutine */ int LA_SLABRD(integer *m, integer *n, integer *nb, real *a,
  integer *lda, real *d__, real *e, real *tauq, real *taup, real *x,
  integer *ldx, real *y, integer *ldy);

#define LA_SLACON F77_FUNC(slacon,SLACON)
/* Subroutine */ int LA_SLACON(integer *n, real *v, real *x, integer *isgn,
  real *est, integer *kase);

#define LA_SLACPY F77_FUNC(slacpy,SLACPY)
/* Subroutine */ int LA_SLACPY(char *uplo, integer *m, integer *n, real *a,
  integer *lda, real *b, integer *ldb);

#define LA_SLADIV F77_FUNC(sladiv,SLADIV)
/* Subroutine */ int LA_SLADIV(real *a, real *b, real *c__, real *d__, real *p,
  real *q);

#define LA_SLAE2 F77_FUNC(slae2,SLAE2)
/* Subroutine */ int LA_SLAE2(real *a, real *b, real *c__, real *rt1, real *rt2);

#define LA_SLAEBZ F77_FUNC(slaebz,SLAEBZ)
/* Subroutine */ int LA_SLAEBZ(integer *ijob, integer *nitmax, integer *n,
  integer *mmax, integer *minp, integer *nbmin, real *abstol, real *
  reltol, real *pivmin, real *d__, real *e, real *e2, integer *nval,
  real *ab, real *c__, integer *mout, integer *nab, real *work, integer
  *iwork, integer *info);

#define LA_SLAED0 F77_FUNC(slaed0,SLAED0)
/* Subroutine */ int LA_SLAED0(integer *icompq, integer *qsiz, integer *n, real
  *d__, real *e, real *q, integer *ldq, real *qstore, integer *ldqs,
  real *work, integer *iwork, integer *info);

#define LA_SLAED1 F77_FUNC(slaed1,SLAED1)
/* Subroutine */ int LA_SLAED1(integer *n, real *d__, real *q, integer *ldq,
  integer *indxq, real *rho, integer *cutpnt, real *work, integer *
  iwork, integer *info);

#define LA_SLAED2 F77_FUNC(slaed2,SLAED2)
/* Subroutine */ int LA_SLAED2(integer *k, integer *n, integer *n1, real *d__,
  real *q, integer *ldq, integer *indxq, real *rho, real *z__, real *
  dlamda, real *w, real *q2, integer *indx, integer *indxc, integer *
  indxp, integer *coltyp, integer *info);

#define LA_SLAED3 F77_FUNC(slaed3,SLAED3)
/* Subroutine */ int LA_SLAED3(integer *k, integer *n, integer *n1, real *d__,
  real *q, integer *ldq, real *rho, real *dlamda, real *q2, integer *
  indx, integer *ctot, real *w, real *s, integer *info);

#define LA_SLAED4 F77_FUNC(slaed4,SLAED4)
/* Subroutine */ int LA_SLAED4(integer *n, integer *i__, real *d__, real *z__,
  real *delta, real *rho, real *dlam, integer *info);

#define LA_SLAED5 F77_FUNC(slaed5,SLAED5)
/* Subroutine */ int LA_SLAED5(integer *i__, real *d__, real *z__, real *delta,
  real *rho, real *dlam);

#define LA_SLAED6 F77_FUNC(slaed6,SLAED6)
/* Subroutine */ int LA_SLAED6(integer *kniter, logical *orgati, real *rho,
  real *d__, real *z__, real *finit, real *tau, integer *info);

#define LA_SLAED7 F77_FUNC(slaed7,SLAED7)
/* Subroutine */ int LA_SLAED7(integer *icompq, integer *n, integer *qsiz,
  integer *tlvls, integer *curlvl, integer *curpbm, real *d__, real *q,
  integer *ldq, integer *indxq, real *rho, integer *cutpnt, real *
  qstore, integer *qptr, integer *prmptr, integer *perm, integer *
  givptr, integer *givcol, real *givnum, real *work, integer *iwork,
  integer *info);

#define LA_SLAED8 F77_FUNC(slaed8,SLAED8)
/* Subroutine */ int LA_SLAED8(integer *icompq, integer *k, integer *n, integer
  *qsiz, real *d__, real *q, integer *ldq, integer *indxq, real *rho,
  integer *cutpnt, real *z__, real *dlamda, real *q2, integer *ldq2,
  real *w, integer *perm, integer *givptr, integer *givcol, real *
  givnum, integer *indxp, integer *indx, integer *info);

#define LA_SLAED9 F77_FUNC(slaed9,SLAED9)
/* Subroutine */ int LA_SLAED9(integer *k, integer *kstart, integer *kstop,
  integer *n, real *d__, real *q, integer *ldq, real *rho, real *dlamda,
   real *w, real *s, integer *lds, integer *info);

#define LA_SLAEDA F77_FUNC(slaeda,SLAEDA)
/* Subroutine */ int LA_SLAEDA(integer *n, integer *tlvls, integer *curlvl,
  integer *curpbm, integer *prmptr, integer *perm, integer *givptr,
  integer *givcol, real *givnum, real *q, integer *qptr, real *z__,
  real *ztemp, integer *info);

#define LA_SLAEIN F77_FUNC(slaein,SLAEIN)
/* Subroutine */ int LA_SLAEIN(logical *rightv, logical *noinit, integer *n,
  real *h__, integer *ldh, real *wr, real *wi, real *vr, real *vi, real
  *b, integer *ldb, real *work, real *eps3, real *smlnum, real *bignum,
  integer *info);

#define LA_SLAEV2 F77_FUNC(slaev2,SLAEV2)
/* Subroutine */ int LA_SLAEV2(real *a, real *b, real *c__, real *rt1, real *
  rt2, real *cs1, real *sn1);

#define LA_SLAEXC F77_FUNC(slaexc,SLAEXC)
/* Subroutine */ int LA_SLAEXC(logical *wantq, integer *n, real *t, integer *
  ldt, real *q, integer *ldq, integer *j1, integer *n1, integer *n2,
  real *work, integer *info);

#define LA_SLAG2 F77_FUNC(slag2,SLAG2)
/* Subroutine */ int LA_SLAG2(real *a, integer *lda, real *b, integer *ldb,
  real *safmin, real *scale1, real *scale2, real *wr1, real *wr2, real *
  wi);

#define LA_SLAGS2 F77_FUNC(slags2,SLAGS2)
/* Subroutine */ int LA_SLAGS2(logical *upper, real *a1, real *a2, real *a3,
  real *b1, real *b2, real *b3, real *csu, real *snu, real *csv, real *
  snv, real *csq, real *snq);

#define LA_SLAGTF F77_FUNC(slagtf,SLAGTF)
/* Subroutine */ int LA_SLAGTF(integer *n, real *a, real *lambda, real *b, real
  *c__, real *tol, real *d__, integer *in, integer *info);

#define LA_SLAGTM F77_FUNC(slagtm,SLAGTM)
/* Subroutine */ int LA_SLAGTM(char *trans, integer *n, integer *nrhs, real *
  alpha, real *dl, real *d__, real *du, real *x, integer *ldx, real *
  beta, real *b, integer *ldb);

#define LA_SLAGTS F77_FUNC(slagts,SLAGTS)
/* Subroutine */ int LA_SLAGTS(integer *job, integer *n, real *a, real *b, real
  *c__, real *d__, integer *in, real *y, real *tol, integer *info);

#define LA_SLAGV2 F77_FUNC(slagv2,SLAGV2)
/* Subroutine */ int LA_SLAGV2(real *a, integer *lda, real *b, integer *ldb,
  real *alphar, real *alphai, real *beta, real *csl, real *snl, real *
  csr, real *snr);

#define LA_SLAHQR F77_FUNC(slahqr,SLAHQR)
/* Subroutine */ int LA_SLAHQR(logical *wantt, logical *wantz, integer *n,
  integer *ilo, integer *ihi, real *h__, integer *ldh, real *wr, real *
  wi, integer *iloz, integer *ihiz, real *z__, integer *ldz, integer *
  info);

#define LA_SLAHRD F77_FUNC(slahrd,SLAHRD)
/* Subroutine */ int LA_SLAHRD(integer *n, integer *k, integer *nb, real *a,
  integer *lda, real *tau, real *t, integer *ldt, real *y, integer *ldy);

#define LA_SLAIC1 F77_FUNC(slaic1,SLAIC1)
/* Subroutine */ int LA_SLAIC1(integer *job, integer *j, real *x, real *sest,
  real *w, real *gamma, real *sestpr, real *s, real *c__);

#define LA_SLALN2 F77_FUNC(slaln2,SLALN2)
/* Subroutine */ int LA_SLALN2(logical *ltrans, integer *na, integer *nw, real *
  smin, real *ca, real *a, integer *lda, real *d1, real *d2, real *b,
  integer *ldb, real *wr, real *wi, real *x, integer *ldx, real *scale,
  real *xnorm, integer *info);

#define LA_SLALS0 F77_FUNC(slals0,SLALS0)
/* Subroutine */ int LA_SLALS0(integer *icompq, integer *nl, integer *nr,
  integer *sqre, integer *nrhs, real *b, integer *ldb, real *bx,
  integer *ldbx, integer *perm, integer *givptr, integer *givcol,
  integer *ldgcol, real *givnum, integer *ldgnum, real *poles, real *
  difl, real *difr, real *z__, integer *k, real *c__, real *s, real *
  work, integer *info);

#define LA_SLALSA F77_FUNC(slalsa,SLALSA)
/* Subroutine */ int LA_SLALSA(integer *icompq, integer *smlsiz, integer *n,
  integer *nrhs, real *b, integer *ldb, real *bx, integer *ldbx, real *
  u, integer *ldu, real *vt, integer *k, real *difl, real *difr, real *
  z__, real *poles, integer *givptr, integer *givcol, integer *ldgcol,
  integer *perm, real *givnum, real *c__, real *s, real *work, integer *
  iwork, integer *info);

#define LA_SLALSD F77_FUNC(slalsd,SLALSD)
/* Subroutine */ int LA_SLALSD(char *uplo, integer *smlsiz, integer *n, integer
  *nrhs, real *d__, real *e, real *b, integer *ldb, real *rcond,
  integer *rank, real *work, integer *iwork, integer *info);

#define LA_SLAMC1 F77_FUNC(slamc1,SLAMC1)
/* Subroutine */ int LA_SLAMC1(integer *beta, integer *t, logical *rnd, logical
  *ieee1);

#define LA_SLAMC2 F77_FUNC(slamc2,SLAMC2)
/* Subroutine */ int LA_SLAMC2(integer *beta, integer *t, logical *rnd, real *
  eps, integer *emin, real *rmin, integer *emax, real *rmax);

#define LA_SLAMC4 F77_FUNC(slamc4,SLAMC4)
/* Subroutine */ int LA_SLAMC4(integer *emin, real *start, integer *base);

#define LA_SLAMC5 F77_FUNC(slamc5,SLAMC5)
/* Subroutine */ int LA_SLAMC5(integer *beta, integer *p, integer *emin,
  logical *ieee, integer *emax, real *rmax);

#define LA_SLAMRG F77_FUNC(slamrg,SLAMRG)
/* Subroutine */ int LA_SLAMRG(integer *n1, integer *n2, real *a, integer *
  strd1, integer *strd2, integer *index);

#define LA_SLANV2 F77_FUNC(slanv2,SLANV2)
/* Subroutine */ int LA_SLANV2(real *a, real *b, real *c__, real *d__, real *
  rt1r, real *rt1i, real *rt2r, real *rt2i, real *cs, real *sn);

#define LA_SLAPLL F77_FUNC(slapll,SLAPLL)
/* Subroutine */ int LA_SLAPLL(integer *n, real *x, integer *incx, real *y,
  integer *incy, real *ssmin);

#define LA_SLAPMT F77_FUNC(slapmt,SLAPMT)
/* Subroutine */ int LA_SLAPMT(logical *forwrd, integer *m, integer *n, real *x,
   integer *ldx, integer *k);

#define LA_SLAQGB F77_FUNC(slaqgb,SLAQGB)
/* Subroutine */ int LA_SLAQGB(integer *m, integer *n, integer *kl, integer *ku,
   real *ab, integer *ldab, real *r__, real *c__, real *rowcnd, real *
  colcnd, real *amax, char *equed);

#define LA_SLAQGE F77_FUNC(slaqge,SLAQGE)
/* Subroutine */ int LA_SLAQGE(integer *m, integer *n, real *a, integer *lda,
  real *r__, real *c__, real *rowcnd, real *colcnd, real *amax, char *
  equed);

#define LA_SLAQP2 F77_FUNC(slaqp2,SLAQP2)
/* Subroutine */ int LA_SLAQP2(integer *m, integer *n, integer *offset, real *a,
   integer *lda, integer *jpvt, real *tau, real *vn1, real *vn2, real *
  work);

#define LA_SLAQPS F77_FUNC(slaqps,SLAQPS)
/* Subroutine */ int LA_SLAQPS(integer *m, integer *n, integer *offset, integer
  *nb, integer *kb, real *a, integer *lda, integer *jpvt, real *tau,
  real *vn1, real *vn2, real *auxv, real *f, integer *ldf);

#define LA_SLAQSB F77_FUNC(slaqsb,SLAQSB)
/* Subroutine */ int LA_SLAQSB(char *uplo, integer *n, integer *kd, real *ab,
  integer *ldab, real *s, real *scond, real *amax, char *equed);

#define LA_SLAQSP F77_FUNC(slaqsp,SLAQSP)
/* Subroutine */ int LA_SLAQSP(char *uplo, integer *n, real *ap, real *s, real *
  scond, real *amax, char *equed);

#define LA_SLAQSY F77_FUNC(slaqsy,SLAQSY)
/* Subroutine */ int LA_SLAQSY(char *uplo, integer *n, real *a, integer *lda,
  real *s, real *scond, real *amax, char *equed);

#define LA_SLAQTR F77_FUNC(slaqtr,SLAQTR)
/* Subroutine */ int LA_SLAQTR(logical *ltran, logical *lreal, integer *n, real
  *t, integer *ldt, real *b, real *w, real *scale, real *x, real *work,
  integer *info);

#define LA_SLAR1V F77_FUNC(slar1v,SLAR1V)
/* Subroutine */ int LA_SLAR1V(integer *n, integer *b1, integer *bn, real *
  sigma, real *d__, real *l, real *ld, real *lld, real *gersch, real *
  z__, real *ztz, real *mingma, integer *r__, integer *isuppz, real *
  work);

#define LA_SLAR2V F77_FUNC(slar2v,SLAR2V)
/* Subroutine */ int LA_SLAR2V(integer *n, real *x, real *y, real *z__, integer
  *incx, real *c__, real *s, integer *incc);

#define LA_SLARF F77_FUNC(slarf,SLARF)
/* Subroutine */ int LA_SLARF(char *side, integer *m, integer *n, real *v,
  integer *incv, real *tau, real *c__, integer *ldc, real *work);

#define LA_SLARFB F77_FUNC(slarfb,SLARFB)
/* Subroutine */ int LA_SLARFB(char *side, char *trans, char *direct, char *
  storev, integer *m, integer *n, integer *k, real *v, integer *ldv,
  real *t, integer *ldt, real *c__, integer *ldc, real *work, integer *
  ldwork);

#define LA_SLARFG F77_FUNC(slarfg,SLARFG)
/* Subroutine */ int LA_SLARFG(integer *n, real *alpha, real *x, integer *incx,
  real *tau);

#define LA_SLARFT F77_FUNC(slarft,SLARFT)
/* Subroutine */ int LA_SLARFT(char *direct, char *storev, integer *n, integer *
  k, real *v, integer *ldv, real *tau, real *t, integer *ldt);

#define LA_SLARFX F77_FUNC(slarfx,SLARFX)
/* Subroutine */ int LA_SLARFX(char *side, integer *m, integer *n, real *v,
  real *tau, real *c__, integer *ldc, real *work);

#define LA_SLARGV F77_FUNC(slargv,SLARGV)
/* Subroutine */ int LA_SLARGV(integer *n, real *x, integer *incx, real *y,
  integer *incy, real *c__, integer *incc);

#define LA_SLARNV F77_FUNC(slarnv,SLARNV)
/* Subroutine */ int LA_SLARNV(integer *idist, integer *iseed, integer *n, real
  *x);

#define LA_SLARRB F77_FUNC(slarrb,SLARRB)
/* Subroutine */ int LA_SLARRB(integer *n, real *d__, real *l, real *ld, real *
  lld, integer *ifirst, integer *ilast, real *sigma, real *reltol, real
  *w, real *wgap, real *werr, real *work, integer *iwork, integer *info);

#define LA_SLARRE F77_FUNC(slarre,SLARRE)
/* Subroutine */ int LA_SLARRE(integer *n, real *d__, real *e, real *tol,
  integer *nsplit, integer *isplit, integer *m, real *w, real *woff,
  real *gersch, real *work, integer *info);

#define LA_SLARRF F77_FUNC(slarrf,SLARRF)
/* Subroutine */ int LA_SLARRF(integer *n, real *d__, real *l, real *ld, real *
  lld, integer *ifirst, integer *ilast, real *w, real *dplus, real *
  lplus, real *work, integer *iwork, integer *info);

#define LA_SLARRV F77_FUNC(slarrv,SLARRV)
/* Subroutine */ int LA_SLARRV(integer *n, real *d__, real *l, integer *isplit,
  integer *m, real *w, integer *iblock, real *gersch, real *tol, real *
  z__, integer *ldz, integer *isuppz, real *work, integer *iwork,
  integer *info);

#define LA_SLARTG F77_FUNC(slartg,SLARTG)
/* Subroutine */ int LA_SLARTG(real *f, real *g, real *cs, real *sn, real *r__);

#define LA_SLARTV F77_FUNC(slartv,SLARTV)
/* Subroutine */ int LA_SLARTV(integer *n, real *x, integer *incx, real *y,
  integer *incy, real *c__, real *s, integer *incc);

#define LA_SLARUV F77_FUNC(slaruv,SLARUV)
/* Subroutine */ int LA_SLARUV(integer *iseed, integer *n, real *x);

#define LA_SLARZ F77_FUNC(slarz,SLARZ)
/* Subroutine */ int LA_SLARZ(char *side, integer *m, integer *n, integer *l,
  real *v, integer *incv, real *tau, real *c__, integer *ldc, real *
  work);

#define LA_SLARZB F77_FUNC(slarzb,SLARZB)
/* Subroutine */ int LA_SLARZB(char *side, char *trans, char *direct, char *
  storev, integer *m, integer *n, integer *k, integer *l, real *v,
  integer *ldv, real *t, integer *ldt, real *c__, integer *ldc, real *
  work, integer *ldwork);

#define LA_SLARZT F77_FUNC(slarzt,SLARZT)
/* Subroutine */ int LA_SLARZT(char *direct, char *storev, integer *n, integer *
  k, real *v, integer *ldv, real *tau, real *t, integer *ldt);

#define LA_SLAS2 F77_FUNC(slas2,SLAS2)
/* Subroutine */ int LA_SLAS2(real *f, real *g, real *h__, real *ssmin, real *
  ssmax);

#define LA_SLASCL F77_FUNC(slascl,SLASCL)
/* Subroutine */ int LA_SLASCL(char *type__, integer *kl, integer *ku, real *
  cfrom, real *cto, integer *m, integer *n, real *a, integer *lda,
  integer *info);

#define LA_SLASD0 F77_FUNC(slasd0,SLASD0)
/* Subroutine */ int LA_SLASD0(integer *n, integer *sqre, real *d__, real *e,
  real *u, integer *ldu, real *vt, integer *ldvt, integer *smlsiz,
  integer *iwork, real *work, integer *info);

#define LA_SLASD1 F77_FUNC(slasd1,SLASD1)
/* Subroutine */ int LA_SLASD1(integer *nl, integer *nr, integer *sqre, real *
  d__, real *alpha, real *beta, real *u, integer *ldu, real *vt,
  integer *ldvt, integer *idxq, integer *iwork, real *work, integer *
  info);

#define LA_SLASD2 F77_FUNC(slasd2,SLASD2)
/* Subroutine */ int LA_SLASD2(integer *nl, integer *nr, integer *sqre, integer
  *k, real *d__, real *z__, real *alpha, real *beta, real *u, integer *
  ldu, real *vt, integer *ldvt, real *dsigma, real *u2, integer *ldu2,
  real *vt2, integer *ldvt2, integer *idxp, integer *idx, integer *idxc,
   integer *idxq, integer *coltyp, integer *info);

#define LA_SLASD3 F77_FUNC(slasd3,SLASD3)
/* Subroutine */ int LA_SLASD3(integer *nl, integer *nr, integer *sqre, integer
  *k, real *d__, real *q, integer *ldq, real *dsigma, real *u, integer *
  ldu, real *u2, integer *ldu2, real *vt, integer *ldvt, real *vt2,
  integer *ldvt2, integer *idxc, integer *ctot, real *z__, integer *
  info);

#define LA_SLASD4 F77_FUNC(slasd4,SLASD4)
/* Subroutine */ int LA_SLASD4(integer *n, integer *i__, real *d__, real *z__,
  real *delta, real *rho, real *sigma, real *work, integer *info);

#define LA_SLASD5 F77_FUNC(slasd5,SLASD5)
/* Subroutine */ int LA_SLASD5(integer *i__, real *d__, real *z__, real *delta,
  real *rho, real *dsigma, real *work);

#define LA_SLASD6 F77_FUNC(slasd6,SLASD6)
/* Subroutine */ int LA_SLASD6(integer *icompq, integer *nl, integer *nr,
  integer *sqre, real *d__, real *vf, real *vl, real *alpha, real *beta,
   integer *idxq, integer *perm, integer *givptr, integer *givcol,
  integer *ldgcol, real *givnum, integer *ldgnum, real *poles, real *
  difl, real *difr, real *z__, integer *k, real *c__, real *s, real *
  work, integer *iwork, integer *info);

#define LA_SLASD7 F77_FUNC(slasd7,SLASD7)
/* Subroutine */ int LA_SLASD7(integer *icompq, integer *nl, integer *nr,
  integer *sqre, integer *k, real *d__, real *z__, real *zw, real *vf,
  real *vfw, real *vl, real *vlw, real *alpha, real *beta, real *dsigma,
   integer *idx, integer *idxp, integer *idxq, integer *perm, integer *
  givptr, integer *givcol, integer *ldgcol, real *givnum, integer *
  ldgnum, real *c__, real *s, integer *info);

#define LA_SLASD8 F77_FUNC(slasd8,SLASD8)
/* Subroutine */ int LA_SLASD8(integer *icompq, integer *k, real *d__, real *
  z__, real *vf, real *vl, real *difl, real *difr, integer *lddifr,
  real *dsigma, real *work, integer *info);

#define LA_SLASD9 F77_FUNC(slasd9,SLASD9)
/* Subroutine */ int LA_SLASD9(integer *icompq, integer *ldu, integer *k, real *
  d__, real *z__, real *vf, real *vl, real *difl, real *difr, real *
  dsigma, real *work, integer *info);

#define LA_SLASDA F77_FUNC(slasda,SLASDA)
/* Subroutine */ int LA_SLASDA(integer *icompq, integer *smlsiz, integer *n,
  integer *sqre, real *d__, real *e, real *u, integer *ldu, real *vt,
  integer *k, real *difl, real *difr, real *z__, real *poles, integer *
  givptr, integer *givcol, integer *ldgcol, integer *perm, real *givnum,
   real *c__, real *s, real *work, integer *iwork, integer *info);

#define LA_SLASDQ F77_FUNC(slasdq,SLASDQ)
/* Subroutine */ int LA_SLASDQ(char *uplo, integer *sqre, integer *n, integer *
  ncvt, integer *nru, integer *ncc, real *d__, real *e, real *vt,
  integer *ldvt, real *u, integer *ldu, real *c__, integer *ldc, real *
  work, integer *info);

#define LA_SLASDT F77_FUNC(slasdt,SLASDT)
/* Subroutine */ int LA_SLASDT(integer *n, integer *lvl, integer *nd, integer *
  inode, integer *ndiml, integer *ndimr, integer *msub);

#define LA_SLASET F77_FUNC(slaset,SLASET)
/* Subroutine */ int LA_SLASET(char *uplo, integer *m, integer *n, real *alpha,
  real *beta, real *a, integer *lda);

#define LA_SLASQ1 F77_FUNC(slasq1,SLASQ1)
/* Subroutine */ int LA_SLASQ1(integer *n, real *d__, real *e, real *work,
  integer *info);

#define LA_SLASQ2 F77_FUNC(slasq2,SLASQ2)
/* Subroutine */ int LA_SLASQ2(integer *n, real *z__, integer *info);

#define LA_SLASQ3 F77_FUNC(slasq3,SLASQ3)
/* Subroutine */ int LA_SLASQ3(integer *i0, integer *n0, real *z__, integer *pp,
   real *dmin__, real *sigma, real *desig, real *qmax, integer *nfail,
  integer *iter, integer *ndiv, logical *ieee);

#define LA_SLASQ4 F77_FUNC(slasq4,SLASQ4)
/* Subroutine */ int LA_SLASQ4(integer *i0, integer *n0, real *z__, integer *pp,
   integer *n0in, real *dmin__, real *dmin1, real *dmin2, real *dn,
  real *dn1, real *dn2, real *tau, integer *ttype);

#define LA_SLASQ5 F77_FUNC(slasq5,SLASQ5)
/* Subroutine */ int LA_SLASQ5(integer *i0, integer *n0, real *z__, integer *pp,
   real *tau, real *dmin__, real *dmin1, real *dmin2, real *dn, real *
  dnm1, real *dnm2, logical *ieee);

#define LA_SLASQ6 F77_FUNC(slasq6,SLASQ6)
/* Subroutine */ int LA_SLASQ6(integer *i0, integer *n0, real *z__, integer *pp,
   real *dmin__, real *dmin1, real *dmin2, real *dn, real *dnm1, real *
  dnm2);

#define LA_SLASR F77_FUNC(slasr,SLASR)
/* Subroutine */ int LA_SLASR(char *side, char *pivot, char *direct, integer *m,
   integer *n, real *c__, real *s, real *a, integer *lda);

#define LA_SLASRT F77_FUNC(slasrt,SLASRT)
/* Subroutine */ int LA_SLASRT(char *id, integer *n, real *d__, integer *info);

#define LA_SLASSQ F77_FUNC(slassq,SLASSQ)
/* Subroutine */ int LA_SLASSQ(integer *n, real *x, integer *incx, real *scale,
  real *sumsq);

#define LA_SLASV2 F77_FUNC(slasv2,SLASV2)
/* Subroutine */ int LA_SLASV2(real *f, real *g, real *h__, real *ssmin, real *
  ssmax, real *snr, real *csr, real *snl, real *csl);

#define LA_SLASWP F77_FUNC(slaswp,SLASWP)
/* Subroutine */ int LA_SLASWP(integer *n, real *a, integer *lda, integer *k1,
  integer *k2, integer *ipiv, integer *incx);

#define LA_SLASY2 F77_FUNC(slasy2,SLASY2)
/* Subroutine */ int LA_SLASY2(logical *ltranl, logical *ltranr, integer *isgn,
  integer *n1, integer *n2, real *tl, integer *ldtl, real *tr, integer *
  ldtr, real *b, integer *ldb, real *scale, real *x, integer *ldx, real
  *xnorm, integer *info);

#define LA_SLASYF F77_FUNC(slasyf,SLASYF)
/* Subroutine */ int LA_SLASYF(char *uplo, integer *n, integer *nb, integer *kb,
   real *a, integer *lda, integer *ipiv, real *w, integer *ldw, integer
  *info);

#define LA_SLATBS F77_FUNC(slatbs,SLATBS)
/* Subroutine */ int LA_SLATBS(char *uplo, char *trans, char *diag, char *
  normin, integer *n, integer *kd, real *ab, integer *ldab, real *x,
  real *scale, real *cnorm, integer *info);

#define LA_SLATDF F77_FUNC(slatdf,SLATDF)
/* Subroutine */ int LA_SLATDF(integer *ijob, integer *n, real *z__, integer *
  ldz, real *rhs, real *rdsum, real *rdscal, integer *ipiv, integer *
  jpiv);

#define LA_SLATPS F77_FUNC(slatps,SLATPS)
/* Subroutine */ int LA_SLATPS(char *uplo, char *trans, char *diag, char *
  normin, integer *n, real *ap, real *x, real *scale, real *cnorm,
  integer *info);

#define LA_SLATRD F77_FUNC(slatrd,SLATRD)
/* Subroutine */ int LA_SLATRD(char *uplo, integer *n, integer *nb, real *a,
  integer *lda, real *e, real *tau, real *w, integer *ldw);

#define LA_SLATRS F77_FUNC(slatrs,SLATRS)
/* Subroutine */ int LA_SLATRS(char *uplo, char *trans, char *diag, char *
  normin, integer *n, real *a, integer *lda, real *x, real *scale, real
  *cnorm, integer *info);

#define LA_SLATRZ F77_FUNC(slatrz,SLATRZ)
/* Subroutine */ int LA_SLATRZ(integer *m, integer *n, integer *l, real *a,
  integer *lda, real *tau, real *work);

#define LA_SLATZM F77_FUNC(slatzm,SLATZM)
/* Subroutine */ int LA_SLATZM(char *side, integer *m, integer *n, real *v,
  integer *incv, real *tau, real *c1, real *c2, integer *ldc, real *
  work);

#define LA_SLAUU2 F77_FUNC(slauu2,SLAUU2)
/* Subroutine */ int LA_SLAUU2(char *uplo, integer *n, real *a, integer *lda,
  integer *info);

#define LA_SLAUUM F77_FUNC(slauum,SLAUUM)
/* Subroutine */ int LA_SLAUUM(char *uplo, integer *n, real *a, integer *lda,
  integer *info);

#define LA_SOPGTR F77_FUNC(sopgtr,SOPGTR)
/* Subroutine */ int LA_SOPGTR(char *uplo, integer *n, real *ap, real *tau,
  real *q, integer *ldq, real *work, integer *info);

#define LA_SOPMTR F77_FUNC(sopmtr,SOPMTR)
/* Subroutine */ int LA_SOPMTR(char *side, char *uplo, char *trans, integer *m,
  integer *n, real *ap, real *tau, real *c__, integer *ldc, real *work,
  integer *info);

#define LA_SORG2L F77_FUNC(sorg2l,SORG2L)
/* Subroutine */ int LA_SORG2L(integer *m, integer *n, integer *k, real *a,
  integer *lda, real *tau, real *work, integer *info);

#define LA_SORG2R F77_FUNC(sorg2r,SORG2R)
/* Subroutine */ int LA_SORG2R(integer *m, integer *n, integer *k, real *a,
  integer *lda, real *tau, real *work, integer *info);

#define LA_SORGBR F77_FUNC(sorgbr,SORGBR)
/* Subroutine */ int LA_SORGBR(char *vect, integer *m, integer *n, integer *k,
  real *a, integer *lda, real *tau, real *work, integer *lwork, integer
  *info);

#define LA_SORGHR F77_FUNC(sorghr,SORGHR)
/* Subroutine */ int LA_SORGHR(integer *n, integer *ilo, integer *ihi, real *a,
  integer *lda, real *tau, real *work, integer *lwork, integer *info);

#define LA_SORGL2 F77_FUNC(sorgl2,SORGL2)
/* Subroutine */ int LA_SORGL2(integer *m, integer *n, integer *k, real *a,
  integer *lda, real *tau, real *work, integer *info);

#define LA_SORGLQ F77_FUNC(sorglq,SORGLQ)
/* Subroutine */ int LA_SORGLQ(integer *m, integer *n, integer *k, real *a,
  integer *lda, real *tau, real *work, integer *lwork, integer *info);

#define LA_SORGQL F77_FUNC(sorgql,SORGQL)
/* Subroutine */ int LA_SORGQL(integer *m, integer *n, integer *k, real *a,
  integer *lda, real *tau, real *work, integer *lwork, integer *info);

#define LA_SORGQR F77_FUNC(sorgqr,SORGQR)
/* Subroutine */ int LA_SORGQR(integer *m, integer *n, integer *k, real *a,
  integer *lda, real *tau, real *work, integer *lwork, integer *info);

#define LA_SORGR2 F77_FUNC(sorgr2,SORGR2)
/* Subroutine */ int LA_SORGR2(integer *m, integer *n, integer *k, real *a,
  integer *lda, real *tau, real *work, integer *info);

#define LA_SORGRQ F77_FUNC(sorgrq,SORGRQ)
/* Subroutine */ int LA_SORGRQ(integer *m, integer *n, integer *k, real *a,
  integer *lda, real *tau, real *work, integer *lwork, integer *info);

#define LA_SORGTR F77_FUNC(sorgtr,SORGTR)
/* Subroutine */ int LA_SORGTR(char *uplo, integer *n, real *a, integer *lda,
  real *tau, real *work, integer *lwork, integer *info);

#define LA_SORM2L F77_FUNC(sorm2l,SORM2L)
/* Subroutine */ int LA_SORM2L(char *side, char *trans, integer *m, integer *n,
  integer *k, real *a, integer *lda, real *tau, real *c__, integer *ldc,
   real *work, integer *info);

#define LA_SORM2R F77_FUNC(sorm2r,SORM2R)
/* Subroutine */ int LA_SORM2R(char *side, char *trans, integer *m, integer *n,
  integer *k, real *a, integer *lda, real *tau, real *c__, integer *ldc,
   real *work, integer *info);

#define LA_SORMBR F77_FUNC(sormbr,SORMBR)
/* Subroutine */ int LA_SORMBR(char *vect, char *side, char *trans, integer *m,
  integer *n, integer *k, real *a, integer *lda, real *tau, real *c__,
  integer *ldc, real *work, integer *lwork, integer *info);

#define LA_SORMHR F77_FUNC(sormhr,SORMHR)
/* Subroutine */ int LA_SORMHR(char *side, char *trans, integer *m, integer *n,
  integer *ilo, integer *ihi, real *a, integer *lda, real *tau, real *
  c__, integer *ldc, real *work, integer *lwork, integer *info);

#define LA_SORML2 F77_FUNC(sorml2,SORML2)
/* Subroutine */ int LA_SORML2(char *side, char *trans, integer *m, integer *n,
  integer *k, real *a, integer *lda, real *tau, real *c__, integer *ldc,
   real *work, integer *info);

#define LA_SORMLQ F77_FUNC(sormlq,SORMLQ)
/* Subroutine */ int LA_SORMLQ(char *side, char *trans, integer *m, integer *n,
  integer *k, real *a, integer *lda, real *tau, real *c__, integer *ldc,
   real *work, integer *lwork, integer *info);

#define LA_SORMQL F77_FUNC(sormql,SORMQL)
/* Subroutine */ int LA_SORMQL(char *side, char *trans, integer *m, integer *n,
  integer *k, real *a, integer *lda, real *tau, real *c__, integer *ldc,
   real *work, integer *lwork, integer *info);

#define LA_SORMQR F77_FUNC(sormqr,SORMQR)
/* Subroutine */ int LA_SORMQR(char *side, char *trans, integer *m, integer *n,
  integer *k, real *a, integer *lda, real *tau, real *c__, integer *ldc,
   real *work, integer *lwork, integer *info);

#define LA_SORMR2 F77_FUNC(sormr2,SORMR2)
/* Subroutine */ int LA_SORMR2(char *side, char *trans, integer *m, integer *n,
  integer *k, real *a, integer *lda, real *tau, real *c__, integer *ldc,
   real *work, integer *info);

#define LA_SORMR3 F77_FUNC(sormr3,SORMR3)
/* Subroutine */ int LA_SORMR3(char *side, char *trans, integer *m, integer *n,
  integer *k, integer *l, real *a, integer *lda, real *tau, real *c__,
  integer *ldc, real *work, integer *info);

#define LA_SORMRQ F77_FUNC(sormrq,SORMRQ)
/* Subroutine */ int LA_SORMRQ(char *side, char *trans, integer *m, integer *n,
  integer *k, real *a, integer *lda, real *tau, real *c__, integer *ldc,
   real *work, integer *lwork, integer *info);

#define LA_SORMRZ F77_FUNC(sormrz,SORMRZ)
/* Subroutine */ int LA_SORMRZ(char *side, char *trans, integer *m, integer *n,
  integer *k, integer *l, real *a, integer *lda, real *tau, real *c__,
  integer *ldc, real *work, integer *lwork, integer *info);

#define LA_SORMTR F77_FUNC(sormtr,SORMTR)
/* Subroutine */ int LA_SORMTR(char *side, char *uplo, char *trans, integer *m,
  integer *n, real *a, integer *lda, real *tau, real *c__, integer *ldc,
   real *work, integer *lwork, integer *info);

#define LA_SPBCON F77_FUNC(spbcon,SPBCON)
/* Subroutine */ int LA_SPBCON(char *uplo, integer *n, integer *kd, real *ab,
  integer *ldab, real *anorm, real *rcond, real *work, integer *iwork,
  integer *info);

#define LA_SPBEQU F77_FUNC(spbequ,SPBEQU)
/* Subroutine */ int LA_SPBEQU(char *uplo, integer *n, integer *kd, real *ab,
  integer *ldab, real *s, real *scond, real *amax, integer *info);

#define LA_SPBRFS F77_FUNC(spbrfs,SPBRFS)
/* Subroutine */ int LA_SPBRFS(char *uplo, integer *n, integer *kd, integer *
  nrhs, real *ab, integer *ldab, real *afb, integer *ldafb, real *b,
  integer *ldb, real *x, integer *ldx, real *ferr, real *berr, real *
  work, integer *iwork, integer *info);

#define LA_SPBSTF F77_FUNC(spbstf,SPBSTF)
/* Subroutine */ int LA_SPBSTF(char *uplo, integer *n, integer *kd, real *ab,
  integer *ldab, integer *info);

#define LA_SPBSV F77_FUNC(spbsv,SPBSV)
/* Subroutine */ int LA_SPBSV(char *uplo, integer *n, integer *kd, integer *
  nrhs, real *ab, integer *ldab, real *b, integer *ldb, integer *info);

#define LA_SPBSVX F77_FUNC(spbsvx,SPBSVX)
/* Subroutine */ int LA_SPBSVX(char *fact, char *uplo, integer *n, integer *kd,
  integer *nrhs, real *ab, integer *ldab, real *afb, integer *ldafb,
  char *equed, real *s, real *b, integer *ldb, real *x, integer *ldx,
  real *rcond, real *ferr, real *berr, real *work, integer *iwork,
  integer *info);

#define LA_SPBTF2 F77_FUNC(spbtf2,SPBTF2)
/* Subroutine */ int LA_SPBTF2(char *uplo, integer *n, integer *kd, real *ab,
  integer *ldab, integer *info);

#define LA_SPBTRF F77_FUNC(spbtrf,SPBTRF)
/* Subroutine */ int LA_SPBTRF(char *uplo, integer *n, integer *kd, real *ab,
  integer *ldab, integer *info);

#define LA_SPBTRS F77_FUNC(spbtrs,SPBTRS)
/* Subroutine */ int LA_SPBTRS(char *uplo, integer *n, integer *kd, integer *
  nrhs, real *ab, integer *ldab, real *b, integer *ldb, integer *info);

#define LA_SPOCON F77_FUNC(spocon,SPOCON)
/* Subroutine */ int LA_SPOCON(char *uplo, integer *n, real *a, integer *lda,
  real *anorm, real *rcond, real *work, integer *iwork, integer *info);

#define LA_SPOEQU F77_FUNC(spoequ,SPOEQU)
/* Subroutine */ int LA_SPOEQU(integer *n, real *a, integer *lda, real *s, real
  *scond, real *amax, integer *info);

#define LA_SPORFS F77_FUNC(sporfs,SPORFS)
/* Subroutine */ int LA_SPORFS(char *uplo, integer *n, integer *nrhs, real *a,
  integer *lda, real *af, integer *ldaf, real *b, integer *ldb, real *x,
   integer *ldx, real *ferr, real *berr, real *work, integer *iwork,
  integer *info);

#define LA_SPOSV F77_FUNC(sposv,SPOSV)
/* Subroutine */ int LA_SPOSV(char *uplo, integer *n, integer *nrhs, real *a,
  integer *lda, real *b, integer *ldb, integer *info);

#define LA_SPOSVX F77_FUNC(sposvx,SPOSVX)
/* Subroutine */ int LA_SPOSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, real *a, integer *lda, real *af, integer *ldaf, char *equed,
  real *s, real *b, integer *ldb, real *x, integer *ldx, real *rcond,
  real *ferr, real *berr, real *work, integer *iwork, integer *info);

#define LA_SPOTF2 F77_FUNC(spotf2,SPOTF2)
/* Subroutine */ int LA_SPOTF2(char *uplo, integer *n, real *a, integer *lda,
  integer *info);

#define LA_SPOTRF F77_FUNC(spotrf,SPOTRF)
/* Subroutine */ int LA_SPOTRF(char *uplo, integer *n, real *a, integer *lda,
  integer *info);

#define LA_SPOTRI F77_FUNC(spotri,SPOTRI)
/* Subroutine */ int LA_SPOTRI(char *uplo, integer *n, real *a, integer *lda,
  integer *info);

#define LA_SPOTRS F77_FUNC(spotrs,SPOTRS)
/* Subroutine */ int LA_SPOTRS(char *uplo, integer *n, integer *nrhs, real *a,
  integer *lda, real *b, integer *ldb, integer *info);

#define LA_SPPCON F77_FUNC(sppcon,SPPCON)
/* Subroutine */ int LA_SPPCON(char *uplo, integer *n, real *ap, real *anorm,
  real *rcond, real *work, integer *iwork, integer *info);

#define LA_SPPEQU F77_FUNC(sppequ,SPPEQU)
/* Subroutine */ int LA_SPPEQU(char *uplo, integer *n, real *ap, real *s, real *
  scond, real *amax, integer *info);

#define LA_SPPRFS F77_FUNC(spprfs,SPPRFS)
/* Subroutine */ int LA_SPPRFS(char *uplo, integer *n, integer *nrhs, real *ap,
  real *afp, real *b, integer *ldb, real *x, integer *ldx, real *ferr,
  real *berr, real *work, integer *iwork, integer *info);

#define LA_SPPSV F77_FUNC(sppsv,SPPSV)
/* Subroutine */ int LA_SPPSV(char *uplo, integer *n, integer *nrhs, real *ap,
  real *b, integer *ldb, integer *info);

#define LA_SPPSVX F77_FUNC(sppsvx,SPPSVX)
/* Subroutine */ int LA_SPPSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, real *ap, real *afp, char *equed, real *s, real *b, integer *
  ldb, real *x, integer *ldx, real *rcond, real *ferr, real *berr, real
  *work, integer *iwork, integer *info);

#define LA_SPPTRF F77_FUNC(spptrf,SPPTRF)
/* Subroutine */ int LA_SPPTRF(char *uplo, integer *n, real *ap, integer *info);

#define LA_SPPTRI F77_FUNC(spptri,SPPTRI)
/* Subroutine */ int LA_SPPTRI(char *uplo, integer *n, real *ap, integer *info);

#define LA_SPPTRS F77_FUNC(spptrs,SPPTRS)
/* Subroutine */ int LA_SPPTRS(char *uplo, integer *n, integer *nrhs, real *ap,
  real *b, integer *ldb, integer *info);

#define LA_SPTCON F77_FUNC(sptcon,SPTCON)
/* Subroutine */ int LA_SPTCON(integer *n, real *d__, real *e, real *anorm,
  real *rcond, real *work, integer *info);

#define LA_SPTEQR F77_FUNC(spteqr,SPTEQR)
/* Subroutine */ int LA_SPTEQR(char *compz, integer *n, real *d__, real *e,
  real *z__, integer *ldz, real *work, integer *info);

#define LA_SPTRFS F77_FUNC(sptrfs,SPTRFS)
/* Subroutine */ int LA_SPTRFS(integer *n, integer *nrhs, real *d__, real *e,
  real *df, real *ef, real *b, integer *ldb, real *x, integer *ldx,
  real *ferr, real *berr, real *work, integer *info);

#define LA_SPTSV F77_FUNC(sptsv,SPTSV)
/* Subroutine */ int LA_SPTSV(integer *n, integer *nrhs, real *d__, real *e,
  real *b, integer *ldb, integer *info);

#define LA_SPTSVX F77_FUNC(sptsvx,SPTSVX)
/* Subroutine */ int LA_SPTSVX(char *fact, integer *n, integer *nrhs, real *d__,
   real *e, real *df, real *ef, real *b, integer *ldb, real *x, integer
  *ldx, real *rcond, real *ferr, real *berr, real *work, integer *info);

#define LA_SPTTRF F77_FUNC(spttrf,SPTTRF)
/* Subroutine */ int LA_SPTTRF(integer *n, real *d__, real *e, integer *info);

#define LA_SPTTRS F77_FUNC(spttrs,SPTTRS)
/* Subroutine */ int LA_SPTTRS(integer *n, integer *nrhs, real *d__, real *e,
  real *b, integer *ldb, integer *info);

#define LA_SPTTS2 F77_FUNC(sptts2,SPTTS2)
/* Subroutine */ int LA_SPTTS2(integer *n, integer *nrhs, real *d__, real *e,
  real *b, integer *ldb);

#define LA_SRSCL F77_FUNC(srscl,SRSCL)
/* Subroutine */ int LA_SRSCL(integer *n, real *sa, real *sx, integer *incx);

#define LA_SSBEV F77_FUNC(ssbev,SSBEV)
/* Subroutine */ int LA_SSBEV(char *jobz, char *uplo, integer *n, integer *kd,
  real *ab, integer *ldab, real *w, real *z__, integer *ldz, real *work,
   integer *info);

#define LA_SSBEVD F77_FUNC(ssbevd,SSBEVD)
/* Subroutine */ int LA_SSBEVD(char *jobz, char *uplo, integer *n, integer *kd,
  real *ab, integer *ldab, real *w, real *z__, integer *ldz, real *work,
   integer *lwork, integer *iwork, integer *liwork, integer *info);

#define LA_SSBEVX F77_FUNC(ssbevx,SSBEVX)
/* Subroutine */ int LA_SSBEVX(char *jobz, char *range, char *uplo, integer *n,
  integer *kd, real *ab, integer *ldab, real *q, integer *ldq, real *vl,
   real *vu, integer *il, integer *iu, real *abstol, integer *m, real *
  w, real *z__, integer *ldz, real *work, integer *iwork, integer *
  ifail, integer *info);

#define LA_SSBGST F77_FUNC(ssbgst,SSBGST)
/* Subroutine */ int LA_SSBGST(char *vect, char *uplo, integer *n, integer *ka,
  integer *kb, real *ab, integer *ldab, real *bb, integer *ldbb, real *
  x, integer *ldx, real *work, integer *info);

#define LA_SSBGV F77_FUNC(ssbgv,SSBGV)
/* Subroutine */ int LA_SSBGV(char *jobz, char *uplo, integer *n, integer *ka,
  integer *kb, real *ab, integer *ldab, real *bb, integer *ldbb, real *
  w, real *z__, integer *ldz, real *work, integer *info);

#define LA_SSBGVD F77_FUNC(ssbgvd,SSBGVD)
/* Subroutine */ int LA_SSBGVD(char *jobz, char *uplo, integer *n, integer *ka,
  integer *kb, real *ab, integer *ldab, real *bb, integer *ldbb, real *
  w, real *z__, integer *ldz, real *work, integer *lwork, integer *
  iwork, integer *liwork, integer *info);

#define LA_SSBGVX F77_FUNC(ssbgvx,SSBGVX)
/* Subroutine */ int LA_SSBGVX(char *jobz, char *range, char *uplo, integer *n,
  integer *ka, integer *kb, real *ab, integer *ldab, real *bb, integer *
  ldbb, real *q, integer *ldq, real *vl, real *vu, integer *il, integer
  *iu, real *abstol, integer *m, real *w, real *z__, integer *ldz, real
  *work, integer *iwork, integer *ifail, integer *info);

#define LA_SSBTRD F77_FUNC(ssbtrd,SSBTRD)
/* Subroutine */ int LA_SSBTRD(char *vect, char *uplo, integer *n, integer *kd,
  real *ab, integer *ldab, real *d__, real *e, real *q, integer *ldq,
  real *work, integer *info);

#define LA_SSPCON F77_FUNC(sspcon,SSPCON)
/* Subroutine */ int LA_SSPCON(char *uplo, integer *n, real *ap, integer *ipiv,
  real *anorm, real *rcond, real *work, integer *iwork, integer *info);

#define LA_SSPEV F77_FUNC(sspev,SSPEV)
/* Subroutine */ int LA_SSPEV(char *jobz, char *uplo, integer *n, real *ap,
  real *w, real *z__, integer *ldz, real *work, integer *info);

#define LA_SSPEVD F77_FUNC(sspevd,SSPEVD)
/* Subroutine */ int LA_SSPEVD(char *jobz, char *uplo, integer *n, real *ap,
  real *w, real *z__, integer *ldz, real *work, integer *lwork, integer
  *iwork, integer *liwork, integer *info);

#define LA_SSPEVX F77_FUNC(sspevx,SSPEVX)
/* Subroutine */ int LA_SSPEVX(char *jobz, char *range, char *uplo, integer *n,
  real *ap, real *vl, real *vu, integer *il, integer *iu, real *abstol,
  integer *m, real *w, real *z__, integer *ldz, real *work, integer *
  iwork, integer *ifail, integer *info);

#define LA_SSPGST F77_FUNC(sspgst,SSPGST)
/* Subroutine */ int LA_SSPGST(integer *itype, char *uplo, integer *n, real *ap,
   real *bp, integer *info);

#define LA_SSPGV F77_FUNC(sspgv,SSPGV)
/* Subroutine */ int LA_SSPGV(integer *itype, char *jobz, char *uplo, integer *
  n, real *ap, real *bp, real *w, real *z__, integer *ldz, real *work,
  integer *info);

#define LA_SSPGVD F77_FUNC(sspgvd,SSPGVD)
/* Subroutine */ int LA_SSPGVD(integer *itype, char *jobz, char *uplo, integer *
  n, real *ap, real *bp, real *w, real *z__, integer *ldz, real *work,
  integer *lwork, integer *iwork, integer *liwork, integer *info);

#define LA_SSPGVX F77_FUNC(sspgvx,SSPGVX)
/* Subroutine */ int LA_SSPGVX(integer *itype, char *jobz, char *range, char *
  uplo, integer *n, real *ap, real *bp, real *vl, real *vu, integer *il,
   integer *iu, real *abstol, integer *m, real *w, real *z__, integer *
  ldz, real *work, integer *iwork, integer *ifail, integer *info);

#define LA_SSPRFS F77_FUNC(ssprfs,SSPRFS)
/* Subroutine */ int LA_SSPRFS(char *uplo, integer *n, integer *nrhs, real *ap,
  real *afp, integer *ipiv, real *b, integer *ldb, real *x, integer *
  ldx, real *ferr, real *berr, real *work, integer *iwork, integer *
  info);

#define LA_SSPSV F77_FUNC(sspsv,SSPSV)
/* Subroutine */ int LA_SSPSV(char *uplo, integer *n, integer *nrhs, real *ap,
  integer *ipiv, real *b, integer *ldb, integer *info);

#define LA_SSPSVX F77_FUNC(sspsvx,SSPSVX)
/* Subroutine */ int LA_SSPSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, real *ap, real *afp, integer *ipiv, real *b, integer *ldb, real
  *x, integer *ldx, real *rcond, real *ferr, real *berr, real *work,
  integer *iwork, integer *info);

#define LA_SSPTRD F77_FUNC(ssptrd,SSPTRD)
/* Subroutine */ int LA_SSPTRD(char *uplo, integer *n, real *ap, real *d__,
  real *e, real *tau, integer *info);

#define LA_SSPTRF F77_FUNC(ssptrf,SSPTRF)
/* Subroutine */ int LA_SSPTRF(char *uplo, integer *n, real *ap, integer *ipiv,
  integer *info);

#define LA_SSPTRI F77_FUNC(ssptri,SSPTRI)
/* Subroutine */ int LA_SSPTRI(char *uplo, integer *n, real *ap, integer *ipiv,
  real *work, integer *info);

#define LA_SSPTRS F77_FUNC(ssptrs,SSPTRS)
/* Subroutine */ int LA_SSPTRS(char *uplo, integer *n, integer *nrhs, real *ap,
  integer *ipiv, real *b, integer *ldb, integer *info);

#define LA_SSTEBZ F77_FUNC(sstebz,SSTEBZ)
/* Subroutine */ int LA_SSTEBZ(char *range, char *order, integer *n, real *vl,
  real *vu, integer *il, integer *iu, real *abstol, real *d__, real *e,
  integer *m, integer *nsplit, real *w, integer *iblock, integer *
  isplit, real *work, integer *iwork, integer *info);

#define LA_SSTEDC F77_FUNC(sstedc,SSTEDC)
/* Subroutine */ int LA_SSTEDC(char *compz, integer *n, real *d__, real *e,
  real *z__, integer *ldz, real *work, integer *lwork, integer *iwork,
  integer *liwork, integer *info);

#define LA_SSTEGR F77_FUNC(sstegr,SSTEGR)
/* Subroutine */ int LA_SSTEGR(char *jobz, char *range, integer *n, real *d__,
  real *e, real *vl, real *vu, integer *il, integer *iu, real *abstol,
  integer *m, real *w, real *z__, integer *ldz, integer *isuppz, real *
  work, integer *lwork, integer *iwork, integer *liwork, integer *info);

#define LA_SSTEIN F77_FUNC(sstein,SSTEIN)
/* Subroutine */ int LA_SSTEIN(integer *n, real *d__, real *e, integer *m, real
  *w, integer *iblock, integer *isplit, real *z__, integer *ldz, real *
  work, integer *iwork, integer *ifail, integer *info);

#define LA_SSTEQR F77_FUNC(ssteqr,SSTEQR)
/* Subroutine */ int LA_SSTEQR(char *compz, integer *n, real *d__, real *e,
  real *z__, integer *ldz, real *work, integer *info);

#define LA_SSTERF F77_FUNC(ssterf,SSTERF)
/* Subroutine */ int LA_SSTERF(integer *n, real *d__, real *e, integer *info);

#define LA_SSTEV F77_FUNC(sstev,SSTEV)
/* Subroutine */ int LA_SSTEV(char *jobz, integer *n, real *d__, real *e, real *
  z__, integer *ldz, real *work, integer *info);

#define LA_SSTEVD F77_FUNC(sstevd,SSTEVD)
/* Subroutine */ int LA_SSTEVD(char *jobz, integer *n, real *d__, real *e, real
  *z__, integer *ldz, real *work, integer *lwork, integer *iwork,
  integer *liwork, integer *info);

#define LA_SSTEVR F77_FUNC(sstevr,SSTEVR)
/* Subroutine */ int LA_SSTEVR(char *jobz, char *range, integer *n, real *d__,
  real *e, real *vl, real *vu, integer *il, integer *iu, real *abstol,
  integer *m, real *w, real *z__, integer *ldz, integer *isuppz, real *
  work, integer *lwork, integer *iwork, integer *liwork, integer *info);

#define LA_SSTEVX F77_FUNC(sstevx,SSTEVX)
/* Subroutine */ int LA_SSTEVX(char *jobz, char *range, integer *n, real *d__,
  real *e, real *vl, real *vu, integer *il, integer *iu, real *abstol,
  integer *m, real *w, real *z__, integer *ldz, real *work, integer *
  iwork, integer *ifail, integer *info);

#define LA_SSYCON F77_FUNC(ssycon,SSYCON)
/* Subroutine */ int LA_SSYCON(char *uplo, integer *n, real *a, integer *lda,
  integer *ipiv, real *anorm, real *rcond, real *work, integer *iwork,
  integer *info);

#define LA_SSYEV F77_FUNC(ssyev,SSYEV)
/* Subroutine */ int LA_SSYEV(char *jobz, char *uplo, integer *n, real *a,
  integer *lda, real *w, real *work, integer *lwork, integer *info);

#define LA_SSYEVD F77_FUNC(ssyevd,SSYEVD)
/* Subroutine */ int LA_SSYEVD(char *jobz, char *uplo, integer *n, real *a,
  integer *lda, real *w, real *work, integer *lwork, integer *iwork,
  integer *liwork, integer *info);

#define LA_SSYEVR F77_FUNC(ssyevr,SSYEVR)
/* Subroutine */ int LA_SSYEVR(char *jobz, char *range, char *uplo, integer *n,
  real *a, integer *lda, real *vl, real *vu, integer *il, integer *iu,
  real *abstol, integer *m, real *w, real *z__, integer *ldz, integer *
  isuppz, real *work, integer *lwork, integer *iwork, integer *liwork,
  integer *info);

#define LA_SSYEVX F77_FUNC(ssyevx,SSYEVX)
/* Subroutine */ int LA_SSYEVX(char *jobz, char *range, char *uplo, integer *n,
  real *a, integer *lda, real *vl, real *vu, integer *il, integer *iu,
  real *abstol, integer *m, real *w, real *z__, integer *ldz, real *
  work, integer *lwork, integer *iwork, integer *ifail, integer *info);

#define LA_SSYGS2 F77_FUNC(ssygs2,SSYGS2)
/* Subroutine */ int LA_SSYGS2(integer *itype, char *uplo, integer *n, real *a,
  integer *lda, real *b, integer *ldb, integer *info);

#define LA_SSYGST F77_FUNC(ssygst,SSYGST)
/* Subroutine */ int LA_SSYGST(integer *itype, char *uplo, integer *n, real *a,
  integer *lda, real *b, integer *ldb, integer *info);

#define LA_SSYGV F77_FUNC(ssygv,SSYGV)
/* Subroutine */ int LA_SSYGV(integer *itype, char *jobz, char *uplo, integer *
  n, real *a, integer *lda, real *b, integer *ldb, real *w, real *work,
  integer *lwork, integer *info);

#define LA_SSYGVD F77_FUNC(ssygvd,SSYGVD)
/* Subroutine */ int LA_SSYGVD(integer *itype, char *jobz, char *uplo, integer *
  n, real *a, integer *lda, real *b, integer *ldb, real *w, real *work,
  integer *lwork, integer *iwork, integer *liwork, integer *info);

#define LA_SSYGVX F77_FUNC(ssygvx,SSYGVX)
/* Subroutine */ int LA_SSYGVX(integer *itype, char *jobz, char *range, char *
  uplo, integer *n, real *a, integer *lda, real *b, integer *ldb, real *
  vl, real *vu, integer *il, integer *iu, real *abstol, integer *m,
  real *w, real *z__, integer *ldz, real *work, integer *lwork, integer
  *iwork, integer *ifail, integer *info);

#define LA_SSYRFS F77_FUNC(ssyrfs,SSYRFS)
/* Subroutine */ int LA_SSYRFS(char *uplo, integer *n, integer *nrhs, real *a,
  integer *lda, real *af, integer *ldaf, integer *ipiv, real *b,
  integer *ldb, real *x, integer *ldx, real *ferr, real *berr, real *
  work, integer *iwork, integer *info);

#define LA_SSYSV F77_FUNC(ssysv,SSYSV)
/* Subroutine */ int LA_SSYSV(char *uplo, integer *n, integer *nrhs, real *a,
  integer *lda, integer *ipiv, real *b, integer *ldb, real *work,
  integer *lwork, integer *info);

#define LA_SSYSVX F77_FUNC(ssysvx,SSYSVX)
/* Subroutine */ int LA_SSYSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, real *a, integer *lda, real *af, integer *ldaf, integer *ipiv,
  real *b, integer *ldb, real *x, integer *ldx, real *rcond, real *ferr,
   real *berr, real *work, integer *lwork, integer *iwork, integer *
  info);

#define LA_SSYTD2 F77_FUNC(ssytd2,SSYTD2)
/* Subroutine */ int LA_SSYTD2(char *uplo, integer *n, real *a, integer *lda,
  real *d__, real *e, real *tau, integer *info);

#define LA_SSYTF2 F77_FUNC(ssytf2,SSYTF2)
/* Subroutine */ int LA_SSYTF2(char *uplo, integer *n, real *a, integer *lda,
  integer *ipiv, integer *info);

#define LA_SSYTRD F77_FUNC(ssytrd,SSYTRD)
/* Subroutine */ int LA_SSYTRD(char *uplo, integer *n, real *a, integer *lda,
  real *d__, real *e, real *tau, real *work, integer *lwork, integer *
  info);

#define LA_SSYTRF F77_FUNC(ssytrf,SSYTRF)
/* Subroutine */ int LA_SSYTRF(char *uplo, integer *n, real *a, integer *lda,
  integer *ipiv, real *work, integer *lwork, integer *info);

#define LA_SSYTRI F77_FUNC(ssytri,SSYTRI)
/* Subroutine */ int LA_SSYTRI(char *uplo, integer *n, real *a, integer *lda,
  integer *ipiv, real *work, integer *info);

#define LA_SSYTRS F77_FUNC(ssytrs,SSYTRS)
/* Subroutine */ int LA_SSYTRS(char *uplo, integer *n, integer *nrhs, real *a,
  integer *lda, integer *ipiv, real *b, integer *ldb, integer *info);

#define LA_STBCON F77_FUNC(stbcon,STBCON)
/* Subroutine */ int LA_STBCON(char *norm, char *uplo, char *diag, integer *n,
  integer *kd, real *ab, integer *ldab, real *rcond, real *work,
  integer *iwork, integer *info);

#define LA_STBRFS F77_FUNC(stbrfs,STBRFS)
/* Subroutine */ int LA_STBRFS(char *uplo, char *trans, char *diag, integer *n,
  integer *kd, integer *nrhs, real *ab, integer *ldab, real *b, integer
  *ldb, real *x, integer *ldx, real *ferr, real *berr, real *work,
  integer *iwork, integer *info);

#define LA_STBTRS F77_FUNC(stbtrs,STBTRS)
/* Subroutine */ int LA_STBTRS(char *uplo, char *trans, char *diag, integer *n,
  integer *kd, integer *nrhs, real *ab, integer *ldab, real *b, integer
  *ldb, integer *info);

#define LA_STGEVC F77_FUNC(stgevc,STGEVC)
/* Subroutine */ int LA_STGEVC(char *side, char *howmny, logical *select,
  integer *n, real *a, integer *lda, real *b, integer *ldb, real *vl,
  integer *ldvl, real *vr, integer *ldvr, integer *mm, integer *m, real
  *work, integer *info);

#define LA_STGEX2 F77_FUNC(stgex2,STGEX2)
/* Subroutine */ int LA_STGEX2(logical *wantq, logical *wantz, integer *n, real
  *a, integer *lda, real *b, integer *ldb, real *q, integer *ldq, real *
  z__, integer *ldz, integer *j1, integer *n1, integer *n2, real *work,
  integer *lwork, integer *info);

#define LA_STGEXC F77_FUNC(stgexc,STGEXC)
/* Subroutine */ int LA_STGEXC(logical *wantq, logical *wantz, integer *n, real
  *a, integer *lda, real *b, integer *ldb, real *q, integer *ldq, real *
  z__, integer *ldz, integer *ifst, integer *ilst, real *work, integer *
  lwork, integer *info);

#define LA_STGSEN F77_FUNC(stgsen,STGSEN)
/* Subroutine */ int LA_STGSEN(integer *ijob, logical *wantq, logical *wantz,
  logical *select, integer *n, real *a, integer *lda, real *b, integer *
  ldb, real *alphar, real *alphai, real *beta, real *q, integer *ldq,
  real *z__, integer *ldz, integer *m, real *pl, real *pr, real *dif,
  real *work, integer *lwork, integer *iwork, integer *liwork, integer *
  info);

#define LA_STGSJA F77_FUNC(stgsja,STGSJA)
/* Subroutine */ int LA_STGSJA(char *jobu, char *jobv, char *jobq, integer *m,
  integer *p, integer *n, integer *k, integer *l, real *a, integer *lda,
   real *b, integer *ldb, real *tola, real *tolb, real *alpha, real *
  beta, real *u, integer *ldu, real *v, integer *ldv, real *q, integer *
  ldq, real *work, integer *ncycle, integer *info);

#define LA_STGSNA F77_FUNC(stgsna,STGSNA)
/* Subroutine */ int LA_STGSNA(char *job, char *howmny, logical *select,
  integer *n, real *a, integer *lda, real *b, integer *ldb, real *vl,
  integer *ldvl, real *vr, integer *ldvr, real *s, real *dif, integer *
  mm, integer *m, real *work, integer *lwork, integer *iwork, integer *
  info);

#define LA_STGSY2 F77_FUNC(stgsy2,STGSY2)
/* Subroutine */ int LA_STGSY2(char *trans, integer *ijob, integer *m, integer *
  n, real *a, integer *lda, real *b, integer *ldb, real *c__, integer *
  ldc, real *d__, integer *ldd, real *e, integer *lde, real *f, integer
  *ldf, real *scale, real *rdsum, real *rdscal, integer *iwork, integer
  *pq, integer *info);

#define LA_STGSYL F77_FUNC(stgsyl,STGSYL)
/* Subroutine */ int LA_STGSYL(char *trans, integer *ijob, integer *m, integer *
  n, real *a, integer *lda, real *b, integer *ldb, real *c__, integer *
  ldc, real *d__, integer *ldd, real *e, integer *lde, real *f, integer
  *ldf, real *scale, real *dif, real *work, integer *lwork, integer *
  iwork, integer *info);

#define LA_STPCON F77_FUNC(stpcon,STPCON)
/* Subroutine */ int LA_STPCON(char *norm, char *uplo, char *diag, integer *n,
  real *ap, real *rcond, real *work, integer *iwork, integer *info);

#define LA_STPRFS F77_FUNC(stprfs,STPRFS)
/* Subroutine */ int LA_STPRFS(char *uplo, char *trans, char *diag, integer *n,
  integer *nrhs, real *ap, real *b, integer *ldb, real *x, integer *ldx,
   real *ferr, real *berr, real *work, integer *iwork, integer *info);

#define LA_STPTRI F77_FUNC(stptri,STPTRI)
/* Subroutine */ int LA_STPTRI(char *uplo, char *diag, integer *n, real *ap,
  integer *info);

#define LA_STPTRS F77_FUNC(stptrs,STPTRS)
/* Subroutine */ int LA_STPTRS(char *uplo, char *trans, char *diag, integer *n,
  integer *nrhs, real *ap, real *b, integer *ldb, integer *info);

#define LA_STRCON F77_FUNC(strcon,STRCON)
/* Subroutine */ int LA_STRCON(char *norm, char *uplo, char *diag, integer *n,
  real *a, integer *lda, real *rcond, real *work, integer *iwork,
  integer *info);

#define LA_STREVC F77_FUNC(strevc,STREVC)
/* Subroutine */ int LA_STREVC(char *side, char *howmny, logical *select,
  integer *n, real *t, integer *ldt, real *vl, integer *ldvl, real *vr,
  integer *ldvr, integer *mm, integer *m, real *work, integer *info);

#define LA_STREXC F77_FUNC(strexc,STREXC)
/* Subroutine */ int LA_STREXC(char *compq, integer *n, real *t, integer *ldt,
  real *q, integer *ldq, integer *ifst, integer *ilst, real *work,
  integer *info);

#define LA_STRRFS F77_FUNC(strrfs,STRRFS)
/* Subroutine */ int LA_STRRFS(char *uplo, char *trans, char *diag, integer *n,
  integer *nrhs, real *a, integer *lda, real *b, integer *ldb, real *x,
  integer *ldx, real *ferr, real *berr, real *work, integer *iwork,
  integer *info);

#define LA_STRSEN F77_FUNC(strsen,STRSEN)
/* Subroutine */ int LA_STRSEN(char *job, char *compq, logical *select, integer
  *n, real *t, integer *ldt, real *q, integer *ldq, real *wr, real *wi,
  integer *m, real *s, real *sep, real *work, integer *lwork, integer *
  iwork, integer *liwork, integer *info);

#define LA_STRSNA F77_FUNC(strsna,STRSNA)
/* Subroutine */ int LA_STRSNA(char *job, char *howmny, logical *select,
  integer *n, real *t, integer *ldt, real *vl, integer *ldvl, real *vr,
  integer *ldvr, real *s, real *sep, integer *mm, integer *m, real *
  work, integer *ldwork, integer *iwork, integer *info);

#define LA_STRSYL F77_FUNC(strsyl,STRSYL)
/* Subroutine */ int LA_STRSYL(char *trana, char *tranb, integer *isgn, integer
  *m, integer *n, real *a, integer *lda, real *b, integer *ldb, real *
  c__, integer *ldc, real *scale, integer *info);

#define LA_STRTI2 F77_FUNC(strti2,STRTI2)
/* Subroutine */ int LA_STRTI2(char *uplo, char *diag, integer *n, real *a,
  integer *lda, integer *info);

#define LA_STRTRI F77_FUNC(strtri,STRTRI)
/* Subroutine */ int LA_STRTRI(char *uplo, char *diag, integer *n, real *a,
  integer *lda, integer *info);

#define LA_STRTRS F77_FUNC(strtrs,STRTRS)
/* Subroutine */ int LA_STRTRS(char *uplo, char *trans, char *diag, integer *n,
  integer *nrhs, real *a, integer *lda, real *b, integer *ldb, integer *
  info);

#define LA_STZRQF F77_FUNC(stzrqf,STZRQF)
/* Subroutine */ int LA_STZRQF(integer *m, integer *n, real *a, integer *lda,
  real *tau, integer *info);

#define LA_STZRZF F77_FUNC(stzrzf,STZRZF)
/* Subroutine */ int LA_STZRZF(integer *m, integer *n, real *a, integer *lda,
  real *tau, real *work, integer *lwork, integer *info);

#define LA_XERBLA F77_FUNC(xerbla,XERBLA)
/* Subroutine */ int LA_XERBLA(char *srname, integer *info);

#define LA_ZBDSQR F77_FUNC(zbdsqr,ZBDSQR)
/* Subroutine */ int LA_ZBDSQR(char *uplo, integer *n, integer *ncvt, integer *
  nru, integer *ncc, doublereal *d__, doublereal *e, doublecomplex *vt,
  integer *ldvt, doublecomplex *u, integer *ldu, doublecomplex *c__,
  integer *ldc, doublereal *rwork, integer *info);

#define LA_ZDROT F77_FUNC(zdrot,ZDROT)
/* Subroutine */ int LA_ZDROT(integer *n, doublecomplex *cx, integer *incx,
  doublecomplex *cy, integer *incy, doublereal *c__, doublereal *s);

#define LA_ZDRSCL F77_FUNC(zdrscl,ZDRSCL)
/* Subroutine */ int LA_ZDRSCL(integer *n, doublereal *sa, doublecomplex *sx,
  integer *incx);

#define LA_ZGBBRD F77_FUNC(zgbbrd,ZGBBRD)
/* Subroutine */ int LA_ZGBBRD(char *vect, integer *m, integer *n, integer *ncc,
   integer *kl, integer *ku, doublecomplex *ab, integer *ldab,
  doublereal *d__, doublereal *e, doublecomplex *q, integer *ldq,
  doublecomplex *pt, integer *ldpt, doublecomplex *c__, integer *ldc,
  doublecomplex *work, doublereal *rwork, integer *info);

#define LA_ZGBCON F77_FUNC(zgbcon,ZGBCON)
/* Subroutine */ int LA_ZGBCON(char *norm, integer *n, integer *kl, integer *ku,
   doublecomplex *ab, integer *ldab, integer *ipiv, doublereal *anorm,
  doublereal *rcond, doublecomplex *work, doublereal *rwork, integer *
  info);

#define LA_ZGBEQU F77_FUNC(zgbequ,ZGBEQU)
/* Subroutine */ int LA_ZGBEQU(integer *m, integer *n, integer *kl, integer *ku,
   doublecomplex *ab, integer *ldab, doublereal *r__, doublereal *c__,
  doublereal *rowcnd, doublereal *colcnd, doublereal *amax, integer *
  info);

#define LA_ZGBRFS F77_FUNC(zgbrfs,ZGBRFS)
/* Subroutine */ int LA_ZGBRFS(char *trans, integer *n, integer *kl, integer *
  ku, integer *nrhs, doublecomplex *ab, integer *ldab, doublecomplex *
  afb, integer *ldafb, integer *ipiv, doublecomplex *b, integer *ldb,
  doublecomplex *x, integer *ldx, doublereal *ferr, doublereal *berr,
  doublecomplex *work, doublereal *rwork, integer *info);

#define LA_ZGBSV F77_FUNC(zgbsv,ZGBSV)
/* Subroutine */ int LA_ZGBSV(integer *n, integer *kl, integer *ku, integer *
  nrhs, doublecomplex *ab, integer *ldab, integer *ipiv, doublecomplex *
  b, integer *ldb, integer *info);

#define LA_ZGBSVX F77_FUNC(zgbsvx,ZGBSVX)
/* Subroutine */ int LA_ZGBSVX(char *fact, char *trans, integer *n, integer *kl,
   integer *ku, integer *nrhs, doublecomplex *ab, integer *ldab,
  doublecomplex *afb, integer *ldafb, integer *ipiv, char *equed,
  doublereal *r__, doublereal *c__, doublecomplex *b, integer *ldb,
  doublecomplex *x, integer *ldx, doublereal *rcond, doublereal *ferr,
  doublereal *berr, doublecomplex *work, doublereal *rwork, integer *
  info);

#define LA_ZGBTF2 F77_FUNC(zgbtf2,ZGBTF2)
/* Subroutine */ int LA_ZGBTF2(integer *m, integer *n, integer *kl, integer *ku,
   doublecomplex *ab, integer *ldab, integer *ipiv, integer *info);

#define LA_ZGBTRF F77_FUNC(zgbtrf,ZGBTRF)
/* Subroutine */ int LA_ZGBTRF(integer *m, integer *n, integer *kl, integer *ku,
   doublecomplex *ab, integer *ldab, integer *ipiv, integer *info);

#define LA_ZGBTRS F77_FUNC(zgbtrs,ZGBTRS)
/* Subroutine */ int LA_ZGBTRS(char *trans, integer *n, integer *kl, integer *
  ku, integer *nrhs, doublecomplex *ab, integer *ldab, integer *ipiv,
  doublecomplex *b, integer *ldb, integer *info);

#define LA_ZGEBAK F77_FUNC(zgebak,ZGEBAK)
/* Subroutine */ int LA_ZGEBAK(char *job, char *side, integer *n, integer *ilo,
  integer *ihi, doublereal *scale, integer *m, doublecomplex *v,
  integer *ldv, integer *info);

#define LA_ZGEBAL F77_FUNC(zgebal,ZGEBAL)
/* Subroutine */ int LA_ZGEBAL(char *job, integer *n, doublecomplex *a, integer
  *lda, integer *ilo, integer *ihi, doublereal *scale, integer *info);

#define LA_ZGEBD2 F77_FUNC(zgebd2,ZGEBD2)
/* Subroutine */ int LA_ZGEBD2(integer *m, integer *n, doublecomplex *a,
  integer *lda, doublereal *d__, doublereal *e, doublecomplex *tauq,
  doublecomplex *taup, doublecomplex *work, integer *info);

#define LA_ZGEBRD F77_FUNC(zgebrd,ZGEBRD)
/* Subroutine */ int LA_ZGEBRD(integer *m, integer *n, doublecomplex *a,
  integer *lda, doublereal *d__, doublereal *e, doublecomplex *tauq,
  doublecomplex *taup, doublecomplex *work, integer *lwork, integer *
  info);

#define LA_ZGECON F77_FUNC(zgecon,ZGECON)
/* Subroutine */ int LA_ZGECON(char *norm, integer *n, doublecomplex *a,
  integer *lda, doublereal *anorm, doublereal *rcond, doublecomplex *
  work, doublereal *rwork, integer *info);

#define LA_ZGEEQU F77_FUNC(zgeequ,ZGEEQU)
/* Subroutine */ int LA_ZGEEQU(integer *m, integer *n, doublecomplex *a,
  integer *lda, doublereal *r__, doublereal *c__, doublereal *rowcnd,
  doublereal *colcnd, doublereal *amax, integer *info);

#define LA_ZGEES F77_FUNC(zgees,ZGEES)
/* Subroutine */ int LA_ZGEES(char *jobvs, char *sort, L_fp select, integer *n,
  doublecomplex *a, integer *lda, integer *sdim, doublecomplex *w,
  doublecomplex *vs, integer *ldvs, doublecomplex *work, integer *lwork,
   doublereal *rwork, logical *bwork, integer *info);

#define LA_ZGEESX F77_FUNC(zgeesx,ZGEESX)
/* Subroutine */ int LA_ZGEESX(char *jobvs, char *sort, L_fp select, char *
  sense, integer *n, doublecomplex *a, integer *lda, integer *sdim,
  doublecomplex *w, doublecomplex *vs, integer *ldvs, doublereal *
  rconde, doublereal *rcondv, doublecomplex *work, integer *lwork,
  doublereal *rwork, logical *bwork, integer *info);

#define LA_ZGEEV F77_FUNC(zgeev,ZGEEV)
/* Subroutine */ int LA_ZGEEV(char *jobvl, char *jobvr, integer *n,
  doublecomplex *a, integer *lda, doublecomplex *w, doublecomplex *vl,
  integer *ldvl, doublecomplex *vr, integer *ldvr, doublecomplex *work,
  integer *lwork, doublereal *rwork, integer *info);

#define LA_ZGEEVX F77_FUNC(zgeevx,ZGEEVX)
/* Subroutine */ int LA_ZGEEVX(char *balanc, char *jobvl, char *jobvr, char *
  sense, integer *n, doublecomplex *a, integer *lda, doublecomplex *w,
  doublecomplex *vl, integer *ldvl, doublecomplex *vr, integer *ldvr,
  integer *ilo, integer *ihi, doublereal *scale, doublereal *abnrm,
  doublereal *rconde, doublereal *rcondv, doublecomplex *work, integer *
  lwork, doublereal *rwork, integer *info);

#define LA_ZGEGS F77_FUNC(zgegs,ZGEGS)
/* Subroutine */ int LA_ZGEGS(char *jobvsl, char *jobvsr, integer *n,
  doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  doublecomplex *alpha, doublecomplex *beta, doublecomplex *vsl,
  integer *ldvsl, doublecomplex *vsr, integer *ldvsr, doublecomplex *
  work, integer *lwork, doublereal *rwork, integer *info);

#define LA_ZGEGV F77_FUNC(zgegv,ZGEGV)
/* Subroutine */ int LA_ZGEGV(char *jobvl, char *jobvr, integer *n,
  doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  doublecomplex *alpha, doublecomplex *beta, doublecomplex *vl, integer
  *ldvl, doublecomplex *vr, integer *ldvr, doublecomplex *work, integer
  *lwork, doublereal *rwork, integer *info);

#define LA_ZGEHD2 F77_FUNC(zgehd2,ZGEHD2)
/* Subroutine */ int LA_ZGEHD2(integer *n, integer *ilo, integer *ihi,
  doublecomplex *a, integer *lda, doublecomplex *tau, doublecomplex *
  work, integer *info);

#define LA_ZGEHRD F77_FUNC(zgehrd,ZGEHRD)
/* Subroutine */ int LA_ZGEHRD(integer *n, integer *ilo, integer *ihi,
  doublecomplex *a, integer *lda, doublecomplex *tau, doublecomplex *
  work, integer *lwork, integer *info);

#define LA_ZGELQ2 F77_FUNC(zgelq2,ZGELQ2)
/* Subroutine */ int LA_ZGELQ2(integer *m, integer *n, doublecomplex *a,
  integer *lda, doublecomplex *tau, doublecomplex *work, integer *info);

#define LA_ZGELQF F77_FUNC(zgelqf,ZGELQF)
/* Subroutine */ int LA_ZGELQF(integer *m, integer *n, doublecomplex *a,
  integer *lda, doublecomplex *tau, doublecomplex *work, integer *lwork,
   integer *info);

#define LA_ZGELS F77_FUNC(zgels,ZGELS)
/* Subroutine */ int LA_ZGELS(char *trans, integer *m, integer *n, integer *
  nrhs, doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  doublecomplex *work, integer *lwork, integer *info);

#define LA_ZGELSX F77_FUNC(zgelsx,ZGELSX)
/* Subroutine */ int LA_ZGELSX(integer *m, integer *n, integer *nrhs,
  doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  integer *jpvt, doublereal *rcond, integer *rank, doublecomplex *work,
  doublereal *rwork, integer *info);

#define LA_ZGELSY F77_FUNC(zgelsy,ZGELSY)
/* Subroutine */ int LA_ZGELSY(integer *m, integer *n, integer *nrhs,
  doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  integer *jpvt, doublereal *rcond, integer *rank, doublecomplex *work,
  integer *lwork, doublereal *rwork, integer *info);

#define LA_ZGEQL2 F77_FUNC(zgeql2,ZGEQL2)
/* Subroutine */ int LA_ZGEQL2(integer *m, integer *n, doublecomplex *a,
  integer *lda, doublecomplex *tau, doublecomplex *work, integer *info);

#define LA_ZGEQLF F77_FUNC(zgeqlf,ZGEQLF)
/* Subroutine */ int LA_ZGEQLF(integer *m, integer *n, doublecomplex *a,
  integer *lda, doublecomplex *tau, doublecomplex *work, integer *lwork,
   integer *info);

#define LA_ZGEQP3 F77_FUNC(zgeqp3,ZGEQP3)
/* Subroutine */ int LA_ZGEQP3(integer *m, integer *n, doublecomplex *a,
  integer *lda, integer *jpvt, doublecomplex *tau, doublecomplex *work,
  integer *lwork, doublereal *rwork, integer *info);

#define LA_ZGEQPF F77_FUNC(zgeqpf,ZGEQPF)
/* Subroutine */ int LA_ZGEQPF(integer *m, integer *n, doublecomplex *a,
  integer *lda, integer *jpvt, doublecomplex *tau, doublecomplex *work,
  doublereal *rwork, integer *info);

#define LA_ZGEQR2 F77_FUNC(zgeqr2,ZGEQR2)
/* Subroutine */ int LA_ZGEQR2(integer *m, integer *n, doublecomplex *a,
  integer *lda, doublecomplex *tau, doublecomplex *work, integer *info);

#define LA_ZGEQRF F77_FUNC(zgeqrf,ZGEQRF)
/* Subroutine */ int LA_ZGEQRF(integer *m, integer *n, doublecomplex *a,
  integer *lda, doublecomplex *tau, doublecomplex *work, integer *lwork,
   integer *info);

#define LA_ZGERFS F77_FUNC(zgerfs,ZGERFS)
/* Subroutine */ int LA_ZGERFS(char *trans, integer *n, integer *nrhs,
  doublecomplex *a, integer *lda, doublecomplex *af, integer *ldaf,
  integer *ipiv, doublecomplex *b, integer *ldb, doublecomplex *x,
  integer *ldx, doublereal *ferr, doublereal *berr, doublecomplex *work,
   doublereal *rwork, integer *info);

#define LA_ZGERQ2 F77_FUNC(zgerq2,ZGERQ2)
/* Subroutine */ int LA_ZGERQ2(integer *m, integer *n, doublecomplex *a,
  integer *lda, doublecomplex *tau, doublecomplex *work, integer *info);

#define LA_ZGERQF F77_FUNC(zgerqf,ZGERQF)
/* Subroutine */ int LA_ZGERQF(integer *m, integer *n, doublecomplex *a,
  integer *lda, doublecomplex *tau, doublecomplex *work, integer *lwork,
   integer *info);

#define LA_ZGESC2 F77_FUNC(zgesc2,ZGESC2)
/* Subroutine */ int LA_ZGESC2(integer *n, doublecomplex *a, integer *lda,
  doublecomplex *rhs, integer *ipiv, integer *jpiv, doublereal *scale);

#define LA_ZGESV F77_FUNC(zgesv,ZGESV)
/* Subroutine */ int LA_ZGESV(integer *n, integer *nrhs, doublecomplex *a,
  integer *lda, integer *ipiv, doublecomplex *b, integer *ldb, integer *
  info);

#define LA_ZGESVX F77_FUNC(zgesvx,ZGESVX)
/* Subroutine */ int LA_ZGESVX(char *fact, char *trans, integer *n, integer *
  nrhs, doublecomplex *a, integer *lda, doublecomplex *af, integer *
  ldaf, integer *ipiv, char *equed, doublereal *r__, doublereal *c__,
  doublecomplex *b, integer *ldb, doublecomplex *x, integer *ldx,
  doublereal *rcond, doublereal *ferr, doublereal *berr, doublecomplex *
  work, doublereal *rwork, integer *info);

#define LA_ZGETC2 F77_FUNC(zgetc2,ZGETC2)
/* Subroutine */ int LA_ZGETC2(integer *n, doublecomplex *a, integer *lda,
  integer *ipiv, integer *jpiv, integer *info);

#define LA_ZGETF2 F77_FUNC(zgetf2,ZGETF2)
/* Subroutine */ int LA_ZGETF2(integer *m, integer *n, doublecomplex *a,
  integer *lda, integer *ipiv, integer *info);

#define LA_ZGETRF F77_FUNC(zgetrf,ZGETRF)
/* Subroutine */ int LA_ZGETRF(integer *m, integer *n, doublecomplex *a,
  integer *lda, integer *ipiv, integer *info);

#define LA_ZGETRI F77_FUNC(zgetri,ZGETRI)
/* Subroutine */ int LA_ZGETRI(integer *n, doublecomplex *a, integer *lda,
  integer *ipiv, doublecomplex *work, integer *lwork, integer *info);

#define LA_ZGETRS F77_FUNC(zgetrs,ZGETRS)
/* Subroutine */ int LA_ZGETRS(char *trans, integer *n, integer *nrhs,
  doublecomplex *a, integer *lda, integer *ipiv, doublecomplex *b,
  integer *ldb, integer *info);

#define LA_ZGGBAK F77_FUNC(zggbak,ZGGBAK)
/* Subroutine */ int LA_ZGGBAK(char *job, char *side, integer *n, integer *ilo,
  integer *ihi, doublereal *lscale, doublereal *rscale, integer *m,
  doublecomplex *v, integer *ldv, integer *info);

#define LA_ZGGBAL F77_FUNC(zggbal,ZGGBAL)
/* Subroutine */ int LA_ZGGBAL(char *job, integer *n, doublecomplex *a, integer
  *lda, doublecomplex *b, integer *ldb, integer *ilo, integer *ihi,
  doublereal *lscale, doublereal *rscale, doublereal *work, integer *
  info);

#define LA_ZGGES F77_FUNC(zgges,ZGGES)
/* Subroutine */ int LA_ZGGES(char *jobvsl, char *jobvsr, char *sort, L_fp
  delctg, integer *n, doublecomplex *a, integer *lda, doublecomplex *b,
  integer *ldb, integer *sdim, doublecomplex *alpha, doublecomplex *
  beta, doublecomplex *vsl, integer *ldvsl, doublecomplex *vsr, integer
  *ldvsr, doublecomplex *work, integer *lwork, doublereal *rwork,
  logical *bwork, integer *info);

#define LA_ZGGESX F77_FUNC(zggesx,ZGGESX)
/* Subroutine */ int LA_ZGGESX(char *jobvsl, char *jobvsr, char *sort, L_fp
  delctg, char *sense, integer *n, doublecomplex *a, integer *lda,
  doublecomplex *b, integer *ldb, integer *sdim, doublecomplex *alpha,
  doublecomplex *beta, doublecomplex *vsl, integer *ldvsl,
  doublecomplex *vsr, integer *ldvsr, doublereal *rconde, doublereal *
  rcondv, doublecomplex *work, integer *lwork, doublereal *rwork,
  integer *iwork, integer *liwork, logical *bwork, integer *info);

#define LA_ZGGEV F77_FUNC(zggev,ZGGEV)
/* Subroutine */ int LA_ZGGEV(char *jobvl, char *jobvr, integer *n,
  doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  doublecomplex *alpha, doublecomplex *beta, doublecomplex *vl, integer
  *ldvl, doublecomplex *vr, integer *ldvr, doublecomplex *work, integer
  *lwork, doublereal *rwork, integer *info);

#define LA_ZGGEVX F77_FUNC(zggevx,ZGGEVX)
/* Subroutine */ int LA_ZGGEVX(char *balanc, char *jobvl, char *jobvr, char *
  sense, integer *n, doublecomplex *a, integer *lda, doublecomplex *b,
  integer *ldb, doublecomplex *alpha, doublecomplex *beta,
  doublecomplex *vl, integer *ldvl, doublecomplex *vr, integer *ldvr,
  integer *ilo, integer *ihi, doublereal *lscale, doublereal *rscale,
  doublereal *abnrm, doublereal *bbnrm, doublereal *rconde, doublereal *
  rcondv, doublecomplex *work, integer *lwork, doublereal *rwork,
  integer *iwork, logical *bwork, integer *info);

#define LA_ZGGGLM F77_FUNC(zggglm,ZGGGLM)
/* Subroutine */ int LA_ZGGGLM(integer *n, integer *m, integer *p,
  doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  doublecomplex *d__, doublecomplex *x, doublecomplex *y, doublecomplex
  *work, integer *lwork, integer *info);

#define LA_ZGGHRD F77_FUNC(zgghrd,ZGGHRD)
/* Subroutine */ int LA_ZGGHRD(char *compq, char *compz, integer *n, integer *
  ilo, integer *ihi, doublecomplex *a, integer *lda, doublecomplex *b,
  integer *ldb, doublecomplex *q, integer *ldq, doublecomplex *z__,
  integer *ldz, integer *info);

#define LA_ZGGLSE F77_FUNC(zgglse,ZGGLSE)
/* Subroutine */ int LA_ZGGLSE(integer *m, integer *n, integer *p,
  doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  doublecomplex *c__, doublecomplex *d__, doublecomplex *x,
  doublecomplex *work, integer *lwork, integer *info);

#define LA_ZGGQRF F77_FUNC(zggqrf,ZGGQRF)
/* Subroutine */ int LA_ZGGQRF(integer *n, integer *m, integer *p,
  doublecomplex *a, integer *lda, doublecomplex *taua, doublecomplex *b,
   integer *ldb, doublecomplex *taub, doublecomplex *work, integer *
  lwork, integer *info);

#define LA_ZGGRQF F77_FUNC(zggrqf,ZGGRQF)
/* Subroutine */ int LA_ZGGRQF(integer *m, integer *p, integer *n,
  doublecomplex *a, integer *lda, doublecomplex *taua, doublecomplex *b,
   integer *ldb, doublecomplex *taub, doublecomplex *work, integer *
  lwork, integer *info);

#define LA_ZGGSVD F77_FUNC(zggsvd,ZGGSVD)
/* Subroutine */ int LA_ZGGSVD(char *jobu, char *jobv, char *jobq, integer *m,
  integer *n, integer *p, integer *k, integer *l, doublecomplex *a,
  integer *lda, doublecomplex *b, integer *ldb, doublereal *alpha,
  doublereal *beta, doublecomplex *u, integer *ldu, doublecomplex *v,
  integer *ldv, doublecomplex *q, integer *ldq, doublecomplex *work,
  doublereal *rwork, integer *iwork, integer *info);

#define LA_ZGGSVP F77_FUNC(zggsvp,ZGGSVP)
/* Subroutine */ int LA_ZGGSVP(char *jobu, char *jobv, char *jobq, integer *m,
  integer *p, integer *n, doublecomplex *a, integer *lda, doublecomplex
  *b, integer *ldb, doublereal *tola, doublereal *tolb, integer *k,
  integer *l, doublecomplex *u, integer *ldu, doublecomplex *v, integer
  *ldv, doublecomplex *q, integer *ldq, integer *iwork, doublereal *
  rwork, doublecomplex *tau, doublecomplex *work, integer *info);

#define LA_ZGTCON F77_FUNC(zgtcon,ZGTCON)
/* Subroutine */ int LA_ZGTCON(char *norm, integer *n, doublecomplex *dl,
  doublecomplex *d__, doublecomplex *du, doublecomplex *du2, integer *
  ipiv, doublereal *anorm, doublereal *rcond, doublecomplex *work,
  integer *info);

#define LA_ZGTRFS F77_FUNC(zgtrfs,ZGTRFS)
/* Subroutine */ int LA_ZGTRFS(char *trans, integer *n, integer *nrhs,
  doublecomplex *dl, doublecomplex *d__, doublecomplex *du,
  doublecomplex *dlf, doublecomplex *df, doublecomplex *duf,
  doublecomplex *du2, integer *ipiv, doublecomplex *b, integer *ldb,
  doublecomplex *x, integer *ldx, doublereal *ferr, doublereal *berr,
  doublecomplex *work, doublereal *rwork, integer *info);

#define LA_ZGTSV F77_FUNC(zgtsv,ZGTSV)
/* Subroutine */ int LA_ZGTSV(integer *n, integer *nrhs, doublecomplex *dl,
  doublecomplex *d__, doublecomplex *du, doublecomplex *b, integer *ldb,
   integer *info);

#define LA_ZGTSVX F77_FUNC(zgtsvx,ZGTSVX)
/* Subroutine */ int LA_ZGTSVX(char *fact, char *trans, integer *n, integer *
  nrhs, doublecomplex *dl, doublecomplex *d__, doublecomplex *du,
  doublecomplex *dlf, doublecomplex *df, doublecomplex *duf,
  doublecomplex *du2, integer *ipiv, doublecomplex *b, integer *ldb,
  doublecomplex *x, integer *ldx, doublereal *rcond, doublereal *ferr,
  doublereal *berr, doublecomplex *work, doublereal *rwork, integer *
  info);

#define LA_ZGTTRF F77_FUNC(zgttrf,ZGTTRF)
/* Subroutine */ int LA_ZGTTRF(integer *n, doublecomplex *dl, doublecomplex *
  d__, doublecomplex *du, doublecomplex *du2, integer *ipiv, integer *
  info);

#define LA_ZGTTRS F77_FUNC(zgttrs,ZGTTRS)
/* Subroutine */ int LA_ZGTTRS(char *trans, integer *n, integer *nrhs,
  doublecomplex *dl, doublecomplex *d__, doublecomplex *du,
  doublecomplex *du2, integer *ipiv, doublecomplex *b, integer *ldb,
  integer *info);

#define LA_ZGTTS2 F77_FUNC(zgtts2,ZGTTS2)
/* Subroutine */ int LA_ZGTTS2(integer *itrans, integer *n, integer *nrhs,
  doublecomplex *dl, doublecomplex *d__, doublecomplex *du,
  doublecomplex *du2, integer *ipiv, doublecomplex *b, integer *ldb);

#define LA_ZHBEV F77_FUNC(zhbev,ZHBEV)
/* Subroutine */ int LA_ZHBEV(char *jobz, char *uplo, integer *n, integer *kd,
  doublecomplex *ab, integer *ldab, doublereal *w, doublecomplex *z__,
  integer *ldz, doublecomplex *work, doublereal *rwork, integer *info);

#define LA_ZHBEVD F77_FUNC(zhbevd,ZHBEVD)
/* Subroutine */ int LA_ZHBEVD(char *jobz, char *uplo, integer *n, integer *kd,
  doublecomplex *ab, integer *ldab, doublereal *w, doublecomplex *z__,
  integer *ldz, doublecomplex *work, integer *lwork, doublereal *rwork,
  integer *lrwork, integer *iwork, integer *liwork, integer *info);

#define LA_ZHBEVX F77_FUNC(zhbevx,ZHBEVX)
/* Subroutine */ int LA_ZHBEVX(char *jobz, char *range, char *uplo, integer *n,
  integer *kd, doublecomplex *ab, integer *ldab, doublecomplex *q,
  integer *ldq, doublereal *vl, doublereal *vu, integer *il, integer *
  iu, doublereal *abstol, integer *m, doublereal *w, doublecomplex *z__,
   integer *ldz, doublecomplex *work, doublereal *rwork, integer *iwork,
   integer *ifail, integer *info);

#define LA_ZHBGST F77_FUNC(zhbgst,ZHBGST)
/* Subroutine */ int LA_ZHBGST(char *vect, char *uplo, integer *n, integer *ka,
  integer *kb, doublecomplex *ab, integer *ldab, doublecomplex *bb,
  integer *ldbb, doublecomplex *x, integer *ldx, doublecomplex *work,
  doublereal *rwork, integer *info);

#define LA_ZHBGV F77_FUNC(zhbgv,ZHBGV)
/* Subroutine */ int LA_ZHBGV(char *jobz, char *uplo, integer *n, integer *ka,
  integer *kb, doublecomplex *ab, integer *ldab, doublecomplex *bb,
  integer *ldbb, doublereal *w, doublecomplex *z__, integer *ldz,
  doublecomplex *work, doublereal *rwork, integer *info);

#define LA_ZHBGVX F77_FUNC(zhbgvx,ZHBGVX)
/* Subroutine */ int LA_ZHBGVX(char *jobz, char *range, char *uplo, integer *n,
  integer *ka, integer *kb, doublecomplex *ab, integer *ldab,
  doublecomplex *bb, integer *ldbb, doublecomplex *q, integer *ldq,
  doublereal *vl, doublereal *vu, integer *il, integer *iu, doublereal *
  abstol, integer *m, doublereal *w, doublecomplex *z__, integer *ldz,
  doublecomplex *work, doublereal *rwork, integer *iwork, integer *
  ifail, integer *info);

#define LA_ZHBTRD F77_FUNC(zhbtrd,ZHBTRD)
/* Subroutine */ int LA_ZHBTRD(char *vect, char *uplo, integer *n, integer *kd,
  doublecomplex *ab, integer *ldab, doublereal *d__, doublereal *e,
  doublecomplex *q, integer *ldq, doublecomplex *work, integer *info);

#define LA_ZHECON F77_FUNC(zhecon,ZHECON)
/* Subroutine */ int LA_ZHECON(char *uplo, integer *n, doublecomplex *a,
  integer *lda, integer *ipiv, doublereal *anorm, doublereal *rcond,
  doublecomplex *work, integer *info);

#define LA_ZHEEV F77_FUNC(zheev,ZHEEV)
/* Subroutine */ int LA_ZHEEV(char *jobz, char *uplo, integer *n, doublecomplex
  *a, integer *lda, doublereal *w, doublecomplex *work, integer *lwork,
  doublereal *rwork, integer *info);

#define LA_ZHEEVD F77_FUNC(zheevd,ZHEEVD)
/* Subroutine */ int LA_ZHEEVD(char *jobz, char *uplo, integer *n,
  doublecomplex *a, integer *lda, doublereal *w, doublecomplex *work,
  integer *lwork, doublereal *rwork, integer *lrwork, integer *iwork,
  integer *liwork, integer *info);

#define LA_ZHEEVR F77_FUNC(zheevr,ZHEEVR)
/* Subroutine */ int LA_ZHEEVR(char *jobz, char *range, char *uplo, integer *n,
  doublecomplex *a, integer *lda, doublereal *vl, doublereal *vu,
  integer *il, integer *iu, doublereal *abstol, integer *m, doublereal *
  w, doublecomplex *z__, integer *ldz, integer *isuppz, doublecomplex *
  work, integer *lwork, doublereal *rwork, integer *lrwork, integer *
  iwork, integer *liwork, integer *info);

#define LA_ZHEEVX F77_FUNC(zheevx,ZHEEVX)
/* Subroutine */ int LA_ZHEEVX(char *jobz, char *range, char *uplo, integer *n,
  doublecomplex *a, integer *lda, doublereal *vl, doublereal *vu,
  integer *il, integer *iu, doublereal *abstol, integer *m, doublereal *
  w, doublecomplex *z__, integer *ldz, doublecomplex *work, integer *
  lwork, doublereal *rwork, integer *iwork, integer *ifail, integer *
  info);

#define LA_ZHEGS2 F77_FUNC(zhegs2,ZHEGS2)
/* Subroutine */ int LA_ZHEGS2(integer *itype, char *uplo, integer *n,
  doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  integer *info);

#define LA_ZHEGST F77_FUNC(zhegst,ZHEGST)
/* Subroutine */ int LA_ZHEGST(integer *itype, char *uplo, integer *n,
  doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  integer *info);

#define LA_ZHEGV F77_FUNC(zhegv,ZHEGV)
/* Subroutine */ int LA_ZHEGV(integer *itype, char *jobz, char *uplo, integer *
  n, doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  doublereal *w, doublecomplex *work, integer *lwork, doublereal *rwork,
   integer *info);

#define LA_ZHEGVD F77_FUNC(zhegvd,ZHEGVD)
/* Subroutine */ int LA_ZHEGVD(integer *itype, char *jobz, char *uplo, integer *
  n, doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  doublereal *w, doublecomplex *work, integer *lwork, doublereal *rwork,
   integer *lrwork, integer *iwork, integer *liwork, integer *info);

#define LA_ZHEGVX F77_FUNC(zhegvx,ZHEGVX)
/* Subroutine */ int LA_ZHEGVX(integer *itype, char *jobz, char *range, char *
  uplo, integer *n, doublecomplex *a, integer *lda, doublecomplex *b,
  integer *ldb, doublereal *vl, doublereal *vu, integer *il, integer *
  iu, doublereal *abstol, integer *m, doublereal *w, doublecomplex *z__,
   integer *ldz, doublecomplex *work, integer *lwork, doublereal *rwork,
   integer *iwork, integer *ifail, integer *info);

#define LA_ZHERFS F77_FUNC(zherfs,ZHERFS)
/* Subroutine */ int LA_ZHERFS(char *uplo, integer *n, integer *nrhs,
  doublecomplex *a, integer *lda, doublecomplex *af, integer *ldaf,
  integer *ipiv, doublecomplex *b, integer *ldb, doublecomplex *x,
  integer *ldx, doublereal *ferr, doublereal *berr, doublecomplex *work,
   doublereal *rwork, integer *info);

#define LA_ZHESV F77_FUNC(zhesv,ZHESV)
/* Subroutine */ int LA_ZHESV(char *uplo, integer *n, integer *nrhs,
  doublecomplex *a, integer *lda, integer *ipiv, doublecomplex *b,
  integer *ldb, doublecomplex *work, integer *lwork, integer *info);

#define LA_ZHESVX F77_FUNC(zhesvx,ZHESVX)
/* Subroutine */ int LA_ZHESVX(char *fact, char *uplo, integer *n, integer *
  nrhs, doublecomplex *a, integer *lda, doublecomplex *af, integer *
  ldaf, integer *ipiv, doublecomplex *b, integer *ldb, doublecomplex *x,
   integer *ldx, doublereal *rcond, doublereal *ferr, doublereal *berr,
  doublecomplex *work, integer *lwork, doublereal *rwork, integer *info);

#define LA_ZHETF2 F77_FUNC(zhetf2,ZHETF2)
/* Subroutine */ int LA_ZHETF2(char *uplo, integer *n, doublecomplex *a,
  integer *lda, integer *ipiv, integer *info);

#define LA_ZHETRD F77_FUNC(zhetrd,ZHETRD)
/* Subroutine */ int LA_ZHETRD(char *uplo, integer *n, doublecomplex *a,
  integer *lda, doublereal *d__, doublereal *e, doublecomplex *tau,
  doublecomplex *work, integer *lwork, integer *info);

#define LA_ZHETRF F77_FUNC(zhetrf,ZHETRF)
/* Subroutine */ int LA_ZHETRF(char *uplo, integer *n, doublecomplex *a,
  integer *lda, integer *ipiv, doublecomplex *work, integer *lwork,
  integer *info);

#define LA_ZHETRI F77_FUNC(zhetri,ZHETRI)
/* Subroutine */ int LA_ZHETRI(char *uplo, integer *n, doublecomplex *a,
  integer *lda, integer *ipiv, doublecomplex *work, integer *info);

#define LA_ZHETRS F77_FUNC(zhetrs,ZHETRS)
/* Subroutine */ int LA_ZHETRS(char *uplo, integer *n, integer *nrhs,
  doublecomplex *a, integer *lda, integer *ipiv, doublecomplex *b,
  integer *ldb, integer *info);

#define LA_ZHGEQZ F77_FUNC(zhgeqz,ZHGEQZ)
/* Subroutine */ int LA_ZHGEQZ(char *job, char *compq, char *compz, integer *n,
  integer *ilo, integer *ihi, doublecomplex *a, integer *lda,
  doublecomplex *b, integer *ldb, doublecomplex *alpha, doublecomplex *
  beta, doublecomplex *q, integer *ldq, doublecomplex *z__, integer *
  ldz, doublecomplex *work, integer *lwork, doublereal *rwork, integer *
  info);

#define LA_ZHPCON F77_FUNC(zhpcon,ZHPCON)
/* Subroutine */ int LA_ZHPCON(char *uplo, integer *n, doublecomplex *ap,
  integer *ipiv, doublereal *anorm, doublereal *rcond, doublecomplex *
  work, integer *info);

#define LA_ZHPEV F77_FUNC(zhpev,ZHPEV)
/* Subroutine */ int LA_ZHPEV(char *jobz, char *uplo, integer *n, doublecomplex
  *ap, doublereal *w, doublecomplex *z__, integer *ldz, doublecomplex *
  work, doublereal *rwork, integer *info);

#define LA_ZHPEVD F77_FUNC(zhpevd,ZHPEVD)
/* Subroutine */ int LA_ZHPEVD(char *jobz, char *uplo, integer *n,
  doublecomplex *ap, doublereal *w, doublecomplex *z__, integer *ldz,
  doublecomplex *work, integer *lwork, doublereal *rwork, integer *
  lrwork, integer *iwork, integer *liwork, integer *info);

#define LA_ZHPEVX F77_FUNC(zhpevx,ZHPEVX)
/* Subroutine */ int LA_ZHPEVX(char *jobz, char *range, char *uplo, integer *n,
  doublecomplex *ap, doublereal *vl, doublereal *vu, integer *il,
  integer *iu, doublereal *abstol, integer *m, doublereal *w,
  doublecomplex *z__, integer *ldz, doublecomplex *work, doublereal *
  rwork, integer *iwork, integer *ifail, integer *info);

#define LA_ZHPGST F77_FUNC(zhpgst,ZHPGST)
/* Subroutine */ int LA_ZHPGST(integer *itype, char *uplo, integer *n,
  doublecomplex *ap, doublecomplex *bp, integer *info);

#define LA_ZHPGV F77_FUNC(zhpgv,ZHPGV)
/* Subroutine */ int LA_ZHPGV(integer *itype, char *jobz, char *uplo, integer *
  n, doublecomplex *ap, doublecomplex *bp, doublereal *w, doublecomplex
  *z__, integer *ldz, doublecomplex *work, doublereal *rwork, integer *
  info);

#define LA_ZHPGVD F77_FUNC(zhpgvd,ZHPGVD)
/* Subroutine */ int LA_ZHPGVD(integer *itype, char *jobz, char *uplo, integer *
  n, doublecomplex *ap, doublecomplex *bp, doublereal *w, doublecomplex
  *z__, integer *ldz, doublecomplex *work, integer *lwork, doublereal *
  rwork, integer *lrwork, integer *iwork, integer *liwork, integer *
  info);

#define LA_ZHPGVX F77_FUNC(zhpgvx,ZHPGVX)
/* Subroutine */ int LA_ZHPGVX(integer *itype, char *jobz, char *range, char *
  uplo, integer *n, doublecomplex *ap, doublecomplex *bp, doublereal *
  vl, doublereal *vu, integer *il, integer *iu, doublereal *abstol,
  integer *m, doublereal *w, doublecomplex *z__, integer *ldz,
  doublecomplex *work, doublereal *rwork, integer *iwork, integer *
  ifail, integer *info);

#define LA_ZHPRFS F77_FUNC(zhprfs,ZHPRFS)
/* Subroutine */ int LA_ZHPRFS(char *uplo, integer *n, integer *nrhs,
  doublecomplex *ap, doublecomplex *afp, integer *ipiv, doublecomplex *
  b, integer *ldb, doublecomplex *x, integer *ldx, doublereal *ferr,
  doublereal *berr, doublecomplex *work, doublereal *rwork, integer *
  info);

#define LA_ZHPSV F77_FUNC(zhpsv,ZHPSV)
/* Subroutine */ int LA_ZHPSV(char *uplo, integer *n, integer *nrhs,
  doublecomplex *ap, integer *ipiv, doublecomplex *b, integer *ldb,
  integer *info);

#define LA_ZHPSVX F77_FUNC(zhpsvx,ZHPSVX)
/* Subroutine */ int LA_ZHPSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, doublecomplex *ap, doublecomplex *afp, integer *ipiv,
  doublecomplex *b, integer *ldb, doublecomplex *x, integer *ldx,
  doublereal *rcond, doublereal *ferr, doublereal *berr, doublecomplex *
  work, doublereal *rwork, integer *info);

#define LA_ZHPTRD F77_FUNC(zhptrd,ZHPTRD)
/* Subroutine */ int LA_ZHPTRD(char *uplo, integer *n, doublecomplex *ap,
  doublereal *d__, doublereal *e, doublecomplex *tau, integer *info);

#define LA_ZHPTRF F77_FUNC(zhptrf,ZHPTRF)
/* Subroutine */ int LA_ZHPTRF(char *uplo, integer *n, doublecomplex *ap,
  integer *ipiv, integer *info);

#define LA_ZHPTRI F77_FUNC(zhptri,ZHPTRI)
/* Subroutine */ int LA_ZHPTRI(char *uplo, integer *n, doublecomplex *ap,
  integer *ipiv, doublecomplex *work, integer *info);

#define LA_ZHPTRS F77_FUNC(zhptrs,ZHPTRS)
/* Subroutine */ int LA_ZHPTRS(char *uplo, integer *n, integer *nrhs,
  doublecomplex *ap, integer *ipiv, doublecomplex *b, integer *ldb,
  integer *info);

#define LA_ZHSEIN F77_FUNC(zhsein,ZHSEIN)
/* Subroutine */ int LA_ZHSEIN(char *side, char *eigsrc, char *initv, logical *
  select, integer *n, doublecomplex *h__, integer *ldh, doublecomplex *
  w, doublecomplex *vl, integer *ldvl, doublecomplex *vr, integer *ldvr,
   integer *mm, integer *m, doublecomplex *work, doublereal *rwork,
  integer *ifaill, integer *ifailr, integer *info);

#define LA_ZHSEQR F77_FUNC(zhseqr,ZHSEQR)
/* Subroutine */ int LA_ZHSEQR(char *job, char *compz, integer *n, integer *ilo,
   integer *ihi, doublecomplex *h__, integer *ldh, doublecomplex *w,
  doublecomplex *z__, integer *ldz, doublecomplex *work, integer *lwork,
   integer *info);

#define LA_ZLABRD F77_FUNC(zlabrd,ZLABRD)
/* Subroutine */ int LA_ZLABRD(integer *m, integer *n, integer *nb,
  doublecomplex *a, integer *lda, doublereal *d__, doublereal *e,
  doublecomplex *tauq, doublecomplex *taup, doublecomplex *x, integer *
  ldx, doublecomplex *y, integer *ldy);

#define LA_ZLACGV F77_FUNC(zlacgv,ZLACGV)
/* Subroutine */ int LA_ZLACGV(integer *n, doublecomplex *x, integer *incx);

#define LA_ZLACON F77_FUNC(zlacon,ZLACON)
/* Subroutine */ int LA_ZLACON(integer *n, doublecomplex *v, doublecomplex *x,
  doublereal *est, integer *kase);

#define LA_ZLACP2 F77_FUNC(zlacp2,ZLACP2)
/* Subroutine */ int LA_ZLACP2(char *uplo, integer *m, integer *n, doublereal *
  a, integer *lda, doublecomplex *b, integer *ldb);

#define LA_ZLACPY F77_FUNC(zlacpy,ZLACPY)
/* Subroutine */ int LA_ZLACPY(char *uplo, integer *m, integer *n,
  doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb);

#define LA_ZLACRM F77_FUNC(zlacrm,ZLACRM)
/* Subroutine */ int LA_ZLACRM(integer *m, integer *n, doublecomplex *a,
  integer *lda, doublereal *b, integer *ldb, doublecomplex *c__,
  integer *ldc, doublereal *rwork);

#define LA_ZLACRT F77_FUNC(zlacrt,ZLACRT)
/* Subroutine */ int LA_ZLACRT(integer *n, doublecomplex *cx, integer *incx,
  doublecomplex *cy, integer *incy, doublecomplex *c__, doublecomplex *
  s);

#define LA_ZLAED0 F77_FUNC(zlaed0,ZLAED0)
/* Subroutine */ int LA_ZLAED0(integer *qsiz, integer *n, doublereal *d__,
  doublereal *e, doublecomplex *q, integer *ldq, doublecomplex *qstore,
  integer *ldqs, doublereal *rwork, integer *iwork, integer *info);

#define LA_ZLAED7 F77_FUNC(zlaed7,ZLAED7)
/* Subroutine */ int LA_ZLAED7(integer *n, integer *cutpnt, integer *qsiz,
  integer *tlvls, integer *curlvl, integer *curpbm, doublereal *d__,
  doublecomplex *q, integer *ldq, doublereal *rho, integer *indxq,
  doublereal *qstore, integer *qptr, integer *prmptr, integer *perm,
  integer *givptr, integer *givcol, doublereal *givnum, doublecomplex *
  work, doublereal *rwork, integer *iwork, integer *info);

#define LA_ZLAED8 F77_FUNC(zlaed8,ZLAED8)
/* Subroutine */ int LA_ZLAED8(integer *k, integer *n, integer *qsiz,
  doublecomplex *q, integer *ldq, doublereal *d__, doublereal *rho,
  integer *cutpnt, doublereal *z__, doublereal *dlamda, doublecomplex *
  q2, integer *ldq2, doublereal *w, integer *indxp, integer *indx,
  integer *indxq, integer *perm, integer *givptr, integer *givcol,
  doublereal *givnum, integer *info);

#define LA_ZLAEIN F77_FUNC(zlaein,ZLAEIN)
/* Subroutine */ int LA_ZLAEIN(logical *rightv, logical *noinit, integer *n,
  doublecomplex *h__, integer *ldh, doublecomplex *w, doublecomplex *v,
  doublecomplex *b, integer *ldb, doublereal *rwork, doublereal *eps3,
  doublereal *smlnum, integer *info);

#define LA_ZLAESY F77_FUNC(zlaesy,ZLAESY)
/* Subroutine */ int LA_ZLAESY(doublecomplex *a, doublecomplex *b,
  doublecomplex *c__, doublecomplex *rt1, doublecomplex *rt2,
  doublecomplex *evscal, doublecomplex *cs1, doublecomplex *sn1);

#define LA_ZLAEV2 F77_FUNC(zlaev2,ZLAEV2)
/* Subroutine */ int LA_ZLAEV2(doublecomplex *a, doublecomplex *b,
  doublecomplex *c__, doublereal *rt1, doublereal *rt2, doublereal *cs1,
   doublecomplex *sn1);

#define LA_ZLAGS2 F77_FUNC(zlags2,ZLAGS2)
/* Subroutine */ int LA_ZLAGS2(logical *upper, doublereal *a1, doublecomplex *
  a2, doublereal *a3, doublereal *b1, doublecomplex *b2, doublereal *b3,
   doublereal *csu, doublecomplex *snu, doublereal *csv, doublecomplex *
  snv, doublereal *csq, doublecomplex *snq);

#define LA_ZLAGTM F77_FUNC(zlagtm,ZLAGTM)
/* Subroutine */ int LA_ZLAGTM(char *trans, integer *n, integer *nrhs,
  doublereal *alpha, doublecomplex *dl, doublecomplex *d__,
  doublecomplex *du, doublecomplex *x, integer *ldx, doublereal *beta,
  doublecomplex *b, integer *ldb);

#define LA_ZLAHEF F77_FUNC(zlahef,ZLAHEF)
/* Subroutine */ int LA_ZLAHEF(char *uplo, integer *n, integer *nb, integer *kb,
   doublecomplex *a, integer *lda, integer *ipiv, doublecomplex *w,
  integer *ldw, integer *info);

#define LA_ZLAHQR F77_FUNC(zlahqr,ZLAHQR)
/* Subroutine */ int LA_ZLAHQR(logical *wantt, logical *wantz, integer *n,
  integer *ilo, integer *ihi, doublecomplex *h__, integer *ldh,
  doublecomplex *w, integer *iloz, integer *ihiz, doublecomplex *z__,
  integer *ldz, integer *info);

#define LA_ZLAHRD F77_FUNC(zlahrd,ZLAHRD)
/* Subroutine */ int LA_ZLAHRD(integer *n, integer *k, integer *nb,
  doublecomplex *a, integer *lda, doublecomplex *tau, doublecomplex *t,
  integer *ldt, doublecomplex *y, integer *ldy);

#define LA_ZLAIC1 F77_FUNC(zlaic1,ZLAIC1)
/* Subroutine */ int LA_ZLAIC1(integer *job, integer *j, doublecomplex *x,
  doublereal *sest, doublecomplex *w, doublecomplex *gamma, doublereal *
  sestpr, doublecomplex *s, doublecomplex *c__);

#define LA_ZLALS0 F77_FUNC(zlals0,ZLALS0)
/* Subroutine */ int LA_ZLALS0(integer *icompq, integer *nl, integer *nr,
  integer *sqre, integer *nrhs, doublecomplex *b, integer *ldb,
  doublecomplex *bx, integer *ldbx, integer *perm, integer *givptr,
  integer *givcol, integer *ldgcol, doublereal *givnum, integer *ldgnum,
   doublereal *poles, doublereal *difl, doublereal *difr, doublereal *
  z__, integer *k, doublereal *c__, doublereal *s, doublereal *rwork,
  integer *info);

#define LA_ZLALSA F77_FUNC(zlalsa,ZLALSA)
/* Subroutine */ int LA_ZLALSA(integer *icompq, integer *smlsiz, integer *n,
  integer *nrhs, doublecomplex *b, integer *ldb, doublecomplex *bx,
  integer *ldbx, doublereal *u, integer *ldu, doublereal *vt, integer *
  k, doublereal *difl, doublereal *difr, doublereal *z__, doublereal *
  poles, integer *givptr, integer *givcol, integer *ldgcol, integer *
  perm, doublereal *givnum, doublereal *c__, doublereal *s, doublereal *
  rwork, integer *iwork, integer *info);

#define LA_ZLAPLL F77_FUNC(zlapll,ZLAPLL)
/* Subroutine */ int LA_ZLAPLL(integer *n, doublecomplex *x, integer *incx,
  doublecomplex *y, integer *incy, doublereal *ssmin);

#define LA_ZLAPMT F77_FUNC(zlapmt,ZLAPMT)
/* Subroutine */ int LA_ZLAPMT(logical *forwrd, integer *m, integer *n,
  doublecomplex *x, integer *ldx, integer *k);

#define LA_ZLAQGB F77_FUNC(zlaqgb,ZLAQGB)
/* Subroutine */ int LA_ZLAQGB(integer *m, integer *n, integer *kl, integer *ku,
   doublecomplex *ab, integer *ldab, doublereal *r__, doublereal *c__,
  doublereal *rowcnd, doublereal *colcnd, doublereal *amax, char *equed);

#define LA_ZLAQGE F77_FUNC(zlaqge,ZLAQGE)
/* Subroutine */ int LA_ZLAQGE(integer *m, integer *n, doublecomplex *a,
  integer *lda, doublereal *r__, doublereal *c__, doublereal *rowcnd,
  doublereal *colcnd, doublereal *amax, char *equed);

#define LA_ZLAQHB F77_FUNC(zlaqhb,ZLAQHB)
/* Subroutine */ int LA_ZLAQHB(char *uplo, integer *n, integer *kd,
  doublecomplex *ab, integer *ldab, doublereal *s, doublereal *scond,
  doublereal *amax, char *equed);

#define LA_ZLAQHE F77_FUNC(zlaqhe,ZLAQHE)
/* Subroutine */ int LA_ZLAQHE(char *uplo, integer *n, doublecomplex *a,
  integer *lda, doublereal *s, doublereal *scond, doublereal *amax,
  char *equed);

#define LA_ZLAQHP F77_FUNC(zlaqhp,ZLAQHP)
/* Subroutine */ int LA_ZLAQHP(char *uplo, integer *n, doublecomplex *ap,
  doublereal *s, doublereal *scond, doublereal *amax, char *equed);

#define LA_ZLAQP2 F77_FUNC(zlaqp2,ZLAQP2)
/* Subroutine */ int LA_ZLAQP2(integer *m, integer *n, integer *offset,
  doublecomplex *a, integer *lda, integer *jpvt, doublecomplex *tau,
  doublereal *vn1, doublereal *vn2, doublecomplex *work);

#define LA_ZLAQPS F77_FUNC(zlaqps,ZLAQPS)
/* Subroutine */ int LA_ZLAQPS(integer *m, integer *n, integer *offset, integer
  *nb, integer *kb, doublecomplex *a, integer *lda, integer *jpvt,
  doublecomplex *tau, doublereal *vn1, doublereal *vn2, doublecomplex *
  auxv, doublecomplex *f, integer *ldf);

#define LA_ZLAQSB F77_FUNC(zlaqsb,ZLAQSB)
/* Subroutine */ int LA_ZLAQSB(char *uplo, integer *n, integer *kd,
  doublecomplex *ab, integer *ldab, doublereal *s, doublereal *scond,
  doublereal *amax, char *equed);

#define LA_ZLAQSP F77_FUNC(zlaqsp,ZLAQSP)
/* Subroutine */ int LA_ZLAQSP(char *uplo, integer *n, doublecomplex *ap,
  doublereal *s, doublereal *scond, doublereal *amax, char *equed);

#define LA_ZLAQSY F77_FUNC(zlaqsy,ZLAQSY)
/* Subroutine */ int LA_ZLAQSY(char *uplo, integer *n, doublecomplex *a,
  integer *lda, doublereal *s, doublereal *scond, doublereal *amax,
  char *equed);

#define LA_ZLAR1V F77_FUNC(zlar1v,ZLAR1V)
/* Subroutine */ int LA_ZLAR1V(integer *n, integer *b1, integer *bn, doublereal
  *sigma, doublereal *d__, doublereal *l, doublereal *ld, doublereal *
  lld, doublereal *gersch, doublecomplex *z__, doublereal *ztz,
  doublereal *mingma, integer *r__, integer *isuppz, doublereal *work);

#define LA_ZLAR2V F77_FUNC(zlar2v,ZLAR2V)
/* Subroutine */ int LA_ZLAR2V(integer *n, doublecomplex *x, doublecomplex *y,
  doublecomplex *z__, integer *incx, doublereal *c__, doublecomplex *s,
  integer *incc);

#define LA_ZLARCM F77_FUNC(zlarcm,ZLARCM)
/* Subroutine */ int LA_ZLARCM(integer *m, integer *n, doublereal *a, integer *
  lda, doublecomplex *b, integer *ldb, doublecomplex *c__, integer *ldc,
   doublereal *rwork);

#define LA_ZLARF F77_FUNC(zlarf,ZLARF)
/* Subroutine */ int LA_ZLARF(char *side, integer *m, integer *n, doublecomplex
  *v, integer *incv, doublecomplex *tau, doublecomplex *c__, integer *
  ldc, doublecomplex *work);

#define LA_ZLARFB F77_FUNC(zlarfb,ZLARFB)
/* Subroutine */ int LA_ZLARFB(char *side, char *trans, char *direct, char *
  storev, integer *m, integer *n, integer *k, doublecomplex *v, integer
  *ldv, doublecomplex *t, integer *ldt, doublecomplex *c__, integer *
  ldc, doublecomplex *work, integer *ldwork);

#define LA_ZLARFG F77_FUNC(zlarfg,ZLARFG)
/* Subroutine */ int LA_ZLARFG(integer *n, doublecomplex *alpha, doublecomplex *
  x, integer *incx, doublecomplex *tau);

#define LA_ZLARFT F77_FUNC(zlarft,ZLARFT)
/* Subroutine */ int LA_ZLARFT(char *direct, char *storev, integer *n, integer *
  k, doublecomplex *v, integer *ldv, doublecomplex *tau, doublecomplex *
  t, integer *ldt);

#define LA_ZLARFX F77_FUNC(zlarfx,ZLARFX)
/* Subroutine */ int LA_ZLARFX(char *side, integer *m, integer *n,
  doublecomplex *v, doublecomplex *tau, doublecomplex *c__, integer *
  ldc, doublecomplex *work);

#define LA_ZLARGV F77_FUNC(zlargv,ZLARGV)
/* Subroutine */ int LA_ZLARGV(integer *n, doublecomplex *x, integer *incx,
  doublecomplex *y, integer *incy, doublereal *c__, integer *incc);

#define LA_ZLARNV F77_FUNC(zlarnv,ZLARNV)
/* Subroutine */ int LA_ZLARNV(integer *idist, integer *iseed, integer *n,
  doublecomplex *x);

#define LA_ZLARRV F77_FUNC(zlarrv,ZLARRV)
/* Subroutine */ int LA_ZLARRV(integer *n, doublereal *d__, doublereal *l,
  integer *isplit, integer *m, doublereal *w, integer *iblock,
  doublereal *gersch, doublereal *tol, doublecomplex *z__, integer *ldz,
   integer *isuppz, doublereal *work, integer *iwork, integer *info);

#define LA_ZLARTG F77_FUNC(zlartg,ZLARTG)
/* Subroutine */ int LA_ZLARTG(doublecomplex *f, doublecomplex *g, doublereal *
  cs, doublecomplex *sn, doublecomplex *r__);

#define LA_ZLARTV F77_FUNC(zlartv,ZLARTV)
/* Subroutine */ int LA_ZLARTV(integer *n, doublecomplex *x, integer *incx,
  doublecomplex *y, integer *incy, doublereal *c__, doublecomplex *s,
  integer *incc);

#define LA_ZLARZ F77_FUNC(zlarz,ZLARZ)
/* Subroutine */ int LA_ZLARZ(char *side, integer *m, integer *n, integer *l,
  doublecomplex *v, integer *incv, doublecomplex *tau, doublecomplex *
  c__, integer *ldc, doublecomplex *work);

#define LA_ZLARZB F77_FUNC(zlarzb,ZLARZB)
/* Subroutine */ int LA_ZLARZB(char *side, char *trans, char *direct, char *
  storev, integer *m, integer *n, integer *k, integer *l, doublecomplex
  *v, integer *ldv, doublecomplex *t, integer *ldt, doublecomplex *c__,
  integer *ldc, doublecomplex *work, integer *ldwork);

#define LA_ZLARZT F77_FUNC(zlarzt,ZLARZT)
/* Subroutine */ int LA_ZLARZT(char *direct, char *storev, integer *n, integer *
  k, doublecomplex *v, integer *ldv, doublecomplex *tau, doublecomplex *
  t, integer *ldt);

#define LA_ZLASCL F77_FUNC(zlascl,ZLASCL)
/* Subroutine */ int LA_ZLASCL(char *type__, integer *kl, integer *ku,
  doublereal *cfrom, doublereal *cto, integer *m, integer *n,
  doublecomplex *a, integer *lda, integer *info);

#define LA_ZLASET F77_FUNC(zlaset,ZLASET)
/* Subroutine */ int LA_ZLASET(char *uplo, integer *m, integer *n,
  doublecomplex *alpha, doublecomplex *beta, doublecomplex *a, integer *
  lda);

#define LA_ZLASR F77_FUNC(zlasr,ZLASR)
/* Subroutine */ int LA_ZLASR(char *side, char *pivot, char *direct, integer *m,
   integer *n, doublereal *c__, doublereal *s, doublecomplex *a,
  integer *lda);

#define LA_ZLASSQ F77_FUNC(zlassq,ZLASSQ)
/* Subroutine */ int LA_ZLASSQ(integer *n, doublecomplex *x, integer *incx,
  doublereal *scale, doublereal *sumsq);

#define LA_ZLASWP F77_FUNC(zlaswp,ZLASWP)
/* Subroutine */ int LA_ZLASWP(integer *n, doublecomplex *a, integer *lda,
  integer *k1, integer *k2, integer *ipiv, integer *incx);

#define LA_ZLASYF F77_FUNC(zlasyf,ZLASYF)
/* Subroutine */ int LA_ZLASYF(char *uplo, integer *n, integer *nb, integer *kb,
   doublecomplex *a, integer *lda, integer *ipiv, doublecomplex *w,
  integer *ldw, integer *info);

#define LA_ZLATBS F77_FUNC(zlatbs,ZLATBS)
/* Subroutine */ int LA_ZLATBS(char *uplo, char *trans, char *diag, char *
  normin, integer *n, integer *kd, doublecomplex *ab, integer *ldab,
  doublecomplex *x, doublereal *scale, doublereal *cnorm, integer *info);

#define LA_ZLATDF F77_FUNC(zlatdf,ZLATDF)
/* Subroutine */ int LA_ZLATDF(integer *ijob, integer *n, doublecomplex *z__,
  integer *ldz, doublecomplex *rhs, doublereal *rdsum, doublereal *
  rdscal, integer *ipiv, integer *jpiv);

#define LA_ZLATPS F77_FUNC(zlatps,ZLATPS)
/* Subroutine */ int LA_ZLATPS(char *uplo, char *trans, char *diag, char *
  normin, integer *n, doublecomplex *ap, doublecomplex *x, doublereal *
  scale, doublereal *cnorm, integer *info);

#define LA_ZLATRD F77_FUNC(zlatrd,ZLATRD)
/* Subroutine */ int LA_ZLATRD(char *uplo, integer *n, integer *nb,
  doublecomplex *a, integer *lda, doublereal *e, doublecomplex *tau,
  doublecomplex *w, integer *ldw);

#define LA_ZLATRS F77_FUNC(zlatrs,ZLATRS)
/* Subroutine */ int LA_ZLATRS(char *uplo, char *trans, char *diag, char *
  normin, integer *n, doublecomplex *a, integer *lda, doublecomplex *x,
  doublereal *scale, doublereal *cnorm, integer *info);

#define LA_ZLATRZ F77_FUNC(zlatrz,ZLATRZ)
/* Subroutine */ int LA_ZLATRZ(integer *m, integer *n, integer *l,
  doublecomplex *a, integer *lda, doublecomplex *tau, doublecomplex *
  work);

#define LA_ZLATZM F77_FUNC(zlatzm,ZLATZM)
/* Subroutine */ int LA_ZLATZM(char *side, integer *m, integer *n,
  doublecomplex *v, integer *incv, doublecomplex *tau, doublecomplex *
  c1, doublecomplex *c2, integer *ldc, doublecomplex *work);

#define LA_ZLAUU2 F77_FUNC(zlauu2,ZLAUU2)
/* Subroutine */ int LA_ZLAUU2(char *uplo, integer *n, doublecomplex *a,
  integer *lda, integer *info);

#define LA_ZLAUUM F77_FUNC(zlauum,ZLAUUM)
/* Subroutine */ int LA_ZLAUUM(char *uplo, integer *n, doublecomplex *a,
  integer *lda, integer *info);

#define LA_ZPBCON F77_FUNC(zpbcon,ZPBCON)
/* Subroutine */ int LA_ZPBCON(char *uplo, integer *n, integer *kd,
  doublecomplex *ab, integer *ldab, doublereal *anorm, doublereal *
  rcond, doublecomplex *work, doublereal *rwork, integer *info);

#define LA_ZPBEQU F77_FUNC(zpbequ,ZPBEQU)
/* Subroutine */ int LA_ZPBEQU(char *uplo, integer *n, integer *kd,
  doublecomplex *ab, integer *ldab, doublereal *s, doublereal *scond,
  doublereal *amax, integer *info);

#define LA_ZPBRFS F77_FUNC(zpbrfs,ZPBRFS)
/* Subroutine */ int LA_ZPBRFS(char *uplo, integer *n, integer *kd, integer *
  nrhs, doublecomplex *ab, integer *ldab, doublecomplex *afb, integer *
  ldafb, doublecomplex *b, integer *ldb, doublecomplex *x, integer *ldx,
   doublereal *ferr, doublereal *berr, doublecomplex *work, doublereal *
  rwork, integer *info);

#define LA_ZPBSTF F77_FUNC(zpbstf,ZPBSTF)
/* Subroutine */ int LA_ZPBSTF(char *uplo, integer *n, integer *kd,
  doublecomplex *ab, integer *ldab, integer *info);

#define LA_ZPBSV F77_FUNC(zpbsv,ZPBSV)
/* Subroutine */ int LA_ZPBSV(char *uplo, integer *n, integer *kd, integer *
  nrhs, doublecomplex *ab, integer *ldab, doublecomplex *b, integer *
  ldb, integer *info);

#define LA_ZPBSVX F77_FUNC(zpbsvx,ZPBSVX)
/* Subroutine */ int LA_ZPBSVX(char *fact, char *uplo, integer *n, integer *kd,
  integer *nrhs, doublecomplex *ab, integer *ldab, doublecomplex *afb,
  integer *ldafb, char *equed, doublereal *s, doublecomplex *b, integer
  *ldb, doublecomplex *x, integer *ldx, doublereal *rcond, doublereal *
  ferr, doublereal *berr, doublecomplex *work, doublereal *rwork,
  integer *info);

#define LA_ZPBTF2 F77_FUNC(zpbtf2,ZPBTF2)
/* Subroutine */ int LA_ZPBTF2(char *uplo, integer *n, integer *kd,
  doublecomplex *ab, integer *ldab, integer *info);

#define LA_ZPBTRF F77_FUNC(zpbtrf,ZPBTRF)
/* Subroutine */ int LA_ZPBTRF(char *uplo, integer *n, integer *kd,
  doublecomplex *ab, integer *ldab, integer *info);

#define LA_ZPBTRS F77_FUNC(zpbtrs,ZPBTRS)
/* Subroutine */ int LA_ZPBTRS(char *uplo, integer *n, integer *kd, integer *
  nrhs, doublecomplex *ab, integer *ldab, doublecomplex *b, integer *
  ldb, integer *info);

#define LA_ZPOCON F77_FUNC(zpocon,ZPOCON)
/* Subroutine */ int LA_ZPOCON(char *uplo, integer *n, doublecomplex *a,
  integer *lda, doublereal *anorm, doublereal *rcond, doublecomplex *
  work, doublereal *rwork, integer *info);

#define LA_ZPOEQU F77_FUNC(zpoequ,ZPOEQU)
/* Subroutine */ int LA_ZPOEQU(integer *n, doublecomplex *a, integer *lda,
  doublereal *s, doublereal *scond, doublereal *amax, integer *info);

#define LA_ZPORFS F77_FUNC(zporfs,ZPORFS)
/* Subroutine */ int LA_ZPORFS(char *uplo, integer *n, integer *nrhs,
  doublecomplex *a, integer *lda, doublecomplex *af, integer *ldaf,
  doublecomplex *b, integer *ldb, doublecomplex *x, integer *ldx,
  doublereal *ferr, doublereal *berr, doublecomplex *work, doublereal *
  rwork, integer *info);

#define LA_ZPOSV F77_FUNC(zposv,ZPOSV)
/* Subroutine */ int LA_ZPOSV(char *uplo, integer *n, integer *nrhs,
  doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  integer *info);

#define LA_ZPOSVX F77_FUNC(zposvx,ZPOSVX)
/* Subroutine */ int LA_ZPOSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, doublecomplex *a, integer *lda, doublecomplex *af, integer *
  ldaf, char *equed, doublereal *s, doublecomplex *b, integer *ldb,
  doublecomplex *x, integer *ldx, doublereal *rcond, doublereal *ferr,
  doublereal *berr, doublecomplex *work, doublereal *rwork, integer *
  info);

#define LA_ZPOTF2 F77_FUNC(zpotf2,ZPOTF2)
/* Subroutine */ int LA_ZPOTF2(char *uplo, integer *n, doublecomplex *a,
  integer *lda, integer *info);

#define LA_ZPOTRF F77_FUNC(zpotrf,ZPOTRF)
/* Subroutine */ int LA_ZPOTRF(char *uplo, integer *n, doublecomplex *a,
  integer *lda, integer *info);

#define LA_ZPOTRI F77_FUNC(zpotri,ZPOTRI)
/* Subroutine */ int LA_ZPOTRI(char *uplo, integer *n, doublecomplex *a,
  integer *lda, integer *info);

#define LA_ZPOTRS F77_FUNC(zpotrs,ZPOTRS)
/* Subroutine */ int LA_ZPOTRS(char *uplo, integer *n, integer *nrhs,
  doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  integer *info);

#define LA_ZPPCON F77_FUNC(zppcon,ZPPCON)
/* Subroutine */ int LA_ZPPCON(char *uplo, integer *n, doublecomplex *ap,
  doublereal *anorm, doublereal *rcond, doublecomplex *work, doublereal
  *rwork, integer *info);

#define LA_ZPPEQU F77_FUNC(zppequ,ZPPEQU)
/* Subroutine */ int LA_ZPPEQU(char *uplo, integer *n, doublecomplex *ap,
  doublereal *s, doublereal *scond, doublereal *amax, integer *info);

#define LA_ZPPRFS F77_FUNC(zpprfs,ZPPRFS)
/* Subroutine */ int LA_ZPPRFS(char *uplo, integer *n, integer *nrhs,
  doublecomplex *ap, doublecomplex *afp, doublecomplex *b, integer *ldb,
   doublecomplex *x, integer *ldx, doublereal *ferr, doublereal *berr,
  doublecomplex *work, doublereal *rwork, integer *info);

#define LA_ZPPSV F77_FUNC(zppsv,ZPPSV)
/* Subroutine */ int LA_ZPPSV(char *uplo, integer *n, integer *nrhs,
  doublecomplex *ap, doublecomplex *b, integer *ldb, integer *info);

#define LA_ZPPSVX F77_FUNC(zppsvx,ZPPSVX)
/* Subroutine */ int LA_ZPPSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, doublecomplex *ap, doublecomplex *afp, char *equed, doublereal *
  s, doublecomplex *b, integer *ldb, doublecomplex *x, integer *ldx,
  doublereal *rcond, doublereal *ferr, doublereal *berr, doublecomplex *
  work, doublereal *rwork, integer *info);

#define LA_ZPPTRF F77_FUNC(zpptrf,ZPPTRF)
/* Subroutine */ int LA_ZPPTRF(char *uplo, integer *n, doublecomplex *ap,
  integer *info);

#define LA_ZPPTRI F77_FUNC(zpptri,ZPPTRI)
/* Subroutine */ int LA_ZPPTRI(char *uplo, integer *n, doublecomplex *ap,
  integer *info);

#define LA_ZPPTRS F77_FUNC(zpptrs,ZPPTRS)
/* Subroutine */ int LA_ZPPTRS(char *uplo, integer *n, integer *nrhs,
  doublecomplex *ap, doublecomplex *b, integer *ldb, integer *info);

#define LA_ZPTCON F77_FUNC(zptcon,ZPTCON)
/* Subroutine */ int LA_ZPTCON(integer *n, doublereal *d__, doublecomplex *e,
  doublereal *anorm, doublereal *rcond, doublereal *rwork, integer *
  info);

#define LA_ZPTRFS F77_FUNC(zptrfs,ZPTRFS)
/* Subroutine */ int LA_ZPTRFS(char *uplo, integer *n, integer *nrhs,
  doublereal *d__, doublecomplex *e, doublereal *df, doublecomplex *ef,
  doublecomplex *b, integer *ldb, doublecomplex *x, integer *ldx,
  doublereal *ferr, doublereal *berr, doublecomplex *work, doublereal *
  rwork, integer *info);

#define LA_ZPTSV F77_FUNC(zptsv,ZPTSV)
/* Subroutine */ int LA_ZPTSV(integer *n, integer *nrhs, doublereal *d__,
  doublecomplex *e, doublecomplex *b, integer *ldb, integer *info);

#define LA_ZPTSVX F77_FUNC(zptsvx,ZPTSVX)
/* Subroutine */ int LA_ZPTSVX(char *fact, integer *n, integer *nrhs,
  doublereal *d__, doublecomplex *e, doublereal *df, doublecomplex *ef,
  doublecomplex *b, integer *ldb, doublecomplex *x, integer *ldx,
  doublereal *rcond, doublereal *ferr, doublereal *berr, doublecomplex *
  work, doublereal *rwork, integer *info);

#define LA_ZPTTRF F77_FUNC(zpttrf,ZPTTRF)
/* Subroutine */ int LA_ZPTTRF(integer *n, doublereal *d__, doublecomplex *e,
  integer *info);

#define LA_ZPTTRS F77_FUNC(zpttrs,ZPTTRS)
/* Subroutine */ int LA_ZPTTRS(char *uplo, integer *n, integer *nrhs,
  doublereal *d__, doublecomplex *e, doublecomplex *b, integer *ldb,
  integer *info);

#define LA_ZPTTS2 F77_FUNC(zptts2,ZPTTS2)
/* Subroutine */ int LA_ZPTTS2(integer *iuplo, integer *n, integer *nrhs,
  doublereal *d__, doublecomplex *e, doublecomplex *b, integer *ldb);

#define LA_ZROT F77_FUNC(zrot,ZROT)
/* Subroutine */ int LA_ZROT(integer *n, doublecomplex *cx, integer *incx,
  doublecomplex *cy, integer *incy, doublereal *c__, doublecomplex *s);

#define LA_ZSPCON F77_FUNC(zspcon,ZSPCON)
/* Subroutine */ int LA_ZSPCON(char *uplo, integer *n, doublecomplex *ap,
  integer *ipiv, doublereal *anorm, doublereal *rcond, doublecomplex *
  work, integer *info);

#define LA_ZSPMV F77_FUNC(zspmv,ZSPMV)
/* Subroutine */ int LA_ZSPMV(char *uplo, integer *n, doublecomplex *alpha,
  doublecomplex *ap, doublecomplex *x, integer *incx, doublecomplex *
  beta, doublecomplex *y, integer *incy);

#define LA_ZSPR F77_FUNC(zspr,ZSPR)
/* Subroutine */ int LA_ZSPR(char *uplo, integer *n, doublecomplex *alpha,
  doublecomplex *x, integer *incx, doublecomplex *ap);

#define LA_ZSPRFS F77_FUNC(zsprfs,ZSPRFS)
/* Subroutine */ int LA_ZSPRFS(char *uplo, integer *n, integer *nrhs,
  doublecomplex *ap, doublecomplex *afp, integer *ipiv, doublecomplex *
  b, integer *ldb, doublecomplex *x, integer *ldx, doublereal *ferr,
  doublereal *berr, doublecomplex *work, doublereal *rwork, integer *
  info);

#define LA_ZSPSV F77_FUNC(zspsv,ZSPSV)
/* Subroutine */ int LA_ZSPSV(char *uplo, integer *n, integer *nrhs,
  doublecomplex *ap, integer *ipiv, doublecomplex *b, integer *ldb,
  integer *info);

#define LA_ZSPSVX F77_FUNC(zspsvx,ZSPSVX)
/* Subroutine */ int LA_ZSPSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, doublecomplex *ap, doublecomplex *afp, integer *ipiv,
  doublecomplex *b, integer *ldb, doublecomplex *x, integer *ldx,
  doublereal *rcond, doublereal *ferr, doublereal *berr, doublecomplex *
  work, doublereal *rwork, integer *info);

#define LA_ZSPTRF F77_FUNC(zsptrf,ZSPTRF)
/* Subroutine */ int LA_ZSPTRF(char *uplo, integer *n, doublecomplex *ap,
  integer *ipiv, integer *info);

#define LA_ZSPTRI F77_FUNC(zsptri,ZSPTRI)
/* Subroutine */ int LA_ZSPTRI(char *uplo, integer *n, doublecomplex *ap,
  integer *ipiv, doublecomplex *work, integer *info);

#define LA_ZSPTRS F77_FUNC(zsptrs,ZSPTRS)
/* Subroutine */ int LA_ZSPTRS(char *uplo, integer *n, integer *nrhs,
  doublecomplex *ap, integer *ipiv, doublecomplex *b, integer *ldb,
  integer *info);

#define LA_ZSTEDC F77_FUNC(zstedc,ZSTEDC)
/* Subroutine */ int LA_ZSTEDC(char *compz, integer *n, doublereal *d__,
  doublereal *e, doublecomplex *z__, integer *ldz, doublecomplex *work,
  integer *lwork, doublereal *rwork, integer *lrwork, integer *iwork,
  integer *liwork, integer *info);

#define LA_ZSTEIN F77_FUNC(zstein,ZSTEIN)
/* Subroutine */ int LA_ZSTEIN(integer *n, doublereal *d__, doublereal *e,
  integer *m, doublereal *w, integer *iblock, integer *isplit,
  doublecomplex *z__, integer *ldz, doublereal *work, integer *iwork,
  integer *ifail, integer *info);

#define LA_ZSTEQR F77_FUNC(zsteqr,ZSTEQR)
/* Subroutine */ int LA_ZSTEQR(char *compz, integer *n, doublereal *d__,
  doublereal *e, doublecomplex *z__, integer *ldz, doublereal *work,
  integer *info);

#define LA_ZSYCON F77_FUNC(zsycon,ZSYCON)
/* Subroutine */ int LA_ZSYCON(char *uplo, integer *n, doublecomplex *a,
  integer *lda, integer *ipiv, doublereal *anorm, doublereal *rcond,
  doublecomplex *work, integer *info);

#define LA_ZSYMV F77_FUNC(zsymv,ZSYMV)
/* Subroutine */ int LA_ZSYMV(char *uplo, integer *n, doublecomplex *alpha,
  doublecomplex *a, integer *lda, doublecomplex *x, integer *incx,
  doublecomplex *beta, doublecomplex *y, integer *incy);

#define LA_ZSYR F77_FUNC(zsyr,ZSYR)
/* Subroutine */ int LA_ZSYR(char *uplo, integer *n, doublecomplex *alpha,
  doublecomplex *x, integer *incx, doublecomplex *a, integer *lda);

#define LA_ZSYRFS F77_FUNC(zsyrfs,ZSYRFS)
/* Subroutine */ int LA_ZSYRFS(char *uplo, integer *n, integer *nrhs,
  doublecomplex *a, integer *lda, doublecomplex *af, integer *ldaf,
  integer *ipiv, doublecomplex *b, integer *ldb, doublecomplex *x,
  integer *ldx, doublereal *ferr, doublereal *berr, doublecomplex *work,
   doublereal *rwork, integer *info);

#define LA_ZSYSV F77_FUNC(zsysv,ZSYSV)
/* Subroutine */ int LA_ZSYSV(char *uplo, integer *n, integer *nrhs,
  doublecomplex *a, integer *lda, integer *ipiv, doublecomplex *b,
  integer *ldb, doublecomplex *work, integer *lwork, integer *info);

#define LA_ZSYSVX F77_FUNC(zsysvx,ZSYSVX)
/* Subroutine */ int LA_ZSYSVX(char *fact, char *uplo, integer *n, integer *
  nrhs, doublecomplex *a, integer *lda, doublecomplex *af, integer *
  ldaf, integer *ipiv, doublecomplex *b, integer *ldb, doublecomplex *x,
   integer *ldx, doublereal *rcond, doublereal *ferr, doublereal *berr,
  doublecomplex *work, integer *lwork, doublereal *rwork, integer *info);

#define LA_ZSYTF2 F77_FUNC(zsytf2,ZSYTF2)
/* Subroutine */ int LA_ZSYTF2(char *uplo, integer *n, doublecomplex *a,
  integer *lda, integer *ipiv, integer *info);

#define LA_ZSYTRF F77_FUNC(zsytrf,ZSYTRF)
/* Subroutine */ int LA_ZSYTRF(char *uplo, integer *n, doublecomplex *a,
  integer *lda, integer *ipiv, doublecomplex *work, integer *lwork,
  integer *info);

#define LA_ZSYTRI F77_FUNC(zsytri,ZSYTRI)
/* Subroutine */ int LA_ZSYTRI(char *uplo, integer *n, doublecomplex *a,
  integer *lda, integer *ipiv, doublecomplex *work, integer *info);

#define LA_ZSYTRS F77_FUNC(zsytrs,ZSYTRS)
/* Subroutine */ int LA_ZSYTRS(char *uplo, integer *n, integer *nrhs,
  doublecomplex *a, integer *lda, integer *ipiv, doublecomplex *b,
  integer *ldb, integer *info);

#define LA_ZTBCON F77_FUNC(ztbcon,ZTBCON)
/* Subroutine */ int LA_ZTBCON(char *norm, char *uplo, char *diag, integer *n,
  integer *kd, doublecomplex *ab, integer *ldab, doublereal *rcond,
  doublecomplex *work, doublereal *rwork, integer *info);

#define LA_ZTBRFS F77_FUNC(ztbrfs,ZTBRFS)
/* Subroutine */ int LA_ZTBRFS(char *uplo, char *trans, char *diag, integer *n,
  integer *kd, integer *nrhs, doublecomplex *ab, integer *ldab,
  doublecomplex *b, integer *ldb, doublecomplex *x, integer *ldx,
  doublereal *ferr, doublereal *berr, doublecomplex *work, doublereal *
  rwork, integer *info);

#define LA_ZTBTRS F77_FUNC(ztbtrs,ZTBTRS)
/* Subroutine */ int LA_ZTBTRS(char *uplo, char *trans, char *diag, integer *n,
  integer *kd, integer *nrhs, doublecomplex *ab, integer *ldab,
  doublecomplex *b, integer *ldb, integer *info);

#define LA_ZTGEVC F77_FUNC(ztgevc,ZTGEVC)
/* Subroutine */ int LA_ZTGEVC(char *side, char *howmny, logical *select,
  integer *n, doublecomplex *a, integer *lda, doublecomplex *b, integer
  *ldb, doublecomplex *vl, integer *ldvl, doublecomplex *vr, integer *
  ldvr, integer *mm, integer *m, doublecomplex *work, doublereal *rwork,
   integer *info);

#define LA_ZTGEX2 F77_FUNC(ztgex2,ZTGEX2)
/* Subroutine */ int LA_ZTGEX2(logical *wantq, logical *wantz, integer *n,
  doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  doublecomplex *q, integer *ldq, doublecomplex *z__, integer *ldz,
  integer *j1, integer *info);

#define LA_ZTGEXC F77_FUNC(ztgexc,ZTGEXC)
/* Subroutine */ int LA_ZTGEXC(logical *wantq, logical *wantz, integer *n,
  doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  doublecomplex *q, integer *ldq, doublecomplex *z__, integer *ldz,
  integer *ifst, integer *ilst, integer *info);

#define LA_ZTGSEN F77_FUNC(ztgsen,ZTGSEN)
/* Subroutine */ int LA_ZTGSEN(integer *ijob, logical *wantq, logical *wantz,
  logical *select, integer *n, doublecomplex *a, integer *lda,
  doublecomplex *b, integer *ldb, doublecomplex *alpha, doublecomplex *
  beta, doublecomplex *q, integer *ldq, doublecomplex *z__, integer *
  ldz, integer *m, doublereal *pl, doublereal *pr, doublereal *dif,
  doublecomplex *work, integer *lwork, integer *iwork, integer *liwork,
  integer *info);

#define LA_ZTGSJA F77_FUNC(ztgsja,ZTGSJA)
/* Subroutine */ int LA_ZTGSJA(char *jobu, char *jobv, char *jobq, integer *m,
  integer *p, integer *n, integer *k, integer *l, doublecomplex *a,
  integer *lda, doublecomplex *b, integer *ldb, doublereal *tola,
  doublereal *tolb, doublereal *alpha, doublereal *beta, doublecomplex *
  u, integer *ldu, doublecomplex *v, integer *ldv, doublecomplex *q,
  integer *ldq, doublecomplex *work, integer *ncycle, integer *info);

#define LA_ZTGSNA F77_FUNC(ztgsna,ZTGSNA)
/* Subroutine */ int LA_ZTGSNA(char *job, char *howmny, logical *select,
  integer *n, doublecomplex *a, integer *lda, doublecomplex *b, integer
  *ldb, doublecomplex *vl, integer *ldvl, doublecomplex *vr, integer *
  ldvr, doublereal *s, doublereal *dif, integer *mm, integer *m,
  doublecomplex *work, integer *lwork, integer *iwork, integer *info);

#define LA_ZTGSY2 F77_FUNC(ztgsy2,ZTGSY2)
/* Subroutine */ int LA_ZTGSY2(char *trans, integer *ijob, integer *m, integer *
  n, doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  doublecomplex *c__, integer *ldc, doublecomplex *d__, integer *ldd,
  doublecomplex *e, integer *lde, doublecomplex *f, integer *ldf,
  doublereal *scale, doublereal *rdsum, doublereal *rdscal, integer *
  info);

#define LA_ZTGSYL F77_FUNC(ztgsyl,ZTGSYL)
/* Subroutine */ int LA_ZTGSYL(char *trans, integer *ijob, integer *m, integer *
  n, doublecomplex *a, integer *lda, doublecomplex *b, integer *ldb,
  doublecomplex *c__, integer *ldc, doublecomplex *d__, integer *ldd,
  doublecomplex *e, integer *lde, doublecomplex *f, integer *ldf,
  doublereal *scale, doublereal *dif, doublecomplex *work, integer *
  lwork, integer *iwork, integer *info);

#define LA_ZTPCON F77_FUNC(ztpcon,ZTPCON)
/* Subroutine */ int LA_ZTPCON(char *norm, char *uplo, char *diag, integer *n,
  doublecomplex *ap, doublereal *rcond, doublecomplex *work, doublereal
  *rwork, integer *info);

#define LA_ZTPRFS F77_FUNC(ztprfs,ZTPRFS)
/* Subroutine */ int LA_ZTPRFS(char *uplo, char *trans, char *diag, integer *n,
  integer *nrhs, doublecomplex *ap, doublecomplex *b, integer *ldb,
  doublecomplex *x, integer *ldx, doublereal *ferr, doublereal *berr,
  doublecomplex *work, doublereal *rwork, integer *info);

#define LA_ZTPTRI F77_FUNC(ztptri,ZTPTRI)
/* Subroutine */ int LA_ZTPTRI(char *uplo, char *diag, integer *n,
  doublecomplex *ap, integer *info);

#define LA_ZTPTRS F77_FUNC(ztptrs,ZTPTRS)
/* Subroutine */ int LA_ZTPTRS(char *uplo, char *trans, char *diag, integer *n,
  integer *nrhs, doublecomplex *ap, doublecomplex *b, integer *ldb,
  integer *info);

#define LA_ZTRCON F77_FUNC(ztrcon,ZTRCON)
/* Subroutine */ int LA_ZTRCON(char *norm, char *uplo, char *diag, integer *n,
  doublecomplex *a, integer *lda, doublereal *rcond, doublecomplex *
  work, doublereal *rwork, integer *info);

#define LA_ZTREVC F77_FUNC(ztrevc,ZTREVC)
/* Subroutine */ int LA_ZTREVC(char *side, char *howmny, logical *select,
  integer *n, doublecomplex *t, integer *ldt, doublecomplex *vl,
  integer *ldvl, doublecomplex *vr, integer *ldvr, integer *mm, integer
  *m, doublecomplex *work, doublereal *rwork, integer *info);

#define LA_ZTREXC F77_FUNC(ztrexc,ZTREXC)
/* Subroutine */ int LA_ZTREXC(char *compq, integer *n, doublecomplex *t,
  integer *ldt, doublecomplex *q, integer *ldq, integer *ifst, integer *
  ilst, integer *info);

#define LA_ZTRRFS F77_FUNC(ztrrfs,ZTRRFS)
/* Subroutine */ int LA_ZTRRFS(char *uplo, char *trans, char *diag, integer *n,
  integer *nrhs, doublecomplex *a, integer *lda, doublecomplex *b,
  integer *ldb, doublecomplex *x, integer *ldx, doublereal *ferr,
  doublereal *berr, doublecomplex *work, doublereal *rwork, integer *
  info);

#define LA_ZTRSEN F77_FUNC(ztrsen,ZTRSEN)
/* Subroutine */ int LA_ZTRSEN(char *job, char *compq, logical *select, integer
  *n, doublecomplex *t, integer *ldt, doublecomplex *q, integer *ldq,
  doublecomplex *w, integer *m, doublereal *s, doublereal *sep,
  doublecomplex *work, integer *lwork, integer *info);

#define LA_ZTRSNA F77_FUNC(ztrsna,ZTRSNA)
/* Subroutine */ int LA_ZTRSNA(char *job, char *howmny, logical *select,
  integer *n, doublecomplex *t, integer *ldt, doublecomplex *vl,
  integer *ldvl, doublecomplex *vr, integer *ldvr, doublereal *s,
  doublereal *sep, integer *mm, integer *m, doublecomplex *work,
  integer *ldwork, doublereal *rwork, integer *info);

#define LA_ZTRSYL F77_FUNC(ztrsyl,ZTRSYL)
/* Subroutine */ int LA_ZTRSYL(char *trana, char *tranb, integer *isgn, integer
  *m, integer *n, doublecomplex *a, integer *lda, doublecomplex *b,
  integer *ldb, doublecomplex *c__, integer *ldc, doublereal *scale,
  integer *info);

#define LA_ZTRTI2 F77_FUNC(ztrti2,ZTRTI2)
/* Subroutine */ int LA_ZTRTI2(char *uplo, char *diag, integer *n,
  doublecomplex *a, integer *lda, integer *info);

#define LA_ZTRTRI F77_FUNC(ztrtri,ZTRTRI)
/* Subroutine */ int LA_ZTRTRI(char *uplo, char *diag, integer *n,
  doublecomplex *a, integer *lda, integer *info);

#define LA_ZTRTRS F77_FUNC(ztrtrs,ZTRTRS)
/* Subroutine */ int LA_ZTRTRS(char *uplo, char *trans, char *diag, integer *n,
  integer *nrhs, doublecomplex *a, integer *lda, doublecomplex *b,
  integer *ldb, integer *info);

#define LA_ZTZRQF F77_FUNC(ztzrqf,ZTZRQF)
/* Subroutine */ int LA_ZTZRQF(integer *m, integer *n, doublecomplex *a,
  integer *lda, doublecomplex *tau, integer *info);

#define LA_ZTZRZF F77_FUNC(ztzrzf,ZTZRZF)
/* Subroutine */ int LA_ZTZRZF(integer *m, integer *n, doublecomplex *a,
  integer *lda, doublecomplex *tau, doublecomplex *work, integer *lwork,
   integer *info);

#define LA_ZUNG2L F77_FUNC(zung2l,ZUNG2L)
/* Subroutine */ int LA_ZUNG2L(integer *m, integer *n, integer *k,
  doublecomplex *a, integer *lda, doublecomplex *tau, doublecomplex *
  work, integer *info);

#define LA_ZUNG2R F77_FUNC(zung2r,ZUNG2R)
/* Subroutine */ int LA_ZUNG2R(integer *m, integer *n, integer *k,
  doublecomplex *a, integer *lda, doublecomplex *tau, doublecomplex *
  work, integer *info);

#define LA_ZUNGBR F77_FUNC(zungbr,ZUNGBR)
/* Subroutine */ int LA_ZUNGBR(char *vect, integer *m, integer *n, integer *k,
  doublecomplex *a, integer *lda, doublecomplex *tau, doublecomplex *
  work, integer *lwork, integer *info);

#define LA_ZUNGHR F77_FUNC(zunghr,ZUNGHR)
/* Subroutine */ int LA_ZUNGHR(integer *n, integer *ilo, integer *ihi,
  doublecomplex *a, integer *lda, doublecomplex *tau, doublecomplex *
  work, integer *lwork, integer *info);

#define LA_ZUNGL2 F77_FUNC(zungl2,ZUNGL2)
/* Subroutine */ int LA_ZUNGL2(integer *m, integer *n, integer *k,
  doublecomplex *a, integer *lda, doublecomplex *tau, doublecomplex *
  work, integer *info);

#define LA_ZUNGLQ F77_FUNC(zunglq,ZUNGLQ)
/* Subroutine */ int LA_ZUNGLQ(integer *m, integer *n, integer *k,
  doublecomplex *a, integer *lda, doublecomplex *tau, doublecomplex *
  work, integer *lwork, integer *info);

#define LA_ZUNGQL F77_FUNC(zungql,ZUNGQL)
/* Subroutine */ int LA_ZUNGQL(integer *m, integer *n, integer *k,
  doublecomplex *a, integer *lda, doublecomplex *tau, doublecomplex *
  work, integer *lwork, integer *info);

#define LA_ZUNGQR F77_FUNC(zungqr,ZUNGQR)
/* Subroutine */ int LA_ZUNGQR(integer *m, integer *n, integer *k,
  doublecomplex *a, integer *lda, doublecomplex *tau, doublecomplex *
  work, integer *lwork, integer *info);

#define LA_ZUNGR2 F77_FUNC(zungr2,ZUNGR2)
/* Subroutine */ int LA_ZUNGR2(integer *m, integer *n, integer *k,
  doublecomplex *a, integer *lda, doublecomplex *tau, doublecomplex *
  work, integer *info);

#define LA_ZUNGRQ F77_FUNC(zungrq,ZUNGRQ)
/* Subroutine */ int LA_ZUNGRQ(integer *m, integer *n, integer *k,
  doublecomplex *a, integer *lda, doublecomplex *tau, doublecomplex *
  work, integer *lwork, integer *info);

#define LA_ZUNGTR F77_FUNC(zungtr,ZUNGTR)
/* Subroutine */ int LA_ZUNGTR(char *uplo, integer *n, doublecomplex *a,
  integer *lda, doublecomplex *tau, doublecomplex *work, integer *lwork,
   integer *info);

#define LA_ZUNM2L F77_FUNC(zunm2l,ZUNM2L)
/* Subroutine */ int LA_ZUNM2L(char *side, char *trans, integer *m, integer *n,
  integer *k, doublecomplex *a, integer *lda, doublecomplex *tau,
  doublecomplex *c__, integer *ldc, doublecomplex *work, integer *info);

#define LA_ZUNM2R F77_FUNC(zunm2r,ZUNM2R)
/* Subroutine */ int LA_ZUNM2R(char *side, char *trans, integer *m, integer *n,
  integer *k, doublecomplex *a, integer *lda, doublecomplex *tau,
  doublecomplex *c__, integer *ldc, doublecomplex *work, integer *info);

#define LA_ZUNMBR F77_FUNC(zunmbr,ZUNMBR)
/* Subroutine */ int LA_ZUNMBR(char *vect, char *side, char *trans, integer *m,
  integer *n, integer *k, doublecomplex *a, integer *lda, doublecomplex
  *tau, doublecomplex *c__, integer *ldc, doublecomplex *work, integer *
  lwork, integer *info);

#define LA_ZUNMHR F77_FUNC(zunmhr,ZUNMHR)
/* Subroutine */ int LA_ZUNMHR(char *side, char *trans, integer *m, integer *n,
  integer *ilo, integer *ihi, doublecomplex *a, integer *lda,
  doublecomplex *tau, doublecomplex *c__, integer *ldc, doublecomplex *
  work, integer *lwork, integer *info);

#define LA_ZUNML2 F77_FUNC(zunml2,ZUNML2)
/* Subroutine */ int LA_ZUNML2(char *side, char *trans, integer *m, integer *n,
  integer *k, doublecomplex *a, integer *lda, doublecomplex *tau,
  doublecomplex *c__, integer *ldc, doublecomplex *work, integer *info);

#define LA_ZUNMLQ F77_FUNC(zunmlq,ZUNMLQ)
/* Subroutine */ int LA_ZUNMLQ(char *side, char *trans, integer *m, integer *n,
  integer *k, doublecomplex *a, integer *lda, doublecomplex *tau,
  doublecomplex *c__, integer *ldc, doublecomplex *work, integer *lwork,
   integer *info);

#define LA_ZUNMQL F77_FUNC(zunmql,ZUNMQL)
/* Subroutine */ int LA_ZUNMQL(char *side, char *trans, integer *m, integer *n,
  integer *k, doublecomplex *a, integer *lda, doublecomplex *tau,
  doublecomplex *c__, integer *ldc, doublecomplex *work, integer *lwork,
   integer *info);

#define LA_ZUNMQR F77_FUNC(zunmqr,ZUNMQR)
/* Subroutine */ int LA_ZUNMQR(char *side, char *trans, integer *m, integer *n,
  integer *k, doublecomplex *a, integer *lda, doublecomplex *tau,
  doublecomplex *c__, integer *ldc, doublecomplex *work, integer *lwork,
   integer *info);

#define LA_ZUNMR2 F77_FUNC(zunmr2,ZUNMR2)
/* Subroutine */ int LA_ZUNMR2(char *side, char *trans, integer *m, integer *n,
  integer *k, doublecomplex *a, integer *lda, doublecomplex *tau,
  doublecomplex *c__, integer *ldc, doublecomplex *work, integer *info);

#define LA_ZUNMR3 F77_FUNC(zunmr3,ZUNMR3)
/* Subroutine */ int LA_ZUNMR3(char *side, char *trans, integer *m, integer *n,
  integer *k, integer *l, doublecomplex *a, integer *lda, doublecomplex
  *tau, doublecomplex *c__, integer *ldc, doublecomplex *work, integer *
  info);

#define LA_ZUNMRQ F77_FUNC(zunmrq,ZUNMRQ)
/* Subroutine */ int LA_ZUNMRQ(char *side, char *trans, integer *m, integer *n,
  integer *k, doublecomplex *a, integer *lda, doublecomplex *tau,
  doublecomplex *c__, integer *ldc, doublecomplex *work, integer *lwork,
   integer *info);

#define LA_ZUNMRZ F77_FUNC(zunmrz,ZUNMRZ)
/* Subroutine */ int LA_ZUNMRZ(char *side, char *trans, integer *m, integer *n,
  integer *k, integer *l, doublecomplex *a, integer *lda, doublecomplex
  *tau, doublecomplex *c__, integer *ldc, doublecomplex *work, integer *
  lwork, integer *info);

#define LA_ZUNMTR F77_FUNC(zunmtr,ZUNMTR)
/* Subroutine */ int LA_ZUNMTR(char *side, char *uplo, char *trans, integer *m,
  integer *n, doublecomplex *a, integer *lda, doublecomplex *tau,
  doublecomplex *c__, integer *ldc, doublecomplex *work, integer *lwork,
   integer *info);

#define LA_ZUPGTR F77_FUNC(zupgtr,ZUPGTR)
/* Subroutine */ int LA_ZUPGTR(char *uplo, integer *n, doublecomplex *ap,
  doublecomplex *tau, doublecomplex *q, integer *ldq, doublecomplex *
  work, integer *info);

#define LA_ZUPMTR F77_FUNC(zupmtr,ZUPMTR)
/* Subroutine */ int LA_ZUPMTR(char *side, char *uplo, char *trans, integer *m,
  integer *n, doublecomplex *ap, doublecomplex *tau, doublecomplex *c__,
   integer *ldc, doublecomplex *work, integer *info);

}

#endif /* HAVE_LAPACK */
#endif /* __CLAPACK_H */

